Package: LSD
Version: 4.1-0
Date: 2020-06-16
Title: Lots of Superior Depictions
Author: Bjoern Schwalb [aut, cre],
	Achim Tresch [aut],
	Phillipp Torkler [ctb],
	Sebastian Duemcke [ctb],
	Carina Demel [ctb],
	Brian Ripley [ctb],
	Bill Venables [ctb]
Maintainer: Bjoern Schwalb <schwalb.bjoern@gmail.com>
Description: Create lots of colorful plots in a plethora of variations. Try the LSD demotour().
License: GPL-2 | GPL-3
LazyData: true
RoxygenNote: 7.1.0
NeedsCompilation: no
Packaged: 2020-06-17 09:20:26 UTC; bschwal
Repository: CRAN
Date/Publication: 2020-06-17 09:50:18 UTC

<div align="center">

<p>
  <sup>
    <a href="https://github.com/sponsors/zwpaper">LSD is supported by the community.</a>
  </sup>
</p>
<sup>Special thanks to:</sup>
<br>
<br>
<a href="https://www.warp.dev/?utm_source=github&utm_medium=referral&utm_campaign=lsd_20231001">
<div>
  <picture>
    <source media="(prefers-color-scheme: dark)" srcset="https://github.com/lsd-rs/lsd/assets/3764335/61c7471f-ade1-42ea-9829-ac381c92b28a">
    <source media="(prefers-color-scheme: light)" srcset="https://github.com/lsd-rs/lsd/assets/3764335/40e5d173-603c-45c8-90fa-50ba6c48a813">
    <img alt="Warp" width="230" src="https://github.com/lsd-rs/lsd/assets/3764335/40e5d173-603c-45c8-90fa-50ba6c48a813">
  </picture>
</div>
  <b>Warp is a blazingly fast, Rust-based terminal reimagined to work like a modern app.</b>
  <div>
    <sup>Get more done in the CLI with real text editing, block-based output, and AI command search.</sup>
  </div>
</a>
<hr>
</div>

**IMPORTANT**: This is the development documents,
please check the docs in [Tags](https://github.com/lsd-rs/lsd/tags) if you installed from the released ones.

The current newest release is: [v1.1.3](https://github.com/lsd-rs/lsd/tree/v1.1.3)

---

# LSD (LSDeluxe)

[![license](http://img.shields.io/badge/license-Apache%20v2-blue.svg)](https://raw.githubusercontent.com/lsd-rs/lsd/master/LICENSE)
[![Latest version](https://img.shields.io/crates/v/lsd.svg)](https://crates.io/crates/lsd)
[![build](https://github.com/lsd-rs/lsd/workflows/CICD/badge.svg)](https://github.com/lsd-rs/lsd/actions)
[![codecov](https://codecov.io/gh/lsd-rs/lsd/branch/master/graph/badge.svg)](https://codecov.io/gh/lsd-rs/lsd)
[![versions](https://img.shields.io/repology/repositories/lsd)](https://repology.org/project/lsd/versions)

![image](https://raw.githubusercontent.com/lsd-rs/lsd/assets/screen_lsd.png)

This project is a rewrite of GNU `ls` with lots of added features like colors, icons, tree-view, more formatting options etc.
The project is heavily inspired by the super [colorls](https://github.com/athityakumar/colorls) project.


## Installation

<details>
<summary>Packaging status</summary>
<a href="https://repology.org/project/lsd/versions">
    <img src="https://repology.org/badge/vertical-allrepos/lsd.svg?columns=3" alt="Packaging status">
</a>
</details>

### Prerequisites

Install the patched fonts of powerline nerd-font and/or font-awesome. Have a look at the [Nerd Font README](https://github.com/ryanoasis/nerd-fonts/blob/master/readme.md) for more installation instructions. Don't forget to setup your terminal in order to use the correct font.

| OS/Distro                       | Command                                                              |
| ------------------------------- | -------------------------------------------------------------------------------|
| Archlinux                       | `pacman -S lsd`                                                                |
| Fedora                          | `dnf install lsd`                                                              |
| Gentoo                          | `sudo emerge sys-apps/lsd`                                                     |
| macOS                           | `brew install lsd` or `sudo port install lsd`                                  |
| NixOS                           | `nix-env -iA nixos.lsd`                                                        |
| FreeBSD                         | `pkg install lsd`                                                              |
| NetBSD or any `pkgsrc` platform | `pkgin install lsd` or `cd /usr/pkgsrc/sysutils/lsd && make install`           |
| OpenBSD                         | `pkg_add lsd`                                                                  |
| Windows                         | `scoop install lsd` or `winget install --id lsd-rs.lsd` or `choco install lsd` |
| Android (via Termux)            | `pkg install lsd`                                                              |
| Debian sid and bookworm         | `apt install lsd`                                                              |
| Ubuntu 23.04 (Lunar Lobster)    | `apt install lsd`                                                              |
| Earlier Ubuntu/Debian versions  | **snap discontinued**, use [From Binaries](#from-binaries)                     |
| Solus                           | `eopkg it lsd`                                                                 |
| Void Linux                      | `sudo xbps-install lsd`                                                        |
| openSUSE                        | `sudo zypper install lsd`                                                      |

### From source

With Rust's package manager cargo, you can install lsd via:

```sh
cargo install lsd
```

If you want to install the latest master branch commit:

```sh
cargo install --git https://github.com/lsd-rs/lsd.git --branch master
```

### From Binaries

The [release page](https://github.com/lsd-rs/lsd/releases) includes precompiled binaries for Linux, macOS and Windows for every release. You can also get the latest binary of `master` branch from the [GitHub action build artifacts](https://github.com/lsd-rs/lsd/actions?query=branch%3Amaster+is%3Asuccess+event%3Apush) (choose the top action and scroll down to the artifacts section).

## Configuration

`lsd` can be configured with a configuration file to set the default options.
Check [Config file content](#config-file-content) for details.

### Config file location

### Non-Windows

On non-Windows systems `lsd` follows the
[XDG Base Directory Specification](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html)
convention for the location of the configuration file. A `config.yaml` or `config.yml` file will be searched for in these locations, in order:

- `$HOME/.config/lsd`
- `$XDG_CONFIG_HOME/lsd`

On most systems these are mapped to the same location, which is `~/.config/lsd/config.yaml`.

### Windows

On Windows systems `lsd` searches for `config.yaml` or `config.yml` in the following locations, in order:

- `%USERPROFILE%\.config\lsd`
- `%APPDATA%\lsd`

These are usually something like `C:\Users\username\AppData\Roaming\lsd\config.yaml` and `C:\Users\username\.config\lsd\config.yaml` respectively.

### Custom

You can also provide a configuration file from a non-standard location:
`lsd --config-file [PATH]`

### Config file content

<details open>
<summary>This is an example config file with the default values and some additional remarks.</summary>

```yaml
# == Classic ==
# This is a shorthand to override some of the options to be backwards compatible
# with `ls`. It affects the "color"->"when", "sorting"->"dir-grouping", "date"
# and "icons"->"when" options.
# Possible values: false, true
classic: false

# == Blocks ==
# This specifies the columns and their order when using the long and the tree
# layout.
# Possible values: permission, user, group, context, size, date, name, inode, links, git
blocks:
  - permission
  - user
  - group
  - size
  - date
  - name

# == Color ==
# This has various color options. (Will be expanded in the future.)
color:
  # When to colorize the output.
  # When "classic" is set, this is set to "never".
  # Possible values: never, auto, always
  when: auto
  # How to colorize the output.
  # When "classic" is set, this is set to "no-color".
  # Possible values: default, custom
  # When "custom" is set, lsd will look in the config directory for `colors.yaml`.
  theme: default

# == Date ==
# This specifies the date format for the date column. The freeform format
# accepts a strftime like string.
# When "classic" is set, this is set to "date".
# Possible values: date, locale, relative, '+<date_format>'
# `date_format` will be a `strftime` formatted value. e.g. `date: '+%d %b %y %X'` will give you a date like this: 17 Jun 21 20:14:55
date: date

# == Dereference ==
# Whether to dereference symbolic links.
# Possible values: false, true
dereference: false

# == Display ==
# What items to display. Do not specify this for the default behavior.
# Possible values: all, almost-all, directory-only
# display: all

# == Icons ==
icons:
  # When to use icons.
  # When "classic" is set, this is set to "never".
  # Possible values: always, auto, never
  when: auto
  # Which icon theme to use.
  # Possible values: fancy, unicode
  theme: fancy
  # Separator between icon and the name
  # Default to 1 space
  separator: " "

# == Ignore Globs ==
# A list of globs to ignore when listing.
# ignore-globs:
#   - .git

# == Indicators ==
# Whether to add indicator characters to certain listed files.
# Possible values: false, true
indicators: false

# == Layout ==
# Which layout to use. "oneline" might be a bit confusing here and should be
# called "one-per-line". It might be changed in the future.
# Possible values: grid, tree, oneline
layout: grid

# == Recursion ==
recursion:
  # Whether to enable recursion.
  # Possible values: false, true
  enabled: false
  # How deep the recursion should go. This has to be a positive integer. Leave
  # it unspecified for (virtually) infinite.
  # depth: 3

# == Size ==
# Specifies the format of the size column.
# Possible values: default, short, bytes
size: default

# == Permission ==
# Specify the format of the permission column
# Possible value: rwx, octal, attributes (windows only), disable
# permission: rwx

# == Sorting ==
sorting:
  # Specify what to sort by.
  # Possible values: extension, name, time, size, version
  column: name
  # Whether to reverse the sorting.
  # Possible values: false, true
  reverse: false
  # Whether to group directories together and where.
  # When "classic" is set, this is set to "none".
  # Possible values: first, last, none
  dir-grouping: none

# == No Symlink ==
# Whether to omit showing symlink targets
# Possible values: false, true
no-symlink: false

# == Total size ==
# Whether to display the total size of directories.
# Possible values: false, true
total-size: false

# == Hyperlink ==
# Attach hyperlink to filenames
# Possible values: always, auto, never
hyperlink: never

# == Symlink arrow ==
# Specifies how the symlink arrow display, chars in both ascii and utf8
symlink-arrow: ⇒

# == Header ==
# Whether to display block headers.
# Possible values: false, true
header: false

# == Literal ==
# Whether to show quotes on filenames.
# Possible values: false, true
literal: false

# == Truncate owner ==
# How to truncate the username and group names for a file if they exceed a certain
# number of characters.
truncate-owner:
  # Number of characters to keep. By default, no truncation is done (empty value).
  after:
  # String to be appended to a name if truncated.
  marker: ""
```

</details>

## Theme

`lsd` can be configured with theme files to set the colors or icons.

### Color Theme

Color theme can be configured in the [configuration file](#configuration)(color.theme).
The valid theme configurations are:

- `default`: the default color scheme shipped in `lsd`
- `custom`: use a custom color scheme defined in `colors.yaml`
- *(deprecated) theme_file_name(yaml): use the theme file to specify colors (without the `yaml` extension)*

When set to `custom`, `lsd` will look for `colors.yaml` in the
XDG Base Directory, e.g. ~/.config/lsd/colors.yaml

When configured with the `theme-file-name` which is a `yaml` file,
`lsd` will look up the theme file in the following way:

- relative name: check the XDG Base Directory, e.g. ~/.config/lsd/themes/<theme-file-name>.yaml
- absolute name: use the file path and name to find theme file

Check [Color Theme file content](#color-theme-file-content) for details.

#### Color Theme file content

Theme file use the [crossterm](https://crates.io/crates/crossterm)
to configure the colors, check [crossterm](https://docs.rs/crossterm/0.20.0/crossterm/style/enum.Color.html)
for supported colors.

Color table: https://upload.wikimedia.org/wikipedia/commons/1/15/Xterm_256color_chart.svg

Please notice that color values would ignore the case, both lowercase and UPPERCASE is supported.

This is the default theme scheme shipped with `lsd`.

```yaml
user: 230
group: 187
permission:
  read: dark_green
  write: dark_yellow
  exec: dark_red
  exec-sticky: 5
  no-access: 245
  octal: 6
  acl: dark_cyan
  context: cyan
date:
  hour-old: 40
  day-old: 42
  older: 36
size:
  none: 245
  small: 229
  medium: 216
  large: 172
inode:
  valid: 13
  invalid: 245
links:
  valid: 13
  invalid: 245
tree-edge: 245
git-status:
  default: 245
  unmodified: 245
  ignored: 245
  new-in-index: dark_green
  new-in-workdir: dark_green
  typechange: dark_yellow
  deleted: dark_red
  renamed: dark_green
  modified: dark_yellow
  conflicted: dark_red
```

When creating a theme for `lsd`, you can specify any part of the default theme,
and then change its colors, the items missed would fall back to use the default colors.

### Icon Theme

Icon theme can be configured in a fixed location, `$XDG_CONFIG_DIR/lsd/icons.yaml`,
for example, `~/.config/lsd/icons.yaml` on macOS,
please check [Config file location](#config-file-location) to make sure where is `$XDG_CONFIG_DIR`.

As the file name indicated, the icon theme file is a `yaml` file.

Check [Icon Theme file content](#icon-theme-file-content) for details.

#### Icon Theme file content

`lsd` support 3 kinds of icon overrides, by `name`, by `filetype` and by `extension`.
The final set of icons used will be a combination of what is shipped with in `lsd` with overrides from config applied on top of it.
*You can find the default set of icons [here](src/theme/icon.rs).*

Both nerd font glyphs and Unicode emojis can be used for icons. You can find an example of icons customization below.

```yaml
name:
  .trash: 
  .cargo: 
  .emacs.d: 
  a.out: 
extension:
  go: 
  hs: 
  rs: 🦀
filetype:
  dir: 📂
  file: 📄
  pipe: 📩
  socket: 󰆨
  executable: 
  symlink-dir: 
  symlink-file: 
  device-char: 
  device-block: 󰜫
  special: 
```

## External Configurations

### Required

Enable nerd fonts for your terminal, URxvt for example in `.Xresources`:

```sh
URxvt*font:    xft:Hack Nerd Font:style=Regular:size=11
```

### Optional

In order to use lsd when entering the `ls` command, you need to add this to your shell
configuration file (~/.bashrc, ~/.zshrc, etc.):

```sh
alias ls='lsd'
```

Some further examples of useful aliases:

```sh
alias l='ls -l'
alias la='ls -a'
alias lla='ls -la'
alias lt='ls --tree'
```

## F.A.Q

### Uses unknown compression for member 'control.tar.zst' when using deb

Zst compression is supported starting from `Debian 12` and `Ubuntu 21.10`,
Please use the `_xz.deb` released starting from `lsd v1.1.0`.

Please check https://github.com/lsd-rs/lsd/issues/891 for details or manual fixes.

### Custom Color Schemes for Windows
For `lsd` currently, it reads a system environment variable called LS_COLORS. Please look at the marked solution in [this post](https://github.com/orgs/lsd-rs/discussions/958#discussioncomment-7659375), which contains a guide on how to set a color scheme.

### Icons not showing up

For `lsd` to be able to display icons, the font has to include special font glyphs. This might not be the case for most fonts that you download. Thankfully, you can patch most fonts using [NerdFont](https://www.nerdfonts.com/) and add these icons. Or you can just download an already patched version of your favorite font from [NerdFont font download page](https://www.nerdfonts.com/font-downloads).
Here is a guide on how to set up fonts on [macOS](https://github.com/lsd-rs/lsd/issues/199#issuecomment-494218334) and [Android](https://github.com/lsd-rs/lsd/issues/423).

To check if the font you are using is set up correctly, try running the following snippet in a shell and see if that [prints a folder icon](https://github.com/lsd-rs/lsd/issues/510#issuecomment-860000306). If it prints a box, or question mark or something else, then you might have some issues in how you set up the font or how your terminal emulator renders the font.

```sh
echo $'\uf115'
```

### Icons missing or not rendering correctly using PuTTY/KiTTY on Windows

First of all, make sure a patched font is installed and PuTTY/KiTTY is configured to use it, please check [Prerequisites](#prerequisites).

There are problems for PuTTY/KiTTY to show 2 char wide icons, make sure using a 1 char wide font like [Hack Regular Nerd Font Complete Mono Windows Compatible](https://github.com/ryanoasis/nerd-fonts/blob/master/patched-fonts/Hack/Regular/complete/Hack%20Regular%20Nerd%20Font%20Complete%20Mono%20Windows%20Compatible.ttf), check [this issue](https://github.com/lsd-rs/lsd/issues/331) for detail.

### Colors

You can customize filetype colors using `LS_COLORS` and other colors using the theme.

The default colors are:

| User/Group                                                            | Permission                                                                             | File Type (changes based on your terminal colorscheme)                                                  | Date                                                                                 | File Size                                                                   |
| :-------------------------------------------------------------------- | :------------------------------------------------------------------------------------- | :------------------------------------------------------------------------------------------------------ | :----------------------------------------------------------------------------------- | :-------------------------------------------------------------------------- |
| ![#ffffd7](https://via.placeholder.com/15/ffffd7/000000?text=+) User  | ![#00d700](https://via.placeholder.com/15/00d700/000000?text=+) Read                   | ![#0087ff](https://via.placeholder.com/15/0087ff/000000?text=+) Directory                               | ![#00d700](https://via.placeholder.com/15/00d700/000000?text=+) within the last hour | ![#ffffaf](https://via.placeholder.com/15/ffffaf/000000?text=+) Small File  |
| ![#d7d7af](https://via.placeholder.com/15/d7d7af/000000?text=+) Group | ![#d7ff87](https://via.placeholder.com/15/d7ff87/000000?text=+) Write                  | ![#00d700](https://via.placeholder.com/15/00d700/000000?text=+) Executable File                         | ![#00d787](https://via.placeholder.com/15/00d787/000000?text=+) within the last day  | ![#ffaf87](https://via.placeholder.com/15/ffaf87/000000?text=+) Medium File |
|                                                                       | ![#af0000](https://via.placeholder.com/15/af0000/000000?text=+) Execute                | ![#ffffff](https://via.placeholder.com/15/ffffff/000000?text=+) Non-Executable File                     | ![#00af87](https://via.placeholder.com/15/00af87/000000?text=+) older                | ![#d78700](https://via.placeholder.com/15/d78700/000000?text=+) Large File  |
|                                                                       | ![#ff00ff](https://via.placeholder.com/15/ff00ff/000000?text=+) Execute with Stickybit | ![#af0000](https://via.placeholder.com/15/af0000/000000?text=+) Broken Symlink                          |                                                                                      | ![#ffffff](https://via.placeholder.com/15/ffffff/000000?text=+) Non File    |
|                                                                       | ![#d75f87](https://via.placeholder.com/15/d75f87/000000?text=+) No Access              | ![#00d7d7](https://via.placeholder.com/15/00d7d7/000000?text=+) Pipe/Symlink/Blockdevice/Socket/Special |                                                                                      |                                                                             |
|                                                                       |                                                                                        | ![#d78700](https://via.placeholder.com/15/d78700/000000?text=+) CharDevice                              |                                                                                      |                                                                             |

_Checkout [trapd00r/LS_COLORS](https://github.com/trapd00r/LS_COLORS) and [sharkdp/vivid](https://github.com/sharkdp/vivid) for help in theming using `LS_COLORS`._

### First char of folder/file getting trimmed

Workaround for Konsole: ㅤEdit the config file (or [create it](#config-file-location) if it doesn't already exist) and paste the following into it (contains invisible Unicode characters):

```yml
icons:
    separator: " ㅤ"
```

This is a known issue in a few terminal emulators. Try using a different terminal emulator like. [Alacritty](https://github.com/alacritty/alacritty) and [Kitty](https://github.com/kovidgoyal/kitty) are really good alternatives. You might also want to check if your font is responsible for causing this.
To verify this, try running lsd with icons disabled and if it still does not have the first character, then this is an lsd bug:

```sh
lsd --icon never --ignore-config
```

### UTF-8 Chars

`lsd` will try to display the UTF-8 chars in file name, A `U+FFFD REPLACEMENT CHARACTER`(�) is used to represent the invalid UTF-8 chars.

### Icons are showing up strangely

Nerd Fonts is moving the code points of the Material Design Icons in 3.0, so lsd has updated the icons in #830. If your icons look weird, use fonts that have been patched using Nerd Fonts v2.3.0 or later.

See also: <https://github.com/ryanoasis/nerd-fonts/releases/tag/v2.3.3>

## Contributors

Everyone can contribute to this project, improving the code or adding functions. If anyone wants something to be added we will try to do it.

As this is being updated regularly, don't forget to rebase your fork before creating a pull-request.

## Credits

Special thanks to:

- [meain](https://github.com/meain) for all his contributions and reviews
- [danieldulaney](https://github.com/danieldulaney) for the Windows integration
- [sharkdp](https://github.com/sharkdp) and his superb [fd](https://github.com/sharkdp/fd) from which I have stolen a lot of CI stuff.
- [athityakumar](https://github.com/athityakumar) for the project [colorls](https://github.com/athityakumar/colorls)
- [All the other contributors](https://github.com/lsd-rs/lsd/graphs/contributors)

# LSD (LSDeluxe)

[![license](http://img.shields.io/badge/license-Apache%20v2-orange.svg)](https://raw.githubusercontent.com/Peltoche/ical-rs/master/LICENSE)
[![Build Status](https://travis-ci.org/Peltoche/lsd.svg?branch=master)](https://travis-ci.org/Peltoche/lsd)
[![Latest version](https://img.shields.io/crates/v/lsd.svg)](https://crates.io/crates/lsd)
[![Snap Status](https://build.snapcraft.io/badge/Peltoche/lsd.svg)](https://build.snapcraft.io/user/Peltoche/lsd)

# Table of Contents

- [Description](#description)
- [Screenshot](#screenshot)
- [Installation](#installation)
- [Configurations](#configurations)
  * [Required](#required)
  * [Optional](#optional)
- [Benchmark](#benchmark)
- [F.A.Q.](#faq)
- [Contributors](#contributors)
- [Credits](#credits)

## Description

This project is heavily inspired by the super [colorls](https://github.com/athityakumar/colorls)
project but with some little differences.  For example it is written in rust and not in ruby which makes it much faster ([see the benchmarks](#benchmark)).

## Screenshot

![image](https://raw.githubusercontent.com/Peltoche/lsd/assets/screen_lsd.png)

## Installation

### Prerequisites

Install the patched fonts of powerline nerd-font and/or font-awesome. Have a look at the [Nerd Font README](https://github.com/ryanoasis/nerd-fonts/blob/master/readme.md) for more installation instructions. Don't forget to setup your terminal in order to use the correct font.

See [this issue comment](https://github.com/Peltoche/lsd/issues/199#issuecomment-494218334) for detailed instructions on how to configure iTerm2 font settings correctly.

### On Archlinux

```sh
pacman -S lsd
```

### On Fedora

```sh
dnf install lsd
```

### On Ubuntu

_... and other Debian-based Linux distributions_

Download the latest .deb package from the [release page](https://github.com/Peltoche/lsd/releases) and install it via:

```sh
sudo dpkg -i lsd_7.2.0_amd64.deb  # adapt version number and architecture
```

### On Gentoo
```sh
sudo emerge sys-apps/lsd
```
(Ebuild maintained by Georgy Yakovlev)

### From Snap

```sh
sudo snap install lsd
```

### On macOS

via [Homebrew](https://brew.sh/):

```sh
brew install lsd
```

### From Sources

With Rust's package manager cargo, you can install lsd via:

```sh
cargo install lsd
```

### From Binaries

The [release page](https://github.com/Peltoche/lsd/releases) includes precompiled binaries for Linux and macOS.


## Configurations

### Required

In order to use lsd instead of the default ls you need to add this to you shell
configuration file  (~/.bashrc, ~/.zshrc, etc.) :

  ```sh
  alias ls='lsd'
  ```

### Optional

Some examples of useful aliases. You can add this to you shell configuration
file  (~/.bashrc, ~/.zshrc, etc.) just under the alias above :

  ```sh
  alias l='ls -l'
  alias la='ls -a'
  alias lla='ls -la'
  alias lt='ls --tree'
  ```


## Benchmark

Result from `hyperfine --warmup 10 'lsd -la /etc/*' 'colorls -la /etc/*' 'exa -la /etc/*' --export-markdown out.md`:

| Command | Mean [ms] | Min…Max [ms] |
|:---|---:|---:|
| `lsd -la /etc/*` | 9.8 ± 0.7 | 8.6…11.9 |
| `colorls -la /etc/*` | 387.3 ± 4.1 | 379.8…393.6 |
| `exa -la /etc/*` | 15.4 ± 1.8 | 14.0…24.0 |

## F.A.Q.

### Default Colors

In the future the possibility to customize the colors might be implemented.
For now, the default colors are:

| User/Group | Permissions | File Types | Last time Modified | File Size |
|:---|:---|:---|:---|:---|
|![#ffffd7](https://placehold.it/17/ffffd7/000000?text=+) User|![#00d700](https://placehold.it/17/00d700/000000?text=+) Read |![#0087ff](https://placehold.it/17/0087ff/000000?text=+) Directory|![#00d700](https://placehold.it/17/00d700/000000?text=+) within the last hour|![#ffffaf](https://placehold.it/17/ffffaf/000000?text=+) Small File|
|![#d7d7af](https://placehold.it/17/d7d7af/000000?text=+) Group|![#d7ff87](https://placehold.it/17/d7ff87/000000?text=+) Write|![#00d700](https://placehold.it/17/00d700/000000?text=+) Executable File|![#00d787](https://placehold.it/17/00d787/000000?text=+) within the last day|![#ffaf87](https://placehold.it/17/ffaf87/000000?text=+) Medium File|
||![#af0000](https://placehold.it/17/af0000/000000?text=+) Execute|![#d7d700](https://placehold.it/17/d7d700/000000?text=+) Non-Executable File|![#00af87](https://placehold.it/17/00af87/000000?text=+) older|![#d78700](https://placehold.it/17/d78700/000000?text=+) Large File|
||![#ff00ff](https://placehold.it/17/ff00ff/000000?text=+) Execute with Stickybit|![#af0000](https://placehold.it/17/af0000/000000?text=+) Broken Symlink||![#ffffff](https://placehold.it/17/ffffff/000000?text=+) Non File|
||![#d75f87](https://placehold.it/17/d75f87/000000?text=+) No Access|![#00d7d7](https://placehold.it/17/00d7d7/000000?text=+) Pipe/Symlink/Blockdevice/Socket/Special|||
|||![#d78700](https://placehold.it/17/d78700/000000?text=+) CharDevice|||



## Contributors

Everyone can contribute to this project, improving the code or adding functions. If anyone wants something to be added we will try to do it.

As this is being updated regularly, don't forget to rebase your fork before creating a pull-request.

## Credits

Special thanks to:

- [meain](https://github.com/meain) for all his contributions and reviews
- [danieldulaney](https://github.com/danieldulaney) for the Windows integration
- [sharkdp](https://github.com/sharkdp) and his superb [fd](https://github.com/sharkdp/fd) from which I have stolen a lot of CI stuff.
- [athityakumar](https://github.com/athityakumar) for the project [colorls](https://github.com/athityakumar/colorls)
- All the other contributors

# LSD (LSDeluxe)

[![license](http://img.shields.io/badge/license-Apache%20v2-blue.svg)](https://raw.githubusercontent.com/Peltoche/lsd/master/LICENSE)
[![Latest version](https://img.shields.io/crates/v/lsd.svg)](https://crates.io/crates/lsd)
[![build](https://github.com/Peltoche/lsd/workflows/CICD/badge.svg)](https://github.com/Peltoche/lsd/actions)
[![codecov](https://codecov.io/gh/Peltoche/lsd/branch/master/graph/badge.svg)](https://codecov.io/gh/Peltoche/lsd)
[![versions](https://img.shields.io/repology/repositories/lsd)](https://repology.org/project/lsd/versions)

# Table of Contents

- [Description](#description)
- [Screenshot](#screenshot)
- [Installation](#installation)
- [Configuration](#configuration)
- [External Configurations](#external-configurations)
  * [Required](#required)
  * [Optional](#optional)
- [F.A.Q.](#faq)
- [Contributors](#contributors)
- [Credits](#credits)

## Description

This project is heavily inspired by the super [colorls](https://github.com/athityakumar/colorls)
project but with some little differences.  For example it is written in rust and not in ruby which makes it much faster.

## Screenshot

![image](https://raw.githubusercontent.com/Peltoche/lsd/assets/screen_lsd.png)

## Installation

### Prerequisites

Install the patched fonts of powerline nerd-font and/or font-awesome. Have a look at the [Nerd Font README](https://github.com/ryanoasis/nerd-fonts/blob/master/readme.md) for more installation instructions. Don't forget to setup your terminal in order to use the correct font.

See [this issue comment](https://github.com/Peltoche/lsd/issues/199#issuecomment-494218334) for detailed instructions on how to configure iTerm2 font settings correctly.

### On Archlinux

```sh
pacman -S lsd
```

### On Fedora

```sh
dnf install lsd
```

### On Ubuntu

_... and other Debian-based Linux distributions_

Download the latest .deb package from the [release page](https://github.com/Peltoche/lsd/releases) and install it via:

```sh
sudo dpkg -i lsd_0.19.0_amd64.deb # adapt version number and architecture
```

### On Gentoo

```sh
sudo emerge sys-apps/lsd
```
(Ebuild maintained by Georgy Yakovlev)


### On macOS

via [Homebrew](https://brew.sh/):

```sh
brew install lsd
```

or [MacPorts](https://www.macports.org/):

```sh
sudo port install lsd
```

### On NixOS/From nix

```sh
nix-env -iA nixos.lsd
```

Or add `lsd` to your `configuration.nix` like so:

```nix
# ...
environment.systemPackages = with pkgs; [
  # other packages ...
  lsd
];
# ...
```

### On FreeBSD

```sh
pkg install lsd
```

### On Windows

Install with [Scoop](https://scoop.sh):
```powershell
scoop install lsd
```
### On Android (via Termux)
```sh
pkg install lsd
```
[Setup Nerd Fonts in Termux](https://github.com/Peltoche/lsd/issues/423)
### From Sources

With Rust's package manager cargo, you can install lsd via:

```sh
cargo install lsd
```

If you want to install the latest master branch commit:
```sh
cargo install --git https://github.com/Peltoche/lsd.git --branch master
```

### From Binaries

The [release page](https://github.com/Peltoche/lsd/releases) includes precompiled binaries for Linux and macOS.

## Configuration

`lsd` can be configured with a configuration file to set the default options.
Check [Config file content](#config-file-content) for details.

### Config file location

#### Non-Windows

On non-Windows systems `lsd` follows the
[XDG Base Directory Specification](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html)
convention for the location of the configuration file. The configuration dir
`lsd` uses is itself named `lsd`. In that directory it looks first for a file
called `config.yaml`.
For most people it should be enough to put their config file at
`~/.config/lsd/config.yaml`.

#### Windows

On Windows systems `lsd` only looks for the `config.yaml` files in one location:
`%APPDATA%\lsd\`

### Config file content

This is an example config file with the default values and some additional
remarks.

```yaml
# == Classic ==
# This is a shorthand to override some of the options to be backwards compatible
# with `ls`. It affects the "color"->"when", "sorting"->"dir-grouping", "date"
# and "icons"->"when" options.
# Possible values: false, true
classic: false

# == Blocks ==
# This specifies the columns and their order when using the long and the tree
# layout.
# Possible values: permission, user, group, size, size_value, date, name, inode
blocks:
  - permission
  - user
  - group
  - size
  - date
  - name

# == Color ==
# This has various color options. (Will be expanded in the future.)
color:
  # When to colorize the output.
  # When "classic" is set, this is set to "never".
  # Possible values: never, auto, always
  when: auto

# == Date ==
# This specifies the date format for the date column. The freeform format
# accepts an strftime like string.
# When "classic" is set, this is set to "date".
# Possible values: date, relative, +<date_format>
date: date

# == Dereference ==
# Whether to dereference symbolic links.
# Possible values: false, true
dereference: false

# == Display ==
# What items to display. Do not specify this for the default behavior.
# Possible values: all, almost-all, directory-only
# display: all

# == Icons ==
icons:
  # When to use icons.
  # When "classic" is set, this is set to "never".
  # Possible values: always, auto, never
  when: auto
  # Which icon theme to use.
  # Possible values: fancy, unicode
  theme: fancy

# == Ignore Globs ==
# A list of globs to ignore when listing.
# ignore-globs:
#   - .git

# == Indicators ==
# Whether to add indicator characters to certain listed files.
# Possible values: false, true
indicators: false

# == Layout ==
# Which layout to use. "oneline" might be a bit confusing here and should be
# called "one-per-line". It might be changed in the future.
# Possible values: grid, tree, oneline
layout: grid

# == Recursion ==
recursion:
  # Whether to enable recursion.
  # Possible values: false, true
  enabled: false
  # How deep the recursion should go. This has to be a positive integer. Leave
  # it unspecified for (virtually) infinite.
  # depth: 3

# == Size ==
# Specifies the format of the size column.
# Possible values: default, short, bytes
size: default

# == Sorting ==
sorting:
  # Specify what to sort by.
  # Possible values: extension, name, time, size, version
  column: name
  # Whether to reverse the sorting.
  # Possible values: false, true
  reverse: false
  # Whether to group directories together and where.
  # When "classic" is set, this is set to "none".
  # Possible values: first, last, none
  dir-grouping: none

# == No Symlink ==
# Whether to omit showing symlink targets
# Possible values: false, true
no-symlink: false

# == Total size ==
# Whether to display the total size of directories.
# Possible values: false, true
total-size: false

# == Symlink arrow ==
# Specifies how the symlink arrow display, chars in both ascii and utf8
symlink-arrow: ⇒
```

## External Configurations

### Required

Enable nerd fonts for your terminal, URxvt for example:

.Xresources
```
URxvt*font:    xft:Hack Nerd Font:style=Regular:size=11
```

### Optional


In order to use lsd when entering the `ls` command, you need to add this to your shell
configuration file  (~/.bashrc, ~/.zshrc, etc.):

  ```sh
  alias ls='lsd'
  ```

Some further examples of useful aliases:

  ```sh
  alias l='ls -l'
  alias la='ls -a'
  alias lla='ls -la'
  alias lt='ls --tree'
  ```

## F.A.Q.

### Default Colors

In the future the possibility to customize the colors might be implemented.
For now, the default colors are:

| User/Group | Permissions | File Types | Last time Modified | File Size |
|:---|:---|:---|:---|:---|
|![#ffffd7](https://placehold.it/17/ffffd7/000000?text=+) User|![#00d700](https://placehold.it/17/00d700/000000?text=+) Read |![#0087ff](https://placehold.it/17/0087ff/000000?text=+) Directory|![#00d700](https://placehold.it/17/00d700/000000?text=+) within the last hour|![#ffffaf](https://placehold.it/17/ffffaf/000000?text=+) Small File|
|![#d7d7af](https://placehold.it/17/d7d7af/000000?text=+) Group|![#d7ff87](https://placehold.it/17/d7ff87/000000?text=+) Write|![#00d700](https://placehold.it/17/00d700/000000?text=+) Executable File|![#00d787](https://placehold.it/17/00d787/000000?text=+) within the last day|![#ffaf87](https://placehold.it/17/ffaf87/000000?text=+) Medium File|
||![#af0000](https://placehold.it/17/af0000/000000?text=+) Execute|![#d7d700](https://placehold.it/17/d7d700/000000?text=+) Non-Executable File|![#00af87](https://placehold.it/17/00af87/000000?text=+) older|![#d78700](https://placehold.it/17/d78700/000000?text=+) Large File|
||![#ff00ff](https://placehold.it/17/ff00ff/000000?text=+) Execute with Stickybit|![#af0000](https://placehold.it/17/af0000/000000?text=+) Broken Symlink||![#ffffff](https://placehold.it/17/ffffff/000000?text=+) Non File|
||![#d75f87](https://placehold.it/17/d75f87/000000?text=+) No Access|![#00d7d7](https://placehold.it/17/00d7d7/000000?text=+) Pipe/Symlink/Blockdevice/Socket/Special|||
|||![#d78700](https://placehold.it/17/d78700/000000?text=+) CharDevice|||

### UTF-8 Chars

`lsd` will try to display the UTF-8 chars in file name, A `U+FFFD REPLACEMENT CHARACTER`(�) is used to represent the invalid UTF-8 chars.

## Contributors

Everyone can contribute to this project, improving the code or adding functions. If anyone wants something to be added we will try to do it.

As this is being updated regularly, don't forget to rebase your fork before creating a pull-request.

## Credits

Special thanks to:

- [meain](https://github.com/meain) for all his contributions and reviews
- [danieldulaney](https://github.com/danieldulaney) for the Windows integration
- [sharkdp](https://github.com/sharkdp) and his superb [fd](https://github.com/sharkdp/fd) from which I have stolen a lot of CI stuff.
- [athityakumar](https://github.com/athityakumar) for the project [colorls](https://github.com/athityakumar/colorls)
- All the other contributors

<div align="center">

<p>
  <sup>
    <a href="https://github.com/sponsors/zwpaper">LSD is supported by the community.</a>
  </sup>
</p>
<sup>Special thanks to:</sup>
<br>
<br>
<a href="https://www.warp.dev/?utm_source=github&utm_medium=referral&utm_campaign=lsd_20231001">
  <div>
    <img src="https://user-images.githubusercontent.com/3764335/271887540-b782d11d-d122-484d-8cd3-7fdff3b4ac4d.png" width="230" alt="Warp">
  </div>
  <b>Warp is a blazingly fast, Rust-based terminal reimagined to work like a modern app.</b>
  <div>
    <sup>Get more done in the CLI with real text editing, block-based output, and AI command search.</sup>
  </div>
</a>
<hr>
</div>

**IMPORTANT**: This is the development documents,
please check the docs in [Tags](https://github.com/lsd-rs/lsd/tags) if you installed from the released ones.

The current newest release is: [v1.0.0](https://github.com/lsd-rs/lsd/tree/v1.0.0)

---

# LSD (LSDeluxe)

[![license](http://img.shields.io/badge/license-Apache%20v2-blue.svg)](https://raw.githubusercontent.com/lsd-rs/lsd/master/LICENSE)
[![Latest version](https://img.shields.io/crates/v/lsd.svg)](https://crates.io/crates/lsd)
[![build](https://github.com/lsd-rs/lsd/workflows/CICD/badge.svg)](https://github.com/lsd-rs/lsd/actions)
[![codecov](https://codecov.io/gh/lsd-rs/lsd/branch/master/graph/badge.svg)](https://codecov.io/gh/lsd-rs/lsd)
[![versions](https://img.shields.io/repology/repositories/lsd)](https://repology.org/project/lsd/versions)

![image](https://raw.githubusercontent.com/lsd-rs/lsd/assets/screen_lsd.png)

This project is a rewrite of GNU `ls` with lots of added features like colors, icons, tree-view, more formatting options etc.
The project is heavily inspired by the super [colorls](https://github.com/athityakumar/colorls) project.


## Installation

<details>
<summary>Packaging status</summary>
<a href="https://repology.org/project/lsd/versions">
    <img src="https://repology.org/badge/vertical-allrepos/lsd.svg?columns=3" alt="Packaging status">
</a>
</details>

### Prerequisites

Install the patched fonts of powerline nerd-font and/or font-awesome. Have a look at the [Nerd Font README](https://github.com/ryanoasis/nerd-fonts/blob/master/readme.md) for more installation instructions. Don't forget to setup your terminal in order to use the correct font.

| OS/Distro                       | Command                                                              |
| ------------------------------- | -------------------------------------------------------------------- |
| Archlinux                       | `pacman -S lsd`                                                      |
| Fedora                          | `dnf install lsd`                                                    |
| Gentoo                          | `sudo emerge sys-apps/lsd`                                           |
| macOS                           | `brew install lsd` or `sudo port install lsd`                        |
| NixOS                           | `nix-env -iA nixos.lsd`                                              |
| FreeBSD                         | `pkg install lsd`                                                    |
| NetBSD or any `pkgsrc` platform | `pkgin install lsd` or `cd /usr/pkgsrc/sysutils/lsd && make install` |
| OpenBSD                         | `pkg_add lsd`                                                        |
| Windows                         | `scoop install lsd` or `winget install --id lsd-rs.lsd`              |
| Android (via Termux)            | `pkg install lsd`                                                    |
| Debian sid and bookworm         | `apt install lsd`                                                    |
| Ubuntu 23.04 (Lunar Lobster)    | `apt install lsd`                                                    |
| Earlier Ubuntu/Debian versions  | **snap discontinued**, use [From Binaries](#from-binaries)           |
| Solus                           | `eopkg it lsd`                                                       |
| Void Linux                      | `sudo xbps-install lsd`                                              |
| openSUSE                        | `sudo zypper install lsd`                                            |

### From source

With Rust's package manager cargo, you can install lsd via:

```sh
cargo install lsd
```

If you want to install the latest master branch commit:

```sh
cargo install --git https://github.com/lsd-rs/lsd.git --branch master
```

### From Binaries

The [release page](https://github.com/lsd-rs/lsd/releases) includes precompiled binaries for Linux, macOS and Windows for every release. You can also get the latest binary of `master` branch from the [GitHub action build artifacts](https://github.com/lsd-rs/lsd/actions?query=branch%3Amaster+is%3Asuccess+event%3Apush) (choose the top action and scroll down to the artifacts section).

## Configuration

`lsd` can be configured with a configuration file to set the default options.
Check [Config file content](#config-file-content) for details.

### Config file location

### Non-Windows

On non-Windows systems `lsd` follows the
[XDG Base Directory Specification](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html)
convention for the location of the configuration file. A `config.yaml` or `config.yml` file will be searched for in these locations, in order:

- `$HOME/.config/lsd`
- `$XDG_CONFIG_HOME/lsd`

On most systems these are mapped to the same location, which is `~/.config/lsd/config.yaml`.

### Windows

On Windows systems `lsd` searches for `config.yaml` or `config.yml` in the following locations, in order:

- `%USERPROFILE%\.config\lsd`
- `%APPDATA%\lsd`

These are usually something like `C:\Users\username\AppData\Roaming\lsd\config.yaml` and `C:\Users\username\.config\lsd\config.yaml` respectively.

### Custom

You can also provide a configuration file from a non standard location:
`lsd --config-file [PATH]`

### Config file content

<details open>
<summary>This is an example config file with the default values and some additional remarks.</summary>

```yaml
# == Classic ==
# This is a shorthand to override some of the options to be backwards compatible
# with `ls`. It affects the "color"->"when", "sorting"->"dir-grouping", "date"
# and "icons"->"when" options.
# Possible values: false, true
classic: false

# == Blocks ==
# This specifies the columns and their order when using the long and the tree
# layout.
# Possible values: permission, user, group, context, size, date, name, inode, links, git
blocks:
  - permission
  - user
  - group
  - size
  - date
  - name

# == Color ==
# This has various color options. (Will be expanded in the future.)
color:
  # When to colorize the output.
  # When "classic" is set, this is set to "never".
  # Possible values: never, auto, always
  when: auto
  # How to colorize the output.
  # When "classic" is set, this is set to "no-color".
  # Possible values: default, custom
  # When "custom" is set, lsd will look in the config directory for `colors.yaml`.
  theme: default

# == Date ==
# This specifies the date format for the date column. The freeform format
# accepts a strftime like string.
# When "classic" is set, this is set to "date".
# Possible values: date, locale, relative, '+<date_format>'
# `date_format` will be a `strftime` formatted value. e.g. `date: '+%d %b %y %X'` will give you a date like this: 17 Jun 21 20:14:55
date: date

# == Dereference ==
# Whether to dereference symbolic links.
# Possible values: false, true
dereference: false

# == Display ==
# What items to display. Do not specify this for the default behavior.
# Possible values: all, almost-all, directory-only
# display: all

# == Icons ==
icons:
  # When to use icons.
  # When "classic" is set, this is set to "never".
  # Possible values: always, auto, never
  when: auto
  # Which icon theme to use.
  # Possible values: fancy, unicode
  theme: fancy
  # Separator between icon and the name
  # Default to 1 space
  separator: " "

# == Ignore Globs ==
# A list of globs to ignore when listing.
# ignore-globs:
#   - .git

# == Indicators ==
# Whether to add indicator characters to certain listed files.
# Possible values: false, true
indicators: false

# == Layout ==
# Which layout to use. "oneline" might be a bit confusing here and should be
# called "one-per-line". It might be changed in the future.
# Possible values: grid, tree, oneline
layout: grid

# == Recursion ==
recursion:
  # Whether to enable recursion.
  # Possible values: false, true
  enabled: false
  # How deep the recursion should go. This has to be a positive integer. Leave
  # it unspecified for (virtually) infinite.
  # depth: 3

# == Size ==
# Specifies the format of the size column.
# Possible values: default, short, bytes
size: default

# == Permission ==
# Specify the format of the permission column
# Possible value: rwx, octal, attributes (windows only), disabled
# permission: rwx

# == Sorting ==
sorting:
  # Specify what to sort by.
  # Possible values: extension, name, time, size, version
  column: name
  # Whether to reverse the sorting.
  # Possible values: false, true
  reverse: false
  # Whether to group directories together and where.
  # When "classic" is set, this is set to "none".
  # Possible values: first, last, none
  dir-grouping: none

# == No Symlink ==
# Whether to omit showing symlink targets
# Possible values: false, true
no-symlink: false

# == Total size ==
# Whether to display the total size of directories.
# Possible values: false, true
total-size: false

# == Hyperlink ==
# Attach hyperlink to filenames
# Possible values: always, auto, never
hyperlink: never

# == Symlink arrow ==
# Specifies how the symlink arrow display, chars in both ascii and utf8
symlink-arrow: ⇒

# == Header ==
# Whether to display block headers.
# Possible values: false, true
header: false

# == Literal ==
# Whether to show quotes on filenames.
# Possible values: false, true
literal: false

# == Truncate owner ==
# How to truncate the username and group names for a file if they exceed a certain
# number of characters.
truncate-owner:
  # Number of characters to keep. By default, no truncation is done (empty value).
  after:
  # String to be appended to a name if truncated.
  marker: ""
```

</details>

## Theme

`lsd` can be configured with theme files to set the colors or icons.

### Color Theme

Color theme can be configured in the [configuration file](#configuration)(color.theme),
The valid theme configurations are:

- `default`: the default color scheme shipped in `lsd`
- `custom`: use a custom color scheme defined in `colors.yaml`
- *(deprecated) theme_file_name(yaml): use the theme file to specify colors(without the `yaml` extension)*

When set to `custom`, `lsd` will look for `colors.yaml` in the
XDG Base Directory, e.g. ~/.config/lsd/colors.yaml

When configured with the `theme-file-name` which is a `yaml` file,
`lsd` will look up the theme file in the following way:

- relative name: check the XDG Base Directory, e.g. ~/.config/lsd/themes/<theme-file-name>.yaml
- absolute name: use the file path and name to find theme file

Check [Color Theme file content](#color-theme-file-content) for details.

#### Color Theme file content

Theme file use the [crossterm](https://crates.io/crates/crossterm)
to configure the colors, check [crossterm](https://docs.rs/crossterm/0.20.0/crossterm/style/enum.Color.html)
for supported colors.

Color table: https://upload.wikimedia.org/wikipedia/commons/1/15/Xterm_256color_chart.svg

Please notice that color values would ignore the case, both lowercase and UPPERCASE is supported.

This is the default theme scheme shipped with `lsd`.

```yaml
user: 230
group: 187
permission:
  read: dark_green
  write: dark_yellow
  exec: dark_red
  exec-sticky: 5
  no-access: 245
  octal: 6
  acl: dark_cyan
  context: cyan
date:
  hour-old: 40
  day-old: 42
  older: 36
size:
  none: 245
  small: 229
  medium: 216
  large: 172
inode:
  valid: 13
  invalid: 245
links:
  valid: 13
  invalid: 245
tree-edge: 245
git-status:
  default: 245
  unmodified: 245
  ignored: 245
  new-in-index: dark_green
  new-in-workdir: dark_green
  typechange: dark_yellow
  deleted: dark_red
  renamed: dark_green
  modified: dark_yellow
  conflicted: dark_red
```

When creating a theme for `lsd`, you can specify any part of the default theme,
and then change its colors, the items missed would fallback to use the default colors.

Please also notice that an empty theme is **NOT** supported due to
[a bug in serde lib](https://github.com/dtolnay/serde-yaml/issues/86).

### Icon Theme

Icon theme can be configured in a fixed location, `$XDG_CONFIG_DIR/lsd/icons.yaml`,
for example, `~/.config/lsd/icons.yaml` on macOS,
please check [Config file location](#config-file-location) to make sure where is `$XDG_CONFIG_DIR`.

As the file name indicated, the icon theme file is a `yaml` file.

Check [Icon Theme file content](#icon-theme-file-content) for details.

#### Icon Theme file content

`lsd` support 3 kinds of icon overrides, by `name`, by `filetype` and by `extension`.
The final set of icons used will be a combination of what is shipped with in `lsd` with overrides from config applied on top of it.
*You can find the default set of icons [here](src/theme/icon.rs).*

Both nerd font glyphs and unicode emojis can be used for icons. You can find an example of icons customization below.

```yaml
name:
  .trash: 
  .cargo: 
  .emacs.d: 
  a.out: 
extension:
  go: 
  hs: 
  rs: 🦀
filetype:
  dir: 📂
  file: 📄
  pipe: 📩
  socket: 󰆨
  executable: 
  symlink-dir: 
  symlink-file: 
  device-char: 
  device-block: 󰜫
  special: 
```

## External Configurations

### Required

Enable nerd fonts for your terminal, URxvt for example in `.Xresources`:

```sh
URxvt*font:    xft:Hack Nerd Font:style=Regular:size=11
```

### Optional

In order to use lsd when entering the `ls` command, you need to add this to your shell
configuration file (~/.bashrc, ~/.zshrc, etc.):

```sh
alias ls='lsd'
```

Some further examples of useful aliases:

```sh
alias l='ls -l'
alias la='ls -a'
alias lla='ls -la'
alias lt='ls --tree'
```

## F.A.Q

### Uses unknown compression for member 'control.tar.zst' when using deb

Zst compression is supported starting from `Debian 12` and `Ubuntu 21.10`,
Please use the `_xz.deb` released starting from `lsd v1.1.0`.

Please check https://github.com/lsd-rs/lsd/issues/891 for details or manual fixes.

### Custom Color Schemes for Windows
For `lsd` currently, it reads a system environment variable called LS_COLORS. Please look at the marked solution in [this post](https://github.com/orgs/lsd-rs/discussions/958#discussioncomment-7659375), which contains a guide on how to set a color scheme.

### Icons not showing up

For `lsd` to be able to display icons, the font has to include special font glyphs. This might not be the case for most fonts that you download. Thankfully, you can patch most fonts using [NerdFont](https://www.nerdfonts.com/) and add these icons. Or you can just download an already patched version of your favourite font from [NerdFont font download page](https://www.nerdfonts.com/font-downloads).
Here is a guide on how to setup fonts on [macOS](https://github.com/lsd-rs/lsd/issues/199#issuecomment-494218334) and [Android](https://github.com/lsd-rs/lsd/issues/423).

To check if the font you are using is setup correctly, try running the following snippet in a shell and see if that [prints a folder icon](https://github.com/lsd-rs/lsd/issues/510#issuecomment-860000306). If it prints a box, or question mark or something else, then you might have some issues in how you setup the font or how your terminal emulator renders the font.

```sh
echo $'\uf115'
```

### Icons missing or not rendering correctly using PuTTY/KiTTY on Windows

First of all, make sure a patched font is installed and PuTTY/KiTTY is configurated to use it, please check [Prerequisites](#prerequisites).

There are problems for PuTTY/KiTTY to show 2 char wide icons, make sure using a 1 char wide font like [Hack Regular Nerd Font Complete Mono Windows Compatible](https://github.com/ryanoasis/nerd-fonts/blob/master/patched-fonts/Hack/Regular/complete/Hack%20Regular%20Nerd%20Font%20Complete%20Mono%20Windows%20Compatible.ttf), check [this issue](https://github.com/lsd-rs/lsd/issues/331) for detail.

### Colors

You can customize filetype colors using `LS_COLORS` and other colors using the theme.

The default colors are:

| User/Group                                                            | Permission                                                                             | File Type (changes based on your terminal colorscheme)                                                  | Date                                                                                 | File Size                                                                   |
| :-------------------------------------------------------------------- | :------------------------------------------------------------------------------------- | :------------------------------------------------------------------------------------------------------ | :----------------------------------------------------------------------------------- | :-------------------------------------------------------------------------- |
| ![#ffffd7](https://via.placeholder.com/15/ffffd7/000000?text=+) User  | ![#00d700](https://via.placeholder.com/15/00d700/000000?text=+) Read                   | ![#0087ff](https://via.placeholder.com/15/0087ff/000000?text=+) Directory                               | ![#00d700](https://via.placeholder.com/15/00d700/000000?text=+) within the last hour | ![#ffffaf](https://via.placeholder.com/15/ffffaf/000000?text=+) Small File  |
| ![#d7d7af](https://via.placeholder.com/15/d7d7af/000000?text=+) Group | ![#d7ff87](https://via.placeholder.com/15/d7ff87/000000?text=+) Write                  | ![#00d700](https://via.placeholder.com/15/00d700/000000?text=+) Executable File                         | ![#00d787](https://via.placeholder.com/15/00d787/000000?text=+) within the last day  | ![#ffaf87](https://via.placeholder.com/15/ffaf87/000000?text=+) Medium File |
|                                                                       | ![#af0000](https://via.placeholder.com/15/af0000/000000?text=+) Execute                | ![#ffffff](https://via.placeholder.com/15/ffffff/000000?text=+) Non-Executable File                     | ![#00af87](https://via.placeholder.com/15/00af87/000000?text=+) older                | ![#d78700](https://via.placeholder.com/15/d78700/000000?text=+) Large File  |
|                                                                       | ![#ff00ff](https://via.placeholder.com/15/ff00ff/000000?text=+) Execute with Stickybit | ![#af0000](https://via.placeholder.com/15/af0000/000000?text=+) Broken Symlink                          |                                                                                      | ![#ffffff](https://via.placeholder.com/15/ffffff/000000?text=+) Non File    |
|                                                                       | ![#d75f87](https://via.placeholder.com/15/d75f87/000000?text=+) No Access              | ![#00d7d7](https://via.placeholder.com/15/00d7d7/000000?text=+) Pipe/Symlink/Blockdevice/Socket/Special |                                                                                      |                                                                             |
|                                                                       |                                                                                        | ![#d78700](https://via.placeholder.com/15/d78700/000000?text=+) CharDevice                              |                                                                                      |                                                                             |

_Checkout [trapd00r/LS_COLORS](https://github.com/trapd00r/LS_COLORS) and [sharkdp/vivid](https://github.com/sharkdp/vivid) for help in themeing using `LS_COLORS`._

### First char of folder/file getting trimmed

Workaround for Konsole: ㅤEdit the config file (or [create it](#config-file-location) if it doesn't already exist) and paste the following into it (contains invisible unicode characters):

```yml
icons:
    separator: " ㅤ"
```

This is a known issue in a few terminal emulator. Try using a different terminal emulator like. [Alacritty](https://github.com/alacritty/alacritty) and [Kitty](https://github.com/kovidgoyal/kitty) are really good alternatives. You might also want to check if your font is responsible for causing this.
To verify this, try running lsd with icons disabled and if it still does not have the first character, then this is an lsd bug:

```sh
lsd --icon never --ignore-config
```

### UTF-8 Chars

`lsd` will try to display the UTF-8 chars in file name, A `U+FFFD REPLACEMENT CHARACTER`(�) is used to represent the invalid UTF-8 chars.

### Icons are showing up strangely

Nerd Fonts is moving the codepoints of the Material Design Icons in 3.0, so lsd has updated the icons in #830. If your icons look weird, use fonts that have been patched using Nerd Fonts v2.3.0 or later.

See also: <https://github.com/ryanoasis/nerd-fonts/releases/tag/v2.3.3>

## Contributors

Everyone can contribute to this project, improving the code or adding functions. If anyone wants something to be added we will try to do it.

As this is being updated regularly, don't forget to rebase your fork before creating a pull-request.

## Credits

Special thanks to:

- [meain](https://github.com/meain) for all his contributions and reviews
- [danieldulaney](https://github.com/danieldulaney) for the Windows integration
- [sharkdp](https://github.com/sharkdp) and his superb [fd](https://github.com/sharkdp/fd) from which I have stolen a lot of CI stuff.
- [athityakumar](https://github.com/athityakumar) for the project [colorls](https://github.com/athityakumar/colorls)
- [All the other contributors](https://github.com/lsd-rs/lsd/graphs/contributors)

### daltonize ###


#' @export
#' @name daltonize
#' @aliases LSD.daltonize
#' @title Dichromat vision simulation for colorpalettes
#' @description Dichromat vision simulation and enhancement according to \url{http://www.daltonize.org}.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param show logical: if \code{TRUE} (by default), the resulting colorpalettes are depicted in an R plot.
#' @return \code{daltonize} returns a list, where each entry is a vector containing R built-in colors in hexadecimal representation: \item{simulated}{vector of simulated colors} \item{enhanced}{vector of enhanced colors}
#' @author Bjoern Schwalb
#' @seealso \code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
#' @references \url{http://www.daltonize.org}
#' @examples daltonize("heat",cvd = "d")
#' daltonize("colorblind",cvd = "p")
#' @keywords daltonize colorblind


daltonize = function(colpal,cvd = "p",show = TRUE)
{
	
	# Color Vision Deficiency Transformation Matrices #
	
	cvdtransform = switch(cvd,
			
			# protanope: reds are greatly reduced (1% men, 0,02% women) #
			
			p = matrix(data = c(0, 2.02344, -2.52581, 0, 1, 0, 0, 0, 1),nrow = 3,ncol = 3,byrow = TRUE),
			
			# deuteranope: greens are greatly reduced (1% men, 0,01% women) #
			
			d = matrix(data = c(1, 0, 0, 0.494207, 0, 1.24827, 0, 0, 1),nrow = 3,ncol = 3,byrow = TRUE),
			
			# tritanope: blues are greatly reduced (0,002% men, 0,001% women) #
			
			t = matrix(data = c(1, 0, 0, 0, 1, 0, -0.395913, 0.801109, 0),nrow = 3,ncol = 3,byrow = TRUE)	
	)
	
	# color management ###
	
	rgbvec = colorpalette(colpal)
	rgbmat = col2rgb(rgbvec)
	
	# conversion of RGB coordinates into LMS, a color space suitable for calculating color blindness as it's represented by the three types of cones of the human eye, named after their sensitivity at wavelengths; Long (564-580nm), Medium (534-545nm) and Short (420-440nm) #
	
	rgb2lms = matrix(data = c(17.8824, 43.5161, 4.11935, 3.45565, 27.1554, 3.86714, 0.0299566, 0.184309, 1.46709),nrow = 3,ncol = 3,byrow = TRUE)
	lmsmat = rgb2lms%*%rgbmat
	
	# simulation of color blindness by reducing the colors along a dichromatic confusion line, the line parallel to the axis of the missing photoreceptor, to a single color #

	simmat = cvdtransform%*%lmsmat
	
	# conversion of LMS coordinates into RGB #
	
	lms2rgb = solve(rgb2lms)
	simrgbmat = lms2rgb%*%simmat

	# adjust for numerical instability #
	
	simrgbmat = apply(simrgbmat,c(1,2),function(x){if (x>255){return(255)} else if (x<0){return(0)} else return(x)})
	
	# conversion to hexadecimal color code #
			
	simpal = apply(round(simrgbmat),2,function(x){rgb(x[1],x[2],x[3],maxColorValue = 255)})
	
	# compensation for color blindness by shifting wavelengths away from the portion of the spectrum invisible to the dichromat, towards the visible portion #

		# isolate invisible colors to color vision deficiency (calculate error matrix) #
		
		errormat = rgbmat - simrgbmat
		
		# shift colors towards visible spectrum (apply error modifications) #
		
		adjustmat = matrix(data = c(0, 0, 0, 0.7, 1, 0, 0.7, 0, 0),nrow = 3,ncol = 3,byrow = TRUE)
		compensationmat = adjustmat%*%errormat
		
		# add compensation to original values #
		
		enhancedrgbmat = compensationmat + rgbmat
	
	# adjust for numerical instability #
	
	enhancedrgbmat = apply(enhancedrgbmat,c(1,2),function(x){if (x>255){return(255)} else if (x<0){return(0)} else return(x)})
	
	# conversion to hexadecimal color code #
	
	enhancedpal = apply(enhancedrgbmat,2,function(x){rgb(x[1],x[2],x[3],maxColorValue = 255)})
	
	# simulation of color blindness for the compensation values #
	
		# conversion of RGB coordinates into LMS #
		
		testlmsmat = rgb2lms%*%enhancedrgbmat
		
		# simulation of color blindness #
		
		testsimmat = cvdtransform%*%testlmsmat
		
		# conversion of LMS coordinates into RGB #
		
		testsimrgbmat = lms2rgb%*%testsimmat
		
		# adjust for numerical instability #
		
		testsimrgbmat = apply(testsimrgbmat,c(1,2),function(x){if (x>255){return(255)} else if (x<0){return(0)} else return(x)})
		
		# conversion to hexadecimal color code #
		
		testsimpal = apply(round(testsimrgbmat),2,function(x){rgb(x[1],x[2],x[3],maxColorValue = 255)})
	
	# plot resulting colpals #
	
	if (show){
		nr = length(rgbvec)
		
		# The nonlinear relations for L, a, and b are intended to mimic the nonlinear response of the eye. Furthermore, uniform changes of components in the Lab color space aim to correspond to uniform changes in perceived color, so the relative perceptual differences between any two colors in Lab can be approximated by treating each color as a point in a three dimensional space and taking the Euclidean distance between them #
	
			# linearize RGB #
	
			linsimmat = apply(simrgbmat/255,c(1,2),function(x){if (x <= 0.04045)return(x/12.92) else return(((x + 0.055)/(1 + 0.055))^(2.4))})
					
			# conversion of RGB coordinates into XYZ (sRGB D65) ###
		
			rgb2xyz = matrix(data = c(0.4124564, 0.3575761, 0.1804375, 0.2126729, 0.7151522, 0.0721750, 0.0193339, 0.1191920, 0.9503041),nrow = 3,ncol = 3,byrow = TRUE)
			simxyzmat = rgb2xyz%*%linsimmat
			
			# tristimulus values of the reference white point: standard light source (D65) chosen according to 6500K color temperature (average daylight) #
		
			x = 0.312713
			y = 0.329016
			z = 1-x-y
			
			xn = x/y
			yn = 1
			zn = z/y
			
			# conversion of XYZ coordinates into Lab ###
			
			sqfkt = function(x){if (x > (6/29)^3)return(x^(1/3)) else return((1/3)*(29/6)^2*x + (4/29))}
			simLabmat = apply(simxyzmat,2,function(x){L = 116*sqfkt(x[2]/yn) - 16;a = 500*(sqfkt(x[1]/xn) - sqfkt(x[2]/yn));b = 200*(sqfkt(x[2]/yn) - sqfkt(x[3]/zn));return(c(L,a,b))})
				
			euclids = c()
			for (i in 1:nr){
				diffmat = simLabmat - simLabmat[,i]
				euclids = c(euclids,apply(diffmat[,setdiff(1:nr,i),drop = FALSE],2,function(x){return(sqrt(sum(x^2)))}))
			}
			euclids = unique(euclids)
		
			# Euclidean perception difference score #
	
			Epds = min(euclids)/sqrt(100^2 + (2*128)^2 + (2*128)^2)
			
		npal = 4
		plot(1,1,xlim=c(0,nr),ylim=c(0,npal*2),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
		rect(xleft = 0:(nr - 1),ybottom = 1 - 1,xright = 1:nr,ytop = 1 - 0.2,col = testsimpal,border = NA)
		rect(xleft = 0,ybottom = 1 - 1,xright = nr,ytop = 1 - 0.2,col = "transparent",border = "darkgrey")
		rect(xleft = 0:(nr - 1),ybottom = 3 - 1,xright = 1:nr,ytop = 3 - 0.2,col = enhancedpal,border = NA)
		rect(xleft = 0,ybottom = 3 - 1,xright = nr,ytop = 3 - 0.2,col = "transparent",border = "darkgrey")
		rect(xleft = 0:(nr - 1),ybottom = 5 - 1,xright = 1:nr,ytop = 5 - 0.2,col = simpal,border = NA)
		rect(xleft = 0,ybottom = 5 - 1,xright = nr,ytop = 5 - 0.2,col = "transparent",border = "darkgrey")
		rect(xleft = 0:(nr - 1),ybottom = 7 - 1,xright = 1:nr,ytop = 7 - 0.2,col = rgbvec,border = NA)
		rect(xleft = 0,ybottom = 7 - 1,xright = nr,ytop = 7 - 0.2,col = "transparent",border = "darkgrey")
		cvdtype = switch(cvd,p = "protanope",d = "deuteranope",t = "tritanope")
		text(rep(nr/2,npal),c(8,6,4,2)-0.6,labels = c(paste("Original colors"),paste("Simulated colors as seen by",cvdtype,"individuals"),paste("Enhanced colors for",cvdtype,"individuals"),paste("Enhanced simulated colors as seen by",cvdtype,"individuals")))
		mtext(paste("Euclidean perception difference score (Epds):",signif(Epds,1)),3,2,cex=1.25)
		mtext(paste("( should be >= 0.01 for sufficient perception differences )"),3,0,col="darkgrey")
	}
	
	# return colpals #

	return(list("simulated" = simpal,"enhanced" = enhancedpal))
}


# alias #


LSD.daltonize = daltonize


### colorpalette ###


#' @export
#' @name colorpalette
#' @aliases LSD.colorpalette
#' @title Provides colorpalettes containing R built-in colors
#' @description Provides pre-designed colorpalettes (character vectors containing R built-in colors) of this and several other R packages (grDevices, RColorBrewer, colorRamps) as well as custom-made ones.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to length of \code{colpal}, if not specified).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is returned to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is returned to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is returned.
#' @return \code{colorpalette} returns a vector containing R built-in colors in hexadecimal representation.
#' @author Achim Tresch, Bjoern Schwalb
#' @seealso \code{\link{disco}}, \code{\link{demotour}}
#' @examples colorpalette("heat")
#' colorpalette(c("darkred","grey","darkblue"),10)
#' @keywords color alpha


colorpalette = function(colpal,nrcol = NULL,simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,rev = FALSE)
{
	if (length(colpal) > 1){palette = colpal}
	else{palette = switch(colpal,			
				
				# custom-made palettes #
				
				heat = c("grey","darkblue","red","orange","gold"),
				crazyred = c( "#940000","#A50000","#FF5C5C","#FFB9B9"),
				crazygreen = c("dark green","#009700","green","#C0F5D0"),
				crazyblue = c("dark blue","blue","#7390EE","light blue"),
				mountain = c("light green","dark green","black","dark grey","#F0F0F0"),
				girly = c("violet","violetred","violetred1","purple","purple3"),
				jamaica = c("red","yellow","green"),
				standard = c("brown","gold","yellow","lightyellow","white"),
				colorblind = c("#000000","#E69F00","#56B4E9","#009E73","#F0E442","#0072B2","#D55E00","#CC79A7"),
				
				# palettes from the RColorBrewer package #
				
				ylorrd = rev(c("#FFFFCC","#FFEDA0","#FED976","#FEB24C","#FD8D3C","#FC4E2A","#E31A1C","#BD0026","#800026")),
				ylorbr = rev(c("#FFFFE5","#FFF7BC","#FEE391","#FEC44F","#FE9929","#EC7014","#CC4C02","#993404","#662506")),
				ylgnbu = rev(c("#FFFFD9","#EDF8B1","#C7E9B4","#7FCDBB","#41B6C4","#1D91C0","#225EA8","#253494","#081D58")),
				ylgn = rev(c("#FFFFE5","#F7FCB9","#D9F0A3","#ADDD8E","#78C679","#41AB5D","#238443","#006837","#004529")),
				reds = rev(c("#FFF5F0","#FEE0D2","#FCBBA1","#FC9272","#FB6A4A","#EF3B2C","#CB181D","#A50F15","#67000D")),
				rdpu = rev(c("#FFF7F3","#FDE0DD","#FCC5C0","#FA9FB5","#F768A1","#DD3497","#AE017E","#7A0177","#49006A")),
				purples = rev(c("#FCFBFD","#EFEDF5","#DADAEB","#BCBDDC","#9E9AC8","#807DBA","#6A51A3","#54278F","#3F007D")),
				purd = rev(c("#F7F4F9","#E7E1EF","#D4B9DA","#C994C7","#DF65B0","#E7298A","#CE1256","#980043","#67001F")),
				pubugn = rev(c("#FFF7FB","#ECE2F0","#D0D1E6","#A6BDDB","#67A9CF","#3690C0","#02818A","#016C59","#014636")),
				pubu = rev(c("#FFF7FB","#ECE7F2","#D0D1E6","#A6BDDB","#74A9CF","#3690C0","#0570B0","#045A8D","#023858")),
				orrd = rev(c("#FFF7EC","#FEE8C8","#FDD49E","#FDBB84","#FC8D59","#EF6548","#D7301F","#B30000","#7F0000")),
				oranges = rev(c("#FFF5EB","#FEE6CE","#FDD0A2","#FDAE6B","#FD8D3C","#F16913","#D94801","#A63603","#7F2704")),
				greys = rev(c("#FFFFFF","#F0F0F0","#D9D9D9","#BDBDBD","#969696","#737373","#525252","#252525","#000000")),
				greens = rev(c("#F7FCF5","#E5F5E0","#C7E9C0","#A1D99B","#74C476","#41AB5D","#238B45","#006D2C","#00441B")),
				gnbu = rev(c("#F7FCF0","#E0F3DB","#CCEBC5","#A8DDB5","#7BCCC4","#4EB3D3","#2B8CBE","#0868AC","#084081")),
				bupu = rev(c("#F7FCFD","#E0ECF4","#BFD3E6","#9EBCDA","#8C96C6","#8C6BB1","#88419D","#810F7C","#4D004B")),
				bugn = rev(c("#F7FCFD","#E5F5F9","#CCECE6","#99D8C9","#66C2A4","#41AE76","#238B45","#006D2C","#00441B")),
				blues = rev(c("#F7FBFF","#DEEBF7","#C6DBEF","#9ECAE1","#6BAED6","#4292C6","#2171B5","#08519C","#08306B")),
				spectral = c("#9E0142","#D53E4F","#F46D43","#FDAE61","#FEE08B","#FFFFBF","#E6F598","#ABDDA4","#66C2A5","#3288BD","#5E4FA2"),
				rdylgn = c("#A50026","#D73027","#F46D43","#FDAE61","#FEE08B","#FFFFBF","#D9EF8B","#A6D96A","#66BD63","#1A9850","#006837"),
				rdylbu = c("#A50026","#D73027","#F46D43","#FDAE61","#FEE090","#FFFFBF","#E0F3F8","#ABD9E9","#74ADD1","#4575B4","#313695"),
				rdgy = c("#67001F","#B2182B","#D6604D","#F4A582","#FDDBC7","#FFFFFF","#E0E0E0","#BABABA","#878787","#4D4D4D","#1A1A1A"),
				rdbu = c("#67001F","#B2182B","#D6604D","#F4A582","#FDDBC7","#F7F7F7","#D1E5F0","#92C5DE","#4393C3","#2166AC","#053061"),
				puor = c("#7F3B08","#B35806","#E08214","#FDB863","#FEE0B6","#F7F7F7","#D8DAEB","#B2ABD2","#8073AC","#542788","#2D004B"),
				prgn = c("#40004B","#762A83","#9970AB","#C2A5CF","#E7D4E8","#F7F7F7","#D9F0D3","#A6DBA0","#5AAE61","#1B7837","#00441B"),
				piyg = c("#8E0152","#C51B7D","#DE77AE","#F1B6DA","#FDE0EF","#F7F7F7","#E6F5D0","#B8E186","#7FBC41","#4D9221","#276419"),
				brbg = c("#543005","#8C510A","#BF812D","#DFC27D","#F6E8C3","#F5F5F5","#C7EAE5","#80CDC1","#35978F","#01665E","#003C30"),
				
				# palettes from the grDevices package #
				
				standardterrain = terrain.colors(9),
				standardtopo = topo.colors(9),
				standardheat = heat.colors(9),
				standardrainbow = rainbow(9,start=0.7,end=0.1),
				standardcm = cm.colors(9),
				
				# palettes from the colorRamps package #

				bl2gr = c("#0000FF","#001AE6","#0033CC","#004DB3","#006699","#008080","#009966","#00B34C","#00CC33","#00E619","#00FF00"),
				bl2gr2rd = c("#0000BF","#0000FF","#0080FF","#00FFFF","#40FFBF","#80FF80","#BFFF40","#FFFF00","#FF8000","#FF0000","#BF0000"),
				bl2rd = c("#0000FF","#0033FF","#0066FF","#0099FF","#00CCFF","#00FFFF","#FFCC00","#FF9900","#FF6600","#FF3300","#FF0000"),
				bl2yl = c("#0000FF","#1A1AE6","#3333CC","#4D4DB3","#666699","#808080","#999966","#B3B34C","#CCCC33","#E6E619","#FFFF00"),
				cy2yl = c("#00FFFF","#1AFFE6","#33FFCC","#4DFFB3","#66FF99","#80FF80","#99FF66","#B3FF4C","#CCFF33","#E6FF19","#FFFF00"),
				gr2rd = c("#00FF00","#1AE600","#33CC00","#4DB300","#669900","#808000","#996600","#B34C00","#CC3300","#E61900","#FF0000"),
				ma2gr = c("#FF00FF","#E61AE6","#CC33CC","#B34DB3","#996699","#808080","#669966","#4CB34C","#33CC33","#19E619","#00FF00"),
				matlablike = c("#0000AA","#0040FF","#0080FF","#40BFFF","#80FFFF","#BFFFBF","#FFFF80","#FFBF40","#FF8000","#FF4000","#AA0000"),
				matlablike2 = c("#0000BF","#0000FF","#0080FF","#00FFFF","#40FFBF","#80FF80","#BFFF40","#FFFF00","#FF8000","#FF0000","#BF0000") 
		)}
	if (is.null(palette)){stop("'colpal' should be a valid colorpalette name (see 'disco()') or a character vector of at least two R built-in color names for interpolation!")}
	if (is.null(nrcol)){nrcol = length(palette)}
	palette = try(colorRampPalette(palette)(nrcol),silent = TRUE)
	if (class(palette) == "try-error"){stop("'colpal' should be a valid colorpalette name (see 'disco()') or a character vector of at least two R built-in color names for interpolation!")}
	if (rev){palette = rev(palette)}
	if (simulate){palette = daltonize(palette,cvd = cvd,show = FALSE)$simulated}
	if (daltonize){palette = daltonize(palette,cvd = cvd,show = FALSE)$enhanced}
	if (!is.null(alpha)){palette = convertcolor(palette,alpha)}
	return(palette)
}


# alias #


LSD.colorpalette = colorpalette


### disco ###


#' @export
#' @name disco
#' @aliases LSD.disco
#' @aliases display.colorpalette
#' @aliases LSD.display.colorpalette
#' @title Disco (DISplays COlorpalettes)
#' @description Displays pre-designed colorpalettes as well as custom-made ones (see \code{colorpalette}).
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (displays all colorpalettes, if not specified).
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to length of \code{colpal}, if not specified).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @author Bjoern Schwalb
#' @seealso \code{\link{colorpalette}}, \code{\link{demotour}}
#' @examples disco()
#' disco("rdbu",10)
#' @keywords color alpha


disco = function(colpal = NULL,nrcol = NULL,alpha = NULL)
{
	if (is.null(colpal)){
		if (is.null(nrcol)){nrcol = 11}
		
		# plot custom-made palettes #
		
		ownpals = c("colorblind","standard","crazyred","crazygreen","crazyblue","girly","jamaica","mountain","heat")
		pals = ownpals
		npal = length(ownpals)
		plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
		for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
		for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
		text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
		mtext(paste("palettes from the LSD package"),3,2,cex=1.25)
		mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
		devAskNewPage(ask = TRUE)
		
		# plot palettes from the RColorBrewer package (part 1) #
		
		brewerpals = c("spectral","rdylgn","rdylbu","rdgy","rdbu","puor","prgn","piyg","brbg")
		pals = brewerpals
		npal = length(brewerpals)
		plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
		for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
		for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
		text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
		mtext(paste("palettes from the RColorBrewer package"),3,2,cex=1.25)
		mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
		devAskNewPage(ask = TRUE)
		
		# plot palettes from the RColorBrewer package (part 2) #
		
		brewerpals = c("ylorrd","ylorbr","ylgnbu","ylgn","reds","rdpu","purples","purd","pubugn","pubu","orrd","oranges","greys","greens","gnbu","bupu","bugn","blues")
		pals = brewerpals
		npal = length(brewerpals)
		plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
		for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
		for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
		text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
		mtext(paste("palettes from the RColorBrewer package"),3,2,cex=1.25)
		mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
		devAskNewPage(ask = TRUE)
		
		# plot palettes from the colorRamps package #

		rampspals = c("bl2gr","bl2gr2rd","bl2rd","bl2yl","cy2yl","gr2rd","ma2gr","matlablike","matlablike2")
		pals = rampspals
		npal = length(rampspals)
		plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
		for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
		for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
		text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
		mtext(paste("palettes from the colorRamps package"),3,2,cex=1.25)
		mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
		devAskNewPage(ask = TRUE)
		
		# plot palettes from the grDevices package #

		grpals = c("standardterrain","standardtopo","standardheat","standardrainbow","standardcm")
		pals = grpals
		npal = length(grpals)
		plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
		for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
		for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
		text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
		mtext(paste("palettes from the grDevices package"),3,2,cex=1.25)
		mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
	} else {
		
		# plot user-specified colorpalette if 'colpal != NULL' #
		
		if (is.null(nrcol)){nrcol = length(colorpalette(colpal,nrcol,alpha = alpha))}
		plot(1,1,xlim=c(0,nrcol),ylim=c(0,8),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
		rect(xleft = 0:(nrcol - 1),ybottom = 3,xright = 1:nrcol,ytop = 5,col = colorpalette(colpal,nrcol,alpha = alpha),border = NA)
		rect(xleft = 0,ybottom = 3,xright = nrcol,ytop = 5,col = "transparent",border = "darkgrey")
		if (length(colpal) > 1){mtext(paste("colorpalette"),3,2,cex=1.25)} else {mtext(paste(colpal,"colorpalette"),3,2,cex=1.25)}
		mtext(paste("( ",paste(colorpalette(colpal,nrcol,alpha = alpha),collapse = "  ")," )"),3,0,col="darkgrey",cex=1 + ((1-0.25)*(nchar(paste("( ",paste(colorpalette(colpal,nrcol,alpha = alpha),collapse = "  ")," )"))-50))/(50-185))
	}
}


# aliases #


LSD.disco = disco
display.colorpalette = disco
LSD.display.colorpalette = disco


### distinctcolors ###


#' @export
#' @name distinctcolors
#' @aliases LSD.distinctcolors
#' @title Find preferably distinct R built-in colors
#' @description Find a vector of distinct R built-in colors for a pre-defined length ('nrcol').
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to the length of \code{10}, if not specified).
#' @param method character string implying the method for color selection to be used ("RGB" uses a grid in the RGB space (default), "Lab" uses a grid in the Lab space, "goldenratio" uses the golden ratio as spacing between colors in the HSV color space).
#' @param bw logical: if \code{TRUE} (\code{FALSE} by default), the colors "black" and "white" are removed from the resulting colorpalette.
#' @param show logical: if \code{TRUE} (by default), the resulting colorpalettes are depicted in an R plot.
#' @param simulate logical: if \code{TRUE} (by default), a converted colorpalettes are additionally depicted to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @return \code{distinctcolors} returns a vector containing R built-in colors in hexadecimal representation.
#' @author Bjoern Schwalb
#' @seealso \code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
#' @examples distinctcolors()
#' @keywords color


distinctcolors = function(nrcol = 10,method = "RGB",bw = FALSE,show = TRUE,simulate = TRUE)
{	
	# get.permutations function #
	
	get.permutations = function(n,r,v = 1:n){
		v = unique(sort(v))
		v0 = vector(mode(v),0)
		sub = function(n,r,v){
			if (r == 1){
				matrix(v,n,1)
			} else if (n == 1) {
				matrix(v,1,r)
			} else {
				inner = Recall(n,r - 1,v)
				cbind(rep(v,rep(nrow(inner),n)),matrix(t(inner),ncol = ncol(inner),nrow = nrow(inner)*n,byrow = TRUE))
			}
		}
		sub(n, r, v[1:n])
	}
	
	if (method == "RGB"){
		
		# 'RGB' uses a grid in the RGB space #
		
		# lay grid into the RGB space #
		
		lower = 1
		while ((nrcol+2) > lower^3) lower = lower + 1
		valseq = seq(0,255,length.out = lower)
        spl = get.permutations(length(valseq),3,valseq)
		
		# remove black and white #
		
		spl = spl[-c(1,nrow(spl)),]
		
		# sample nrcol of colors needed #
		
		spl = spl[sample(nrow(spl),nrcol),,drop=FALSE]
		
		# conversion to hexadecimal color code #
		
		colpal = apply(spl,1,function(x){rgb(x[1],x[2],x[3],maxColorValue = 255)})
		
		# black and white? #
		
		if (!bw){colpal[1] = "#000000";colpal[length(colpal)] = "#FFFFFF"}
		
	} else if (method == "Lab"){
		
		# 'Lab' uses a grid in the Lab space #
		
		# lay grid into the Lab space #
		
		lower = 1
		while ((nrcol+2) > lower^3) lower = lower + 1
		valseq = seq(0,1,length.out = lower)
		spl = get.permutations(length(valseq),3,valseq)
		spl[,1] = spl[,1]*100
		spl[,2:3] = (spl[,2:3]*2 - 1)*150
		
		# The nonlinear relations for L, a, and b are intended to mimic the nonlinear response of the eye. Furthermore, uniform changes of components in the Lab color space aim to correspond to uniform changes in perceived color, so the relative perceptual differences between any two colors in Lab can be approximated by treating each color as a point in a three dimensional space and taking the Euclidean distance between them #
		
		# tristimulus values of the reference white point: standard light source (D65) chosen according to 6500K color temperature (average daylight) #
		
		x = 0.312713
		y = 0.329016
		z = 1-x-y
		
		xn = x/y
		yn = 1
		zn = z/y
		
		# conversion of Lab coordinates into XYZ ###
		
		sqfkt = function(x){if (x > 6/29)return(x^3) else return(3*(6/29)^2*(x - (4/29)))}
		xyzspl = apply(t(spl),2,function(x){X = xn*sqfkt((x[1] + 16)/116 + x[2]/500);Y = yn*sqfkt((x[1] + 16)/116);Z = zn*sqfkt((x[1] + 16)/116 - x[3]/200);return(c(X,Y,Z))})
		
		# conversion of XYZ coordinates into RGB (sRGB D65) ###
		
		rgb2xyz = matrix(data = c(0.4124564, 0.3575761, 0.1804375, 0.2126729, 0.7151522, 0.0721750, 0.0193339, 0.1191920, 0.9503041),nrow = 3,ncol = 3,byrow = TRUE)
		linrgbspl = solve(rgb2xyz)%*%xyzspl
		
		# adjust for numerical instability #
		
		linrgbspl = apply(linrgbspl,c(1,2),function(x){if (x>1){return(1)} else if (x<0){return(0)} else return(x)})
		
		# reverse linearization in RGB #
		
		revrgbspl = t(apply(linrgbspl,c(1,2),function(x){if (x <= 0.0031308)return(x*12.92) else return(x^(1/2.4)*(1 + 0.055) - 0.055)})*255)
		
		# remove black and white #
		
		revrgbspl = revrgbspl[-which(apply(round(revrgbspl),1,sum) %in% c(0,3*255)),]
		
		# sample nrcol of colors needed #
		
		revrgbspl = revrgbspl[sample(nrow(revrgbspl),nrcol),,drop=FALSE]
		
		# conversion to hexadecimal color code #
		
		colpal = apply(revrgbspl,1,function(x){rgb(x[1],x[2],x[3],maxColorValue = 255)})
		
		# black and white? #
		
		if (!bw){colpal[1] = "#000000";colpal[length(colpal)] = "#FFFFFF"}
		
	} else if (method == "goldenratio"){
		
		# 'goldenratio' uses the golden ratio as spacing between colors in the HSV color space #
	
		# use random start value #
		
		h = runif(1)
		
		# subsequently add the golden ratio conjugate (1/golden ratio) modulo 1 #
		
		for (i in 1:(nrcol-1)){h = c(h,(h[length(h)] + 0.618033988749895)%%1)}
		
		# conversion to hexadecimal color code #
		
		colpal = hsv(h = h,s = 1,v = 1)
		
		# black and white? #
		
		if (!bw){colpal[1] = "#000000";colpal[length(colpal)] = "#FFFFFF"}
		
		# method switch trap #
		
	} else {stop("method need to be 'RGB', 'Lab' or 'goldenratio' !")}	
	
	# plot results? #
	
	if (show){
		if (simulate){
			nrcolpal = 4
			plot(1,1,xlim=c(0,nrcol),ylim=c(0,nrcolpal*2),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
			rect(xleft = 0:(nrcol - 1),ybottom = 1 - 1,xright = 1:nrcol,ytop = 1 - 0.2,col = daltonize(colpal,cvd = "t",show = FALSE)$simulated,border = NA)
			rect(xleft = 0,ybottom = 1 - 1,xright = nrcol,ytop = 1 - 0.2,col = "transparent",border = "darkgrey")
			rect(xleft = 0:(nrcol - 1),ybottom = 3 - 1,xright = 1:nrcol,ytop = 3 - 0.2,col = daltonize(colpal,cvd = "d",show = FALSE)$simulated,border = NA)
			rect(xleft = 0,ybottom = 3 - 1,xright = nrcol,ytop = 3 - 0.2,col = "transparent",border = "darkgrey")
			rect(xleft = 0:(nrcol - 1),ybottom = 5 - 1,xright = 1:nrcol,ytop = 5 - 0.2,col = daltonize(colpal,cvd = "p",show = FALSE)$simulated,border = NA)
			rect(xleft = 0,ybottom = 5 - 1,xright = nrcol,ytop = 5 - 0.2,col = "transparent",border = "darkgrey")
			rect(xleft = 0:(nrcol - 1),ybottom = 7 - 1,xright = 1:nrcol,ytop = 7 - 0.2,col = colpal,border = NA)
			rect(xleft = 0,ybottom = 7 - 1,xright = nrcol,ytop = 7 - 0.2,col = "transparent",border = "darkgrey")
			text(rep(nrcol/2,nrcolpal),c(8,6,4,2)-0.6,labels = c(paste("Original colors"),paste("Simulated colors as seen by protanope individuals"),paste("Simulated colors as seen by deuteranope individuals"),paste("Simulated colors as seen by tritanope individuals")))
			mtext(paste("distinctcolors"),3,2,cex=1.25)
			mtext(paste("( ",paste(colpal,collapse = "  ")," )"),3,0,col="darkgrey",cex=1 + ((1-0.25)*(nchar(paste("( ",paste(colpal,collapse = "  ")," )"))-50))/(50-185))
		} else {
			plot(1,1,xlim=c(0,nrcol),ylim=c(0,8),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
			rect(xleft = 0:(nrcol - 1),ybottom = 3,xright = 1:nrcol,ytop = 5,col = colpal,border = NA)
			rect(xleft = 0,ybottom = 3,xright = nrcol,ytop = 5,col = "transparent",border = "darkgrey")
			mtext(paste("distinctcolors"),3,2,cex=1.25)
			mtext(paste("( ",paste(colpal,collapse = "  ")," )"),3,0,col="darkgrey",cex=1 + ((1-0.25)*(nchar(paste("( ",paste(colpal,collapse = "  ")," )"))-50))/(50-185))
		}
	}
	
	# return colpal #
	
	return(colpal)
}


# alias #


LSD.distinctcolors = distinctcolors


### convertcolor ###


#' @export
#' @name convertcolor
#' @aliases LSD.convertcolor
#' @title Map R colors to hexadecimal representation
#' @description Convert R built-in colors to hexadecimal representation.
#' @param cols a character vector containing R built-in colors.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @return \code{convertcolor} returns a vector containing R built-in colors in hexadecimal representation.
#' @author Bjoern Schwalb
#' @seealso \code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
#' @examples convertcolor(c("red","green","blue"))
#' @keywords color


convertcolor = function(cols,alpha = NULL)
{
	colmat = col2rgb(cols)
	cols = apply(colmat,2,function(x){rgb(x[1],x[2],x[3],maxColorValue = 255)})
	if (!is.null(alpha)){cols = paste(cols,alpha,sep="")}
	return(cols)
}


# alias #


LSD.convertcolor = convertcolor


### complementarycolor ###


#' @export
#' @name complementarycolor
#' @aliases LSD.complementarycolor
#' @title Complement R colors
#' @description Convert R built-in colors to their color complement
#' @param cols a character vector containing R built-in colors.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @return \code{complementarycolor} returns a vector containing R built-in colors in hexadecimal representation.
#' @author Bjoern Schwalb
#' @seealso \code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
#' @examples complementarycolor(c("red","green","blue"))
#' @keywords color


complementarycolor = function(cols,alpha = NULL)
{
	colmat = c(255,255,255) - col2rgb(cols)
	cols = apply(colmat,2,function(x){rgb(x[1],x[2],x[3],maxColorValue = 255)})
	if (!is.null(alpha)){cols = paste(cols,alpha,sep="")}
	return(cols)
}


# alias #


LSD.complementarycolor = complementarycolor


### convertgrey ###


#' @export
#' @name convertgrey
#' @aliases LSD.convertgrey
#' @title Convert R colors to greyscale
#' @description Greyscale R built-in colors.
#' @param cols a character vector containing R built-in colors.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @return \code{convertgrey} returns a vector containing R built-in colors in hexadecimal representation.
#' @author Bjoern Schwalb
#' @seealso \code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
#' @examples convertgrey(c("red","green","blue"))
#' @keywords greyscale color


convertgrey = function(cols,alpha = NULL)
{
	colmat = col2rgb(cols)
	cols = apply(colmat,2,function(x){rgb(0.3*x[1]+0.59*x[2]+0.11*x[3],0.3*x[1]+0.59*x[2]+0.11*x[3],0.3*x[1]+0.59*x[2]+0.11*x[3],maxColorValue = 255)})
	if (!is.null(alpha)){cols = paste(cols,alpha,sep="")}
	return(cols)
}


# alias #


LSD.convertgrey = convertgrey

### heatbarplot ###


#' @export
#' @name heatbarplot
#' @aliases LSD.heatbarplot
#' @title Color a barplot.
#' @description Depict a histogram object as a barplot in a color encoded fashion based on a kernel density estimate.
#' @param x a histogram object.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param horizontal logical: if \code{TRUE} (\code{FALSE} by default), rotation of 90 degrees is applied.
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples points = 10^4
#' x = c(rnorm(points/2),rnorm(points/2)+4)
#' x = sign(x)*abs(x)^1.3
#' xhist = hist(x,plot = FALSE)
#' 
#' heatbarplot(xhist)
#' @keywords barplot


heatbarplot = function(x,colpal = "heat",simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,rev = FALSE,horizontal = FALSE,nrcol = 100,...)
{
	if (class(x) != "histogram") stop("x must be of class histogram!")
	if (!horizontal){
		barplot(x$density,axes = FALSE,space = 0,border = "white",...)
		dy = (max(x$density) - 0)/nrcol
		colpal = colorpalette(colpal,nrcol,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev)
		colorlane = function(a,b){for(i in 1:100){rect(a,0 + (i-1) * dy,b,0 + i*dy,col = colpal[i],border = NA)}}
		for (j in 1:length(x$counts)){colorlane(j-1,j)}
		for (j in 1:length(x$counts)){rect(j-1,x$density[j],j,max(x$density),col = "white",border = NA)}
		for (j in 1:length(x$counts)){rect(j-1,0,j,x$density[j],col = "transparent",border = NULL)}
	} else{
		barplot(x$density,axes = FALSE,space = 0,border = "white",horiz=TRUE,...)
		dy = (max(x$density) - 0)/nrcol
		colpal = colorpalette(colpal,nrcol,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev)
		colorlane = function(a,b){for(i in 1:100){rect(0 + (i-1) * dy,a,0 + i*dy,b,col = colpal[i],border = NA)}}
		for (j in 1:length(x$counts)){colorlane(j-1,j)}
		for (j in 1:length(x$counts)){rect(x$density[j],j-1,max(x$density),j,col = "white",border = NA)}
		for (j in 1:length(x$counts)){rect(0,j-1,x$density[j],j,col = "transparent",border = NULL)}}
}


### aliases ###


LSD.heatbarplot = heatbarplot


### comparisonplot ###


#' @export
#' @name comparisonplot
#' @aliases cplot
#' @title Comparisonplot: a fancy scatterplot
#' @description A function to compare two vectors extensively.
#' @param x a numeric vector.
#' @param y a numeric vector.
#' @param histbreaks a non-negative integer specifying the number of breaks of the histograms.
#' @param adjust scale the used bandwidth of the density estimate, if \code{add.density = TRUE}.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param cor if \code{TRUE} (\code{FALSE} by default), the correlation is added to the title.
#' @param xlab x label, standard graphics parameter.
#' @param ylab y label, standard graphics parameter.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param ab if \code{TRUE} (\code{FALSE} by default), \code{abline(0,1)} is added to the heatscatter.
#' @param add.density if \code{TRUE} (\code{FALSE} by default), density lines are added to the barplots.
#' @param col.density R built-in color to specify the color of the density line.
#' @param pimp if \code{TRUE} (\code{FALSE} by default), the plot is pimped.
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples points = 10^4
#' x = c(rnorm(points/2),rnorm(points/2)+4)
#' y = x + rnorm(points,sd=0.8)
#' x = sign(x)*abs(x)^1.3
#' 
#' comparisonplot(x,y,histbreaks=30,pch=20)
#' @keywords scatterplot barplot


comparisonplot = function(x,y,histbreaks = 30,adjust = 1,colpal = "heat",simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,rev = FALSE,main = "comparisonplot",cor = FALSE,xlab = NULL,ylab = NULL,xlim = NULL,ylim = NULL,ab = FALSE,add.density = FALSE,col.density = "darkred",pimp = FALSE,...)
{
	if (!is.vector(x) | !is.vector(y)) stop("First two argument must be vectors!")
	if (is.null(xlab)){xlab = deparse(substitute(x))}
	if (is.null(ylab)){ylab = deparse(substitute(y))}
	sound = which((!(is.na(x)|is.nan(x)|(x==Inf)|(x==-Inf))) & (!(is.na(y)|is.nan(y)|(y==Inf)|(y==-Inf))))
	if (length(sound)==0) stop("There are no valid point pairs to plot!")
	x = x[sound]
	y = y[sound]
	xrange <- c(min(range(x),range(y)),max(range(x),range(y)))
	yrange <- c(min(range(x),range(y)),max(range(x),range(y)))
	if (!is.null(xlim)){cut = x > xlim[1] & x < xlim[2]
		x = x[cut]
		y = y[cut]
		xrange = xlim
	}
	if (!is.null(ylim)){cut = y > ylim[1] & y < ylim[2]
		y = y[cut]
		x = x[cut]
		yrange = ylim
	}                           
	def.par = par(no.readonly = TRUE) # save default, for resetting...
	xhist = hist(x, breaks=seq(xrange[1],xrange[2],length.out=histbreaks),plot=FALSE)
	yhist = hist(y, breaks=seq(yrange[1],yrange[2],length.out=histbreaks),plot=FALSE)
	top = max(c(xhist$density,yhist$density))
	nf = layout(matrix(c(0,2,0,4,1,3,0,5,0),3,3,byrow=TRUE), c(1,3,1), c(1,3,1), TRUE)
	dx = density(x)
	dy = density(y)
	par(mar=c(4,4,4,4))
	heatscatter(x,y,xlim=xrange,ylim=yrange,xlab = xlab,ylab = ylab,main=main,colpal=colpal,cor=cor,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev,...)
	if (pimp){
		if (ab){abline(0,1,col="#08306B50",lwd=2)}
		par(mar=c(0,4,1,4))
		heatbarplot(xhist,ylim=c(0,top),colpal=colpal,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = !rev)
		if (add.density){lines((dx$x-xhist$breaks[1])/(xhist$breaks[2]-xhist$breaks[1]),dx$y,lwd = 2,col = col.density)}
		par(mar=c(4,0,4,1))
		heatbarplot(yhist,xlim=c(0,top),colpal=colpal,horizontal=TRUE,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = !rev)
		if (add.density){lines(dy$y,(dy$x-yhist$breaks[1])/(yhist$breaks[2]-yhist$breaks[1]),lwd = 2,col = col.density)}
		par(mar=c(4,1,4,0))
		heatboxplot(y,axes=FALSE,graphics = FALSE,colpal=colpal,ylim=yrange,nolab=TRUE,adjust=adjust,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = !rev)
		par(mar=c(1,4,0,4))
		heatboxplot(x,axes=FALSE,horizontal=TRUE,graphics = FALSE,colpal=colpal,ylim=xrange,nolab=TRUE,adjust=adjust,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = !rev)
	}
	else {
		if (ab){abline(0,1,col="black",lwd=1)}
		par(mar=c(0,4,1,4))
		barplot(xhist$density, axes=FALSE, ylim=c(0, top), space=0,col="#F0F0F0")
		if (add.density){lines((dx$x-xhist$breaks[1])/(xhist$breaks[2]-xhist$breaks[1]),dx$y,lwd = 2,col = col.density)}
		par(mar=c(4,0,4,1))
		barplot(yhist$density, axes=FALSE, xlim=c(0, top), space=0,col="#F0F0F0", horiz=TRUE)
		if (add.density){lines(dy$y,(dy$x-yhist$breaks[1])/(yhist$breaks[2]-yhist$breaks[1]),lwd = 2,col = col.density)}
		par(mar=c(4,1,4,0))
		boxplot(y,axes=FALSE,col="#F0F0F0",ylim=yrange)
		par(mar=c(1,4,0,4))
		boxplot(x,axes=FALSE,horizontal=TRUE,col="#F0F0F0",ylim=xrange)
	}
	par(def.par)
}


### aliases ###


LSD.comparisonplot = comparisonplot

### LSD.pie ###


#' @export
#' @name LSD.pie
#' @title Custom-built piechart version
#' @description Piecharts at arbitrary position and radii.
#' @param props a numeric vector giving the relations of the pie pieces (need not to be normalized).
#' @param x x-position of the piechart.
#' @param y y-position of the piechart.
#' @param radius a numeric value giving the radius of the piechart.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param edges an integer giving the number of edges the "circle" will have.
#' @param add logical: if \code{TRUE} (\code{FALSE} by default), the pie is added to an existing plot.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param addPercent logical: if \code{TRUE} (\code{FALSE} by default), the percentage of each slice is written inside of the pie.
#' @param textcol a R build-in color for the percentages of \code{addPercent}.
#' @param clockwise if \code{TRUE} (\code{FALSE} by default), slices drawn clockwise (counter clockwise, if \code{FALSE}).
#' @param init.angle a numerical value representing an angle as a starting angle for the drawn slices.
#' @param labels a character vector giving the names for the pie slices.
#' @param cex scaling a numeric value giving the expansion factor for the slice names (if labels are given).
#' @param cex.percentage a numeric value giving the expansion factor for the percentage values (if \code{addPercent = TRUE}).
#' @param border a R build-in color giving the border color (NA by default).
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb, Carina Demel
#' @seealso \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples emptyplot(xlim=c(1,9),ylim=c(1,9))
#' mtext(paste("LSD.pie: piecharts"),3,2,cex=1.25)
#' polygon(c(4,2,4,7,8),c(4,8,4,2,8))
#' LSD.pie(sample(1:50,5),4,4,add=TRUE,radius=2,colpal="prgn",alpha=75)
#' LSD.pie(sample(1:50,5),2,8,add=TRUE,colpal="prgn",alpha=75)
#' LSD.pie(sample(1:50,5),8,8,add=TRUE,colpal="prgn",alpha=75)
#' LSD.pie(sample(1:50,5),7,2,add=TRUE,colpal="prgn",alpha=75)
#' @keywords pie


LSD.pie = function(props,x = 0,y = 0,radius = 1,colpal = "prgn",simulate = FALSE,daltonize = FALSE,cvd = "p",edges = 1000,add = FALSE,xlim = c(-1,1),ylim = c(-1,1),main = "LSD.pie: piecharts",alpha = NULL,addPercent = FALSE,textcol = "black",clockwise = FALSE,init.angle=0,labels=c(),cex = 1,cex.percentage = cex,border=NA,...) 				
{
	direction <- if (clockwise) -2 else 2 
	
	# circle coordinates #
	
	xx = sin(-(0:edges)/edges*direction*pi+init.angle*pi/180)*radius
	yy = cos(-(0:edges)/edges*direction*pi+init.angle*pi/180)*radius
	
	xxtext = sin(-(0:edges)/edges*direction*pi+init.angle*pi/180)*radius*0.7
	yytext = cos(-(0:edges)/edges*direction*pi+init.angle*pi/180)*radius*0.7
	
	xxlabels = sin(-(0:edges)/edges*direction*pi+init.angle*pi/180)*radius*1.25
	yylabels = cos(-(0:edges)/edges*direction*pi+init.angle*pi/180)*radius*1.25
	
	# number of pie pieces #
	
	n = length(props)
	
	# default colors #
	
	cols = colorpalette(colpal,n,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha)
	
	# pie segments #
	
	phi = cumsum(props)/sum(props)*edges
	phi = c(0,round(phi))+1
	
	# plotting region #
	
	if (!add){
		emptyplot(xlim=xlim,ylim=ylim,...)
		mtext(paste(main),3,2,cex=1.25)
	}
	
	# draw pie pieces #
	
	for (j in 1:n){xvec = c(x,x+xx[phi[j]:phi[j+1]])
		yvec = c(y,y+yy[phi[j]:phi[j+1]])
		polygon(xvec,yvec,col="white",border="black")
		polygon(xvec,yvec,col=cols[j],border="black")
	}
	for(j in 1:n){
		if(addPercent){
			xtext = c(x+xxtext[phi[j]:phi[j+1]])
			ytext = c(y+yytext[phi[j]:phi[j+1]])
			text(xtext[(length(xtext)+1)/2], ytext[(length(ytext)+1)/2], paste(round(props[j]/sum(props)*100,1), "%", sep=""), col=textcol, cex=cex.percentage)
		}
		if(length(labels)==n){
			xlabel = c(x+xxlabels[phi[j]:phi[j+1]])
			ylabel = c(y+yylabels[phi[j]:phi[j+1]])
			
			lab = as.character(labels[j])
			if (!is.na(lab) && nzchar(lab)) {
				Px = xlabel[(length(xlabel)+1)/2]
				Py = ylabel[(length(ylabel)+1)/2]
				text(Px,Py,labels[j],col=textcol,cex=cex,adj=ifelse(Px < 0,1,0),xpd=TRUE)
			}
		}
	}
	
	# return invisible #
	
	invisible()
}

### densitylane ###


#' @name densitylane
#' @aliases LSD.densitylane
#' @title Visualize a density in a rectangular fashion
#' @description Add a color stripe to an existing plot based on a kernel density estimate.
#' @param x density$x values of a density object.
#' @param y density$y values of a density object.
#' @param pos the x co-ordinate of the lane (mid point).
#' @param width a numeric value giving the width of the lane.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param horizontal logical: if \code{TRUE} (\code{FALSE} by default), rotation of 90 degrees is applied.
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).
#' @author Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @keywords density


densitylane = function(x,y,pos = 1,width = 0.4,colpal = "standard",rev = FALSE,simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,horizontal = horizontal,nrcol = 75)
{
	if (!is.vector(x) | !is.vector(y)) stop("First two argument must be vectors!")
	if (length(x) != length(y)) stop("Data vectors must be of the same length!")
	colpalette = rev(colorpalette(colpal,nrcol,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev))
	ycol  = pmin(pmax(round((y-min(y))/(max(y)-min(y))*nrcol+0.5),1),nrcol)
	if (horizontal){for (j in 1:(length(x)-1)){rect(x[j],pos-width/2,x[j+1],pos+width/2,col=colpalette[ycol[j]],border=NA)}}
	else {for (j in 1:(length(x)-1)){rect(pos-width/2,x[j],pos+width/2,x[j+1],col=colpalette[ycol[j]],border=NA)}}
}


### aliases ###


LSD.densitylane = densitylane


### heatboxplot ###


#' @export
#' @name heatboxplot
#' @aliases LSD.heatboxplot
#' @title Heatboxplot: a colored boxplot
#' @description A boxplot with an additional color stripe based on a kernel density estimate.
#' @param x data as vector, matrix, list or data.frame.
#' @param horizontal logical: if \code{TRUE} (\code{FALSE} by default), rotation of 90 degrees is applied.
#' @param add logical: if \code{TRUE} (\code{FALSE} by default), the boxplot is added to an existing plot.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param colpals a character vector containing names of \code{LSD} colorpalettes (see disco() or \code{\link{disco}}).
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).
#' @param lwd linewidth of the box and whiskers.
#' @param axes logical: if \code{TRUE} (by default), the axes are plotted.
#' @param labels a character vector of labels.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param xlab x label, standard graphics parameter.
#' @param ylab y label, standard graphics parameter.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param nolab logical: if \code{TRUE} (\code{FALSE} by default), the title and ylab are suppressed.
#' @param outline logical: if \code{TRUE} (by default), outliers are plotted.
#' @param boxonly logical: if \code{TRUE} (\code{FALSE} by default), the density is only be plotted in the box.
#' @param adjust a numeric value giving the scaling factor for the used bandwidth (defaults to 1).
#' @param quant.from a numeric value (between 0 and 1) giving the quantile from which the density lane should be plotted.
#' @param quant.to a numeric value (between 0 and 1) giving the quantile to which the density lane should be plotted.
#' @param range a numeric value to determine how far the plot whiskers extend out from the box.
#' @param border an R build-in color for the box and whiskers.
#' @param plot.boxplot logical: if \code{TRUE} (by default), the boxplot is added to the density.
#' @param add.quartiles if \code{TRUE} (\code{FALSE} by default), only the box of the boxplot is added (if \code{plot.boxplot = FALSE}).
#' @param add.box logical: if \code{TRUE} (by default), the box is added to the plot.
#' @param n.density an integer specifying the number of equally spaced points at which the density is to be estimated.
#' @param cexbox a numerical value giving the amount by which the boxes should be magnified relative to the default.
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples f = c(rnorm(200),rnorm(200)+4)
#' h = rf(500,15,15)*10
#' g = rnorm(300)+1
#' 
#' heatboxplot(h)
#' 
#' heatboxplot(list(f=f,g=g),colpals=c("rdpu","greens"),labels=c("bimodal","unimodal"))
#' @keywords boxplot


heatboxplot = function(x,horizontal = FALSE,add = FALSE,colpal = "standard",rev = FALSE,simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,colpals = NULL,nrcol = 75,lwd = 1.75,axes = TRUE,labels = NULL,xlim = NULL,ylim = NULL,xlab = NULL,ylab = "",main = "heatboxplot",nolab = FALSE,outline = TRUE,boxonly = FALSE,adjust = 1,quant.from = 0.25,quant.to = 0.75,range = 1.5,border = "black",plot.boxplot = TRUE,add.quartiles = TRUE,add.box = FALSE,n.density = 1024,cexbox = 0.6,...)
{
	if (!is.vector(x) & !is.matrix(x) & !is.list(x) & !is.data.frame(x)) stop("x must be a vector, matrix, list or a data.frame!")
	if (!is.list(x) & !is.matrix(x) & !is.data.frame(x)){x = cbind(x)}
	if (is.data.frame(x)){x = as.list(x)}
	if (is.matrix(x)){x = as.list(as.data.frame(x))}
	if (is.null(colpals)){colpals = rep(colpal,length(x))}
	if (!is.null(xlim)){print("xlim argument will be ignored!")}
	if (is.null(ylim)){ylim = range(unlist(x))}
	if (!is.null(xlab)){print("xlab argument will be ignored! Use labels instead!")} # necessary ? 
	if (length(x) == 1){xlab = labels}
	if (length(x) == 1){cexbox = 0.4}
	if (length(x) > 1){boxwex = cexbox} else{boxwex = NULL}
	if (nolab){ylab = NULL}
	if (horizontal){labdummy = ylab
		ylab = xlab
		xlab = labdummy}
	limlist = list()
	qlimlist = list()
	for (i in 1:length(x)){limlist[[i]] = c(quantile(x[[i]],quant.from),quantile(x[[i]],quant.to))}
	for (i in 1:length(x)){qlimlist[[i]] = c(quantile(x[[i]],0.25),quantile(x[[i]],0.75))}
	boxplot(x,border="white",add=add,horizontal=horizontal,axes=axes,xlim=c(0.5,length(x)+0.5),ylim=ylim,width=NULL,boxwex=boxwex,main="",ylab=ylab,xlab=xlab,names=labels,outline=outline,range=range,lwd=lwd,...)
	if (!nolab){mtext(paste(main),3,2,cex=1.25)}
	for (j in 1:length(x)){xrel = x[[j]][x[[j]] >= ylim[1] & x[[j]] <= ylim[2]]
		dx = density(xrel,n=n.density,adjust=adjust)
		if(boxonly){dxx = dx$x[dx$x >= limlist[[j]][1] & dx$x <= limlist[[j]][2]]
			dxy = dx$y[dx$x >= limlist[[j]][1] & dx$x <= limlist[[j]][2]]}
		else {dxx = dx$x
			dxy = dx$y}
		densitylane(dxx,dxy,colpal=colpals[[j]],horizontal=horizontal,pos=j,width=cexbox,nrcol=nrcol,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha=alpha,rev = rev)}
	if (plot.boxplot){boxplot(x,add=TRUE,horizontal=horizontal,axes=axes,col="transparent",xlim=c(0.5,length(x)+0.5),ylim=ylim,width=NULL,boxwex=boxwex,names=labels,outline=outline,range=range,lwd=lwd,...)}                                 
	if (!plot.boxplot){if (add.quartiles) {if (horizontal){ for (j in 1:length(x)){rect(qlimlist[[j]][1],j-cexbox/2,qlimlist[[j]][2],j+cexbox/2,border="grey40",lwd=lwd)} }
			else { for (j in 1:length(x)){rect(j-cexbox/2,qlimlist[[j]][1],j+cexbox/2,qlimlist[[j]][2],border="grey40",lwd=lwd)} }}}
	if (add.box){if (horizontal){ for (j in 1:length(x)){rect(limlist[[j]][1],j-cexbox/2,limlist[[j]][2],j+cexbox/2,border=border,lwd=lwd)} }
		else { for (j in 1:length(x)){rect(j-cexbox/2,limlist[[j]][1],j+cexbox/2,limlist[[j]][2],border=border,lwd=lwd)} }}
}


### aliases ###


LSD.heatboxplot = heatboxplot

### emptyplot ###


#' @export
#' @name emptyplot
#' @aliases LSD.emptyplot
#' @title Wrapper function for an empty graphics device
#' @description Calls an empty graphics device with a coordinate system of choice.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{demotour}}
#' @examples emptyplot()
#' @keywords empty plotting region


emptyplot = function(xlim = c(-1,1),ylim = c(-1,1),...)
{
	plot.new()
	plot.window(xlim = xlim,ylim = ylim,...)
}


### alias ###


LSD.emptyplot = emptyplot




### windowxy ###


#' @export
#' @name windowxy
#' @aliases LSD.windowxy
#' @title Factorization of the number of windows for plots with device partitions
#' @description Create a factorization of the number of windows for plots with device partitions to be used in par(mfrow = ...).
#' @param nrwin a non-negative integer specifying the number of windows.
#' @author Bjoern Schwalb
#' @seealso \code{\link{demotour}}
#' @examples windowxy(20)
#' @keywords factorization


windowxy = function(nrwin = 1)
{
	# factorize 'nrwin' #
	
	flsq = floor(sqrt(nrwin))
	if (flsq^2==nrwin){
		fac = c(flsq,flsq)
	} else if (nrwin <= flsq*(flsq+1)){
		fac = c(flsq,flsq+1)
	} else {
		fac = c(flsq,flsq+2)
	}
	
	# return 'fac' #
	
	return(fac)
}


### alias ###


LSD.windowxy = windowxy




### webdesign ###


#' @export
#' @name webdesign
#' @aliases LSD.webdesign
#' @title Colored rectangular grid
#' @description Adds a colored rectangular grid to an existing plot.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param xlabels a character vector containing labels depicted parallel to the x-axis.
#' @param ylabels a character vector containing labels depicted parallel to the y-axis.
#' @param ... additional parameters to be passed to abline().
#' @author Bjoern Schwalb
#' @seealso \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples emptyplot(c(-5,5),c(-5,5))
#' labels = c("2 fold","4 fold","8 fold")
#' webdesign(c(-5,5),c(-5,5),lty = 2,xlabels = labels,ylabels = labels)
#' @keywords grid web


webdesign = function(xlim,ylim,colpal = "rdbu",xlabels = NULL,ylabels = NULL,...)
{
	# provide color encoding #
	
	colpal = colorpalette(colpal,max(diff(xlim),diff(ylim))+1)
	
	# add abscissa and ordinate #
	
	abline(h=0,v=0,...)
	
	# line segments along the x-axis #
	
	xseq = xlim[2]:xlim[1]
	abline(h=xseq,col=colpal,...)
	
	# line segments along the y-axis #
	
	yseq = ylim[2]:ylim[1]
	abline(v=yseq,col=colpal,...)
	
	# add labels if !NULL #
	
	if (!is.null(xlabels)){text(1:length(ylabels),ylim[2]-1,xlabels,col=colpal[rev(which(yseq %in% 1:length(xlabels)))],adj=c(-0.1,-0.1))}
	if (!is.null(ylabels)){text(xlim[1]+1,-(1:length(ylabels)),ylabels,col=colpal[which(xseq %in% -(1:length(ylabels)))],adj=c(-0.1,-0.1))}
}


### alias ###


LSD.webdesign = webdesign

	
	

### demotour ###


#' @export
#' @name demotour
#' @aliases LSD.demotour
#' @title LSD teaser
#' @description A compilation of selected plot examples.
#' @author Bjoern Schwalb
#' @seealso \code{\link{heatscatter}}, \code{\link{clusterplot}}, \code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{daltonize}}
#' @examples demotour()
#' @keywords heatscatter clusterplot disco colorpalette daltonize


demotour = function()
{
	# LSD.show #
	
	LSD.show = function(it){
		emptyplot()
		text(-0.7,0.15,it,pos=4,cex=pmax(1,6-log(nchar(it))))
		points(-0.7,0,pch=3,cex=8,col="red")
	}
	
	# heatscatter #
	
	par(mfrow=c(1,1))
	LSD.show("heatscatter")
	devAskNewPage(ask = TRUE)
	points = 10^4
	x = c(rnorm(points/2),rnorm(points/2)+4)
	y = x + rnorm(points,sd=0.8)
	x = sign(x)*abs(x)^1.3
	par(mfrow=c(2,2))
	heatscatter(x,y)
	heatscatter(x,y,colpal="bl2gr2rd",main="bl2gr2rd")
	heatscatter(x,y,main="greyscales with add.contour=TRUE",add.contour=TRUE,color.contour="red",greyscale=TRUE)
	heatscatter(x,y,colpal="spectral",main="spectral with add.contour=TRUE",add.contour=TRUE)
	devAskNewPage(ask = TRUE)
	
	# clusterplot #
	
	par(mfrow=c(1,1))
	LSD.show("clusterplot")
	devAskNewPage(ask = TRUE)
	samples = 150
	probes = 75
	at = 1:probes
	clus = matrix(rnorm(probes*samples,sd=1),ncol=probes)
	clus = rbind(t(t(clus)+sin(1:probes/10))+1:nrow(clus)/samples,t(t(clus)+sin(pi/2+1:probes/10))+1:nrow(clus)/samples)
	labs = paste("cluster",kmeans(clus,4)$cluster)
	par(mfrow=c(2,2))
	clusterplot(clus,label=labs,main="Data",colpal=c("standardheat","crazyblue","crazyred","standardtopo"))
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	clusterplot(clus,label=paste("cluster",kmeans(clus,2)$cluster),separate=FALSE,main="Alpha overlay",fromto=c(0.3,0.7),colpal=c("greens","purples"),outer.col="none",ylim=c(-1,2),alpha=50,quartiles.col = c("transparent","black","transparent"))
	devAskNewPage(ask = TRUE)
	
	# daltonize #
	
	par(mfrow=c(1,1))
	LSD.show("daltonize")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	daltonize("rdylgn",cvd = "d")
	devAskNewPage(ask = TRUE)
	
	
	### disco ###
	
	nrcol = 11
	par(mfrow=c(1,1))
	LSD.show("disco")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	ownpals = c("colorblind","standard","crazyred","crazygreen","crazyblue","girly","jamaica","mountain","heat")
	pals = ownpals
	npal = length(ownpals)
	plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
	for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
	for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
	text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
	mtext(paste("palettes from the LSD package"),3,2,cex=1.25)
	mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	brewerpals = c("spectral","rdylgn","rdylbu","rdgy","rdbu","puor","prgn","piyg","brbg")
	pals = brewerpals
	npal = length(brewerpals)
	plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
	for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
	for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
	text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
	mtext(paste("palettes from the RColorBrewer package"),3,2,cex=1.25)
	mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	brewerpals = c("ylorrd","ylorbr","ylgnbu","ylgn","reds","rdpu","purples","purd","pubugn","pubu","orrd","oranges","greys","greens","gnbu","bupu","bugn","blues")
	pals = brewerpals
	npal = length(brewerpals)
	plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
	for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
	for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
	text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
	mtext(paste("palettes from the RColorBrewer package"),3,2,cex=1.25)
	mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	rampspals = c("bl2gr","bl2gr2rd","bl2rd","bl2yl","cy2yl","gr2rd","ma2gr","matlablike","matlablike2")
	pals = rampspals
	npal = length(rampspals)
	plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
	for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
	for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
	text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
	mtext(paste("palettes from the colorRamps package"),3,2,cex=1.25)
	mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	grpals = c("standardterrain","standardtopo","standardheat","standardrainbow","standardcm")
	pals = grpals
	npal = length(grpals)
	plot(1,1,xlim=c(0,nrcol),ylim=c(0,npal),type="n",axes=FALSE,bty="n",xlab="",ylab="",main="")
	for (i in 1:npal){rect(xleft = 0:(nrcol - 1),ybottom = i - 1,xright = 1:nrcol,ytop = i - 0.2,col = colorpalette(pals[i],nrcol),border = NA)}
	for (i in 1:npal){rect(xleft = 0,ybottom = i - 1,xright = nrcol,ytop = i - 0.2,col = "transparent",border = "darkgrey")}
	text(rep(-0.1,npal),(1:npal)-0.6,labels = pals,xpd = TRUE,adj = 1,cex=0.8)
	mtext(paste("palettes from the grDevices package"),3,2,cex=1.25)
	mtext(paste("( character strings can be passed to LSD functions as 'colpal' )"),3,0,col="darkgrey")
	
	# heatboxplot #
	
	par(mfrow=c(1,1))
	LSD.show("heatboxplot")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	f = c(rnorm(200),rnorm(200)+4)
	h = rf(500,15,15)*10
	g = rnorm(300)+1
	heatboxplot(list(f=f,g=g),colpals=c("rdpu","greens"),labels=c("bimodal","unimodal"))
	devAskNewPage(ask = TRUE)
	
	
	# intersphere #
	
	par(mfrow=c(1,1))
	LSD.show("intersphere")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	data = list("A" = sample(1:200,100),"B" = sample(1:200,150),"C" = sample(1:200,50),"D" = sample(1:200,75))
	intersphere(data,colors = c("orange","skyblue","green","purple"),expand.circles = 0.5,expand.lims = 0.5)
	devAskNewPage(ask = TRUE)
		
	# align #
	
	homer = list()
	homer[[1]] = c(0,0,0,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
	homer[[2]] = c(0,0,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
	homer[[3]] = c(0,1,1,0,0,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0)
	homer[[4]] = c(1,0,1,1,1,2,2,2,2,2,2,1,1,0,0,0,0,0,0,0,0,0)
	homer[[5]] = c(1,0,1,2,2,2,2,2,2,2,2,2,2,1,0,0,0,0,0,0,0,0)
	homer[[6]] = c(0,1,2,1,2,2,2,2,2,2,2,2,2,2,1,0,0,0,0,0,0,0)
	homer[[7]] = c(0,1,2,2,2,2,2,2,2,2,2,2,2,2,1,0,0,0,0,0,0,0)
	homer[[8]] = c(1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,0,0,0,0,0,0)
	homer[[9]] = c(1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,0,0,0,0)
	homer[[10]] = c(1,2,2,2,2,2,2,2,2,2,1,1,1,1,1,0,0,0,1,0,0,0)
	homer[[11]] = c(1,2,2,2,2,2,2,2,2,1,0,0,0,0,1,0,0,0,0,1,0,0)
	homer[[12]] = c(1,2,2,2,2,2,2,2,1,0,0,0,0,0,0,1,0,1,0,1,0,0)
	homer[[13]] = c(1,2,2,2,2,2,2,2,1,0,0,0,0,0,0,1,0,0,0,1,0,0)
	homer[[14]] = c(0,1,2,2,1,2,2,2,1,0,0,0,1,0,0,1,1,1,1,0,0,0)
	homer[[15]] = c(0,1,2,2,1,1,2,2,2,1,0,0,0,0,1,2,2,2,2,1,0,0)
	homer[[16]] = c(0,1,1,1,2,2,1,2,2,2,1,1,1,1,2,2,2,2,2,1,0,0)
	homer[[17]] = c(0,1,0,1,1,2,2,2,2,2,2,2,2,2,2,1,1,1,1,0,0,0)
	homer[[18]] = c(0,0,0,1,1,1,2,2,2,2,2,2,1,1,1,3,3,3,3,1,0,0)
	homer[[19]] = c(0,0,0,1,2,2,2,2,2,2,2,1,3,3,3,3,3,3,3,3,1,0)
	homer[[20]] = c(0,0,0,1,2,2,1,2,2,2,1,3,3,3,3,3,3,3,3,3,1,0)
	homer[[21]] = c(0,0,0,0,1,1,2,2,2,1,3,3,3,3,3,3,3,3,3,3,3,1)
	homer[[22]] = c(0,0,0,0,0,1,2,2,2,1,3,1,3,3,3,3,3,3,3,3,3,1)
	homer[[23]] = c(0,0,0,0,0,1,2,2,2,1,3,1,1,1,1,1,1,1,1,1,1,0)
	homer[[24]] = c(0,0,0,0,0,1,2,2,2,1,3,3,3,3,3,3,3,1,0,0,0,0)
	homer[[25]] = c(0,0,0,0,0,1,2,2,2,2,1,3,3,3,3,3,1,0,0,0,0,0)
	homer[[26]] = c(0,0,0,0,0,1,2,2,2,2,1,3,3,3,3,3,1,0,0,0,0,0)
	homer[[27]] = c(0,0,0,0,1,1,2,2,2,2,2,1,3,3,3,1,0,0,0,0,0,0)
	homer[[28]] = c(0,0,0,1,0,0,1,1,2,2,2,2,1,1,1,1,1,0,0,0,0,0)
	homer[[29]] = c(0,0,0,1,0,0,0,0,1,1,2,2,2,2,2,1,0,1,0,0,0,0)
	homer[[30]] = c(0,0,1,1,0,0,0,0,0,0,1,1,2,2,2,1,0,0,1,1,0,0)
	homer[[31]] = c(0,1,0,0,1,0,0,0,0,0,0,1,1,2,2,1,0,0,0,1,0,0)
	
	par(mfrow=c(1,1))
	LSD.show("align")
	devAskNewPage(ask = TRUE)
	par(mfrow=c(1,1))
	align(homer,colpal = c("white","black","yellow","wheat3"),main = "D'OH!",asp = 1,axes = FALSE)
	devAskNewPage(ask = TRUE)
	
	# and many more ... #

	par(mfrow=c(1,1))
	LSD.show("and many more ...")
}


### aliases ###


LSD.demotour = demotour

### plotit ###


#' @export
#' @name plotit
#' @aliases LSD.plotit
#' @title Plotting wrapper function to plot plots in printable quality and all kinds of formats
#' @description Plotting wrapper function to save plots in R as "pdf", "ps", "jpeg", "png", "bmp" or "tiff".
#' @param filename name of the plot to be saved with the format type suffix.
#' @param sw scaling factor of weight.
#' @param sh scaling factor of height.
#' @param sres scaling factor of the resolution.
#' @param plotsfkt list of plots to be plotted.
#' @param ww width of window.
#' @param wh height of window.
#' @param pointsize the default pointsize of plotted text, interpreted as big points (1/72 inch) for plots to be saved.
#' @param dev.pointsize pointsize of plotted text, interpreted as big points (1/72 inch) for display in R.
#' @param paper needed only if filformat = "pdf" or "ps".
#' @param quality needed only if filformat = "jpeg".
#' @param units needed only if filformat = "jpeg", "png", "bmp" or "tiff".
#' @param bg backgroundcolor.
#' @param fileformat save the plot as "pdf", "ps", "jpeg", "png", "bmp" or "tiff".
#' @param saveit should plot be saved.
#' @param notinR should plot be not plotted in R.
#' @param addformat should plot be saved additionally in another format ("pdf", "ps", "jpeg", "png", "bmp" or "tiff").
#' @author Bjoern Schwalb
#' @seealso \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples data(homer)
#'
#' plotsfkt = function(){
#' 		colpal = c("white","black","yellow","wheat3")
#' 		align(homer,colpal = colpal,main = "D'OH!",asp = 1,axes = FALSE)
#' }
#'
#' # choose 'saveit = TRUE' for saving the plot in the specified fileformat #
#'
#' # choose 'notinR = TRUE' to suppress plotting in R #
#'
#' plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "jpeg")
#'
#' plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "png")
#'
#' plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "bmp")
#'
#' plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "tiff")
#'
#' plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "ps")
#'
#' plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "pdf")
#' @keywords plot jpeg png bmp tiff ps pdf


plotit = function(filename,sw = 1,sh = 1,sres = 1,plotsfkt,ww = 7,wh = 7,pointsize = 12,dev.pointsize = 8,paper = "special",quality = 100,units = "px",bg = "white",fileformat = "jpeg",saveit = FALSE,notinR = FALSE,addformat = NULL)
{
	
	# switch between different file formats for plot saving (if saveit = TRUE) #
	
	pwidth = sw*480
	pheight = sh*480
	pres = sres*72
	if (saveit){
		switch(fileformat,"jpeg" = jpeg(filename = paste(filename,".",fileformat,sep=""), width = pwidth, height = pheight,units = units, pointsize = pointsize, quality = quality, bg = bg,res = pres),
				"png" = png(filename = paste(filename,".",fileformat,sep=""), width = pwidth, height = pheight,units = units, pointsize = pointsize, bg = bg,res = pres),
				"bmp" = bmp(filename = paste(filename,".",fileformat,sep=""), width = pwidth, height = pheight,units = units, pointsize = pointsize, bg = bg,res = pres),
				"tiff" = tiff(filename = paste(filename,".",fileformat,sep=""), width = pwidth, height = pheight,units = units, pointsize = pointsize, bg = bg,res = pres),
				"ps" = postscript(file = paste(filename,".",fileformat,sep=""), width = ww, height = wh, pointsize = pointsize, paper = paper),
				"pdf" = pdf(file = paste(filename,".",fileformat,sep=""), width = ww, height = wh, pointsize = pointsize, paper = paper))
		plotsfkt()
		dev.off()
	}
	
	# switch between different file formats for additional plot saving (if saveit = TRUE) #
	
	if (saveit){
		if (!is.null(addformat)){
			switch(addformat,"jpeg" = jpeg(filename = paste(filename,".",addformat,sep=""), width = pwidth, height = pheight,units = units, pointsize = pointsize, quality = quality, bg = bg,res = pres),
					"png" = png(filename = paste(filename,".",addformat,sep=""), width = pwidth, height = pheight,units = units, pointsize = pointsize, bg = bg,res = pres),
					"bmp" = bmp(filename = paste(filename,".",addformat,sep=""), width = pwidth, height = pheight,units = units, pointsize = pointsize, bg = bg,res = pres),
					"tiff" = tiff(filename = paste(filename,".",addformat,sep=""), width = pwidth, height = pheight,units = units, pointsize = pointsize, bg = bg,res = pres),
					"ps" = postscript(file = paste(filename,".",addformat,sep=""), width = ww, height = wh, pointsize = pointsize, paper = paper),
					"pdf" = pdf(file = paste(filename,".",addformat,sep=""), width = ww, height = wh, pointsize = pointsize, paper = paper))
			plotsfkt()
			dev.off()
		}
	}
	
	# should plotting be repressed in R (if notinR = TRUE) #
	
	if (!notinR){
		dev.new(width = ww,height = wh,pointsize = dev.pointsize)
		plotsfkt()
	}
}


### alias ###


LSD.plotit = plotit

### linesplot ###


#' @export
#' @name linesplot
#' @aliases LSD.linesplot
#' @title One-dimensional scatterplot
#' @description Visualize one-dimensional data in its every detail.
#' @param x numeric data as vector, matrix, list or data.frame.
#' @param labels a character vector of labels.
#' @param col a R build-in color.
#' @param cols a character vector of R build-in colors.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param xlab x label, standard graphics parameter.
#' @param ylab y label, standard graphics parameter.
#' @param las las=1: horizontal text, las=2: vertical text (x-axis labels).
#' @param outline logical: if \code{TRUE} (by default), outliers are plotted.
#' @param cexbox a numerical value giving the amount by which the boxes should be magnified relative to the default.
#' @param addboxes logical: if \code{TRUE} (\code{FALSE} by default), boxplots be added to the plot.
#' @param border a R build-in color for the box and the whiskers (if \code{addboxes = TRUE}).
#' @param range this determines how far the plot whiskers extend out from the box.
#' @param lwd linewidth of the box and whiskers.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples l = list()
#' for (i in 1:10){l[[i]] = rnorm(100,sqrt(i^2.5),1+i/2)}
#' 
#' linesplot(l,alpha=25,border="darkred",addboxes = TRUE,outline=FALSE)
#' @keywords boxplotlike


linesplot = function(x,labels = NULL,col = "black",cols = NULL,alpha = 25,xlim = NULL,ylim = NULL,xlab = NULL,ylab = "",las = 1,outline = TRUE,cexbox = 0.6,addboxes = FALSE,border = "black",range = 1.5,lwd = 1.5,main = "LSD.linesplot",...)
{
	if (!is.vector(x) & !is.matrix(x) & !is.list(x) & !is.data.frame(x)) stop("x must be a vector, matrix, list or a data.frame!")
	if (!is.list(x) & !is.matrix(x) & !is.data.frame(x)){x = cbind(x)}
	if (is.data.frame(x)){x = as.list(x)}
	if (is.matrix(x)){x = as.list(as.data.frame(x))}
	if (is.null(labels)){labels = labels(x)}
	if (is.null(cols)){cols = rep(convertcolor(col,alpha),length(x))} else{cols = convertcolor(cols,alpha)}
	if (!is.null(xlim)){print("xlim argument will be ignored!")}
	if (is.null(ylim)){ylim = range(unlist(x),na.rm=TRUE)}
	if (!is.null(xlab)){print("xlab argument will be ignored! Use labels instead!")}
	if (length(x) == 1){cexbox = 0.4}
	if (length(x) > 1){boxwex = cexbox} else{boxwex = NULL}
	plot(1,col="white",xlim=c(0.5,length(x)+0.5),ylim=ylim,xlab="",xaxt="n",ylab=ylab,main="",...)
	mtext(paste(main),3,2,cex=1.25)
	par.axis.default = par("cex.axis")
	par(cex.axis = par("cex.lab"))
	axis(1,at=seq(1,length(x),1),labels=labels,las=las)
	for (j in 1:length(x)){segments(j-cexbox/2,x[[j]],j+cexbox/2,x[[j]],lwd=2,col=cols[j])}
	if (addboxes){boxplot(x,add=TRUE,col="transparent",xlim=c(0.5,length(x)+0.5),ylim=ylim,width=NULL,boxwex=boxwex,outline=outline,axes=FALSE,border=border,lwd=lwd,range=range)}                                 
	par(cex.axis = par.axis.default)                                 
}


### aliases ###


LSD.linesplot = linesplot

### plotmatrix ###


#' @export 
#' @name plotmatrix
#' @aliases LSD.plotmatrix
#' @title Visualize two-dimensional data
#' @description Plot the rows of a matrix as lines along the cols.
#' @param input a matrix with numerical entries.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param xlab x lab, standard graphics parameter.
#' @param ylab y lab, standard graphics parameter.
#' @param main title of the plot, standard graphics parameter.
#' @param type what 'type' of plot should be drawn (to be passed to points).
#' @param lwd a positive number giving the line width.
#' @param at a integer vector containing the x-positions corresponding to the columns of 'input'.
#' @param xlabels a character vector containing labels for the x-axis.
#' @param ltys a numeric vector giving the line types for each row of 'input'.
#' @param add logical: if \code{TRUE} (\code{FALSE} by default), lines are added to existing plot.
#' @param cols a character vector of R build-in colors.
#' @param ... additional parameters to be passed to points and plot.
#' @author Achim Tresch, Bjoern Schwalb
#' @seealso \code{\link{clusterplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples len = 20
#' x = sin(seq(0,2*pi,length=len*2))
#' fun = function(){n=sample(1:len,1); return(x[n:(n+len-1)])}
#' input = t(replicate(7,fun(),simplify=TRUE))
#' input = input + rnorm(length(input))/2
#'
#' plotmatrix(input,cols=1:7)
#' @keywords matrix


plotmatrix = function(input,xlim = NULL,ylim = NULL,xlab = "",ylab = "",main = "plotmatrix",type = "l",lwd = 2,at = NULL,xlabels = NULL,ltys = NULL,add = FALSE,cols = NULL,...)
{
	if (!is.matrix(input)) stop("First argument must be a matrix !")
	if (sum(is.na(input)) > 0) print("Be careful: Your data contains NAs ! NA containing rows will be omitted !")
	na.rows = apply(input,1,function(x){!(sum(is.na(x)) > 0)})
	if (!all(na.rows)) stop("Your matrix contains not a single row without NAs !")
	input = input[na.rows,,drop = FALSE]
	if (is.null(at)){at=1:ncol(input)}
	if (is.null(xlabels)){xlabels = at}
	if (is.null(xlim)){xlim = c(1,max(at))}
	if (is.null(ylim)){ylim = range(input)}
	if (is.null(ltys)){ltys = rep(1,nrow(input))}
	if (is.null(cols)) {cols = rep("black", nrow(input))}else {if (length(cols) != nrow(input)) {if(length(cols) < nrow(input)){cols = rep(cols,ceiling(nrow(input)/length(cols)))}
			cols = cols[1:nrow(input)]
			cols[which(is.na(cols))] = "black"
		}
	}
	if(!add){
		plot(c(at[1],median(input)),xlim=xlim,ylim=ylim,type="n",main="",xaxt="n",ylab=ylab,xlab=xlab,...)
		mtext(paste(main),3,2,cex=1.25)
	}
	axis(side=1,at=at,labels=xlabels,...)
	sapply(1:nrow(input),function(x){points(at,input[x,],col=cols[x],lty=ltys[x],type=type,lwd=lwd)})
	points(c(at[1],median(input)),type = "n")
}


### alias ###


LSD.plotmatrix = plotmatrix

### ellipsescatter ###


#' @export
#' @name ellipsescatter
#' @aliases LSD.ellipsescatter
#' @title Visualize subgroups of two-dimensional data assuming normal distributions
#' @description A scatterplot with additional colored ellipses based on a gaussianity assumption.
#' @param x a numeric vector.
#' @param y a numeric vector.
#' @param groups a list of indices or vector names to be plotted as groups (not necessarily all of x and y).
#' @param colors a character vector of R build-in colors corresponding to the chosen groups.
#' @param pch the plotting character (to be passed to plot).
#' @param bgcol a R build-in color for non-grouped points.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param xlab x label, standard graphics parameter.
#' @param ylab y label, standard graphics parameter.
#' @param scalesd a numeric value giving the scaling factor for standard deviations in each dimension (defaults to 1).
#' @param level a numeric value (between 0 and 1) giving the confidence level of a pairwise confidence region.
#' @param legend.cex a numerical value giving the amount by which the added legend should be magnified relative to the default.
#' @param location the x and y co-ordinates to be used to position the legend (see 'xy.coords').
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples x = c(rnorm(50),rnorm(100,2),rnorm(50,4))
#' y = (x + rnorm(200,0,0.8))*rep(c(1,4,1),c(50,100,50))
#' x = sign(x)*abs(x)^1.3
#'	
#' groups = list("Green" = 1:50,"Red" = 51:150,"Blue" = 151:200)
#' colors = c("darkgreen","darkred","darkblue")
#' ellipsescatter(x,y,groups,colors,location = "topleft")
#' @keywords scatterplot


ellipsescatter = function(x,y,groups,colors = NULL,pch = 20,bgcol	= "darkgrey",main = "ellipsescatter",xlab = NULL,ylab = NULL,scalesd = 1,level = 0.75,legend.cex = 1,location = "topright",...)
{	
	if(is.null(names(groups))){names(groups) = 1:dim(summary(groups))[1]}
	grouplength = length(names(groups))
	if(is.null(colors)){colors = 1:grouplength}
	ellipse.coordinates = function(r,scale = c(1,1),centre = c(0,0),level = 0.95,t = sqrt(qchisq(level,2)))
	{
		r = min(max(r,-1),1)
		d = acos(r)
		a = seq(0,2*pi,len = 100)
		matrix(c(t*scale[1]*cos(a + d/2) + centre[1],t*scale[2]*cos(a - d/2) + centre[2]),100,2,dimnames = list(NULL,c("x","y")))
	}
	add.ellipses = function(x,y,col)
	{
		points(x,y,col=col,pch=pch)
        points(ellipse.coordinates(round(cor(x,y,method="spearman",use="na.or.complete"),digits=2),scale=c(sd(x,na.rm=TRUE)*scalesd,sd(y,na.rm=TRUE)*scalesd),centre=c(mean(x,na.rm=TRUE),mean(y,na.rm=TRUE)),level=level),type = 'l',col=col,lwd=3)
	}
	if (is.null(xlab)){xlab = deparse(substitute(x))}
	if (is.null(ylab)){ylab = deparse(substitute(y))}
	plot(x,y,pch=pch,col=bgcol,ylab = ylab,xlab = xlab,main="",...)
	mtext(paste(main),3,2,cex=1.25)
	legendtext = c()
	for (k in 1:grouplength){
		add.ellipses(x[groups[[k]]],y[groups[[k]]],col=colors[k])
		legendtext = c(legendtext,paste(names(groups)[k]," (",length(x[groups[[k]]][!is.na(x[groups[[k]]])]),")",sep=""))
	}
	legend(location,legendtext,pt.bg=colors,col=rep("black",grouplength),bg="white",pch=21,cex=legend.cex,inset=0.01)
}	


### aliases ###


LSD.ellipsescatter = ellipsescatter

### intersphere ###


#' @export
#' @name intersphere
#' @aliases LSD.intersphere
#' @title Intersphere: a fancy Venn diagram
#' @description Create circles for visualizing overlaps between up to 4 datasets.
#' @param data a list with n entries having elements that can be represented as sets (have union and intersect methods).
#' @param colors a character vector of  R build-in colors for circles representing different sets.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param cex a numeric value giving the character expansion factor for intersect size text inside each circle.
#' @param expand.circles a numeric value giving the expansion factor of circles (multiplicative).
#' @param expand.lims a numeric value giving the expansion of x and y limits (additive).
#' @param main title(s) of the plot, standard graphics parameter.
#' @param onlySets vectors, which n-overlaps should be shown, default to all 1 < n < length(data).
#' @author Sebastian Duemcke, Bjoern Schwalb
#' @seealso \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples data = list(
#' 	"A" = sample(1:200,100),
#' 	"B" = sample(1:200,150),
#' 	"C" = sample(1:200,50))
#' 
#' intersphere(data,colors = c("orange","skyblue","green"))
#' 
#' data = list(
#' 	"A" = sample(1:200,100),
#' 	"B" = sample(1:200,150),
#' 	"C" = sample(1:200,50),
#' 	"D" = sample(1:200,75))
#' 
#' colors = c("orange","skyblue","green","purple")
#' intersphere(data,colors,expand.circles = 0.5,expand.lims = 0.5)
#' @keywords intersphere Venn


intersphere = function(data,colors = NULL,alpha = 25,cex = 1,expand.circles = 1,expand.lims = 1.5,main = "intersphere: overlap diagram",onlySets = seq(length(data),2,by=-1))
{
    
    # number of cicles and overlap sizes #
    
    nb.circles = 2^length(data) - 1
    get.n.overlap = function(n,data){combn(1:length(data),n,FUN=function(x,d){length(Reduce(intersect,d[x]))},simplify=TRUE,data)}
    get.overlap.size = function(d,...){length(Reduce(intersect,d[...]))}
    circle.sizes = unlist(lapply(1:length(data),get.n.overlap,data))
    stopifnot(length(circle.sizes) == nb.circles)
    
    # scale of the radii #
    
    radius.scale = max(circle.sizes)/expand.circles
    radius.scale[radius.scale == 0] = 1
    
    # default colors #
    
    if(is.null(colors)){colors = distinctcolors(nb.circles)}
    
    # get coordinates of points on unit circle (original sets) #
    
    xcoor = cos(seq(0, 2 * pi , length = length(data)+1)+pi/4)/0.5
    ycoor = sin(seq(0, 2 * pi , length = length(data)+1)+pi/4)/0.5
    coords = cbind(xcoor,ycoor)
    
    # define plotting region #
    
    xmax = max(xcoor)
    ymax = max(ycoor)
    plot(0,type="n",axes=FALSE,xlim=c(-xmax-expand.lims,xmax+expand.lims),ylim=c(-ymax-expand.lims,ymax+expand.lims),ylab="",xlab="",main="")
    mtext(paste(main),3,2,cex=1.25)
    
	# draw.circles function #
	
	draw.circles = function(x,y,radius,border = "black",col = "white"){
		roots = seq(0,2*pi - 2*pi/100,by = 2*pi/100)
		for (circle in 1:length(radius)){
			xv = cos(roots)*radius[circle] + x[circle]
			yv = sin(roots)*radius[circle] + y[circle]
			polygon(xv,yv,border = border,col = col[circle])
		}
	}
	
    # draw function #
    
    draw = function(points,coords,data){
        mass = apply(coords[points,],2,sum) / length(points)
        # shift mass point. new mass = third of way between center and pairwise intersect of neighbouring #
        if(length(points) == 2 && abs(points[1] - points[2]) == 2 && length(data) != 3){
            mass = ((apply(coords[1:length(data),],2,sum) / length(data)) + (apply(coords[c(points[1],points[1]+1),],2,sum) / 2)) * 0.8
        }
        # draw line segments to mass point in same color as origin #
        sapply(points,function(p){points(rbind(coords[p,],mass),col=colors[p],type="l")})
        # draw mass points #
        draw.circles(mass[1],mass[2],r=sqrt(get.overlap.size(data,points)/(pi*radius.scale)),col="white",border="black")
        draw.circles(mass[1],mass[2],r=sqrt(get.overlap.size(data,points)/(pi*radius.scale)),col=convertcolor("grey50",alpha),border="grey50")
        # add text #
        text(mass[1],mass[2],labels=get.overlap.size(data,points),cex=cex)
    }
    
    # draw mass points, line segments and text #
    
    sapply(onlySets,function(n,draw,coords,data){combn(1:length(data),n,FUN=draw,simplify=FALSE,coords,data)},draw,coords,data)
    sapply(1:length(data),function(p){draw.circles(coords[p,1],coords[p,2],r=sqrt(length(data[[p]])/(pi*radius.scale)),col="white",border="black")})
    sapply(1:length(data),function(p){draw.circles(coords[p,1],coords[p,2],r=sqrt(length(data[[p]])/(pi*radius.scale)),col=convertcolor(colors[p],alpha),border=colors[p])})
    sapply(1:length(data),function(p){text(coords[p,1],coords[p,2],labels=length(data[[p]]),cex=cex)})
    
    # return invisible #
    
    invisible()
}


### aliases ###


LSD.intersphere = intersphere

### singleclusterplot ###


#' @export
#' @name singleclusterplot
#' @aliases LSD.singleclusterplot
#' @title Visualize two-dimensional data clusters (add to an existing plot)
#' @description Depict a numeric matrix or list utilizing the underlying distribution quantiles of one dimension in a color encoded fashion (add to an existing plot).
#' @param input matrix or list with numerical entries.
#' @param at a integer vector containing the x-positions corresponding to the columns of 'input'.
#' @param fromto a numeric vector containing the range of quantiles (between 0 and 1) to be plotted.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 25, if not specified).
#' @param outer.col R built-in color to be used for outlier lines (lines outside of 'fromto').
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param quartiles.col a character vector containing three R built-in colors for quartile lines (c('0.25','0.5','0.75')).
#' @param add.quartiles logical: if \code{TRUE} (by default), lines are plotted corresponding to the quartiles.
#' @author Achim Tresch, Bjoern Schwalb
#' @seealso \code{\link{clusterplot}}, \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples samples = 100
#' probes = 200
#' clus = matrix(rnorm(probes*samples,sd=1),ncol=probes)
#' 
#' clus = rbind(
#' 	t(t(clus)+sin(1:probes/10))+1:nrow(clus)/samples,
#' 	t(t(clus)+sin(pi/2+1:probes/10))+1:nrow(clus)/samples)
#' 
#' emptyplot(xlim = c(1,ncol(clus)),ylim = range(clus))
#' singleclusterplot(clus)
#' axis(1)
#' axis(2)
#' box()
#' @keywords cluster


singleclusterplot = function(input,at = NULL,fromto = c(0.05,0.95),colpal = "standardheat",simulate = FALSE,daltonize = FALSE,cvd = "p",nrcol = 25,outer.col = "lightgrey",rev = FALSE,alpha = NULL,quartiles.col = c("grey","black","grey"),add.quartiles = TRUE)
{
	# stops execution, if 'input' is neither a list nor a matrix and executes an error action #
	
	if (!is.matrix(input) & !is.list(input)) stop("'input' must be a matrix or a list !")
	
	# define x-positions corresponding to the columns/elements of 'input' #
	
	if (is.null(at)) if (is.matrix(input)){at=1:ncol(input)} else if (is.list(input)){at=1:length(input)}
	
	# preliminaries #
	
	probes = length(at)
	
	# wrapper for the lines function #
	
	drawline = function(y,col="black",lwd=1,lty=1){lines(at[1:length(y)],y,type="l",col=col,lwd=lwd,lty=lty)}
	
	# optional drawing of outlier lines #
	
	if (is.matrix(input)){if (outer.col!="none") apply(input,1,drawline,col=outer.col)}
	
	# provide 'colpal' via colorpalette #
	
	colpal = colorpalette(colpal,nrcol,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev)
	colpal = c(rev(colpal),colpal)

	# determine quantiles among columns/elements of 'input' #

	if (is.matrix(input)){
		qline = apply(input,2,quantile,probs=seq(fromto[1],fromto[2],length=(length(colpal)+1)),na.rm=TRUE)
	} else if (is.list(input)){
		qline = lapply(input,quantile,probs=seq(fromto[1],fromto[2],length=(length(colpal)+1)),na.rm=TRUE)
		qline = sapply(qline,c)
	}
	
	# plot polygons according to qline #

	for (j in 1:length(colpal)){polygon(at[c(1:probes,probes:1)],c(qline[j,],qline[j+1,probes:1]),col = colpal[j],lty=0)}
	
	# add lines corresponding to the quartiles #

	if (add.quartiles){
		if (is.matrix(input)){
			drawline(apply(input,2,quantile,probs=0.5,na.rm=TRUE),col=quartiles.col[2],lwd=2)
			drawline(apply(input,2,quantile,probs=0.25,na.rm=TRUE),col=quartiles.col[1],lwd=2)
			drawline(apply(input,2,quantile,probs=0.75,na.rm=TRUE),col=quartiles.col[3],lwd=2)
		} else if (is.list(input)){
			drawline(sapply(input,quantile,probs=0.5,na.rm=TRUE),col=quartiles.col[2],lwd=2)
			drawline(sapply(input,quantile,probs=0.25,na.rm=TRUE),col=quartiles.col[1],lwd=2)
			drawline(sapply(input,quantile,probs=0.75,na.rm=TRUE),col=quartiles.col[3],lwd=2)
			
		}
	}
}


# alias #


LSD.singleclusterplot = singleclusterplot


### clusterplot ###


#' @export
#' @name clusterplot
#' @aliases LSD.clusterplot
#' @title Visualize two-dimensional data clusters
#' @description Depict a numeric matrix or list utilizing the underlying distribution quantiles of one dimension in a color encoded fashion.
#' @param input matrix or list with numerical entries.
#' @param label a character vector assigning rows/elements of 'input' to clusters (if specified, multiple clusters can be depicted in different colors and/or subsequent plots).
#' @param at a integer vector containing the x-positions corresponding to the columns of 'input'.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param xlabels a character vector containing labels for the x-axis.
#' @param fromto a numeric vector containing the range of quantiles (between 0 and 1) to be plotted.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 25, if not specified).
#' @param outer.col R built-in color to be used for outlier lines (lines outside of 'fromto').
#' @param quartiles.col a character vector containing three R built-in colors for quartile lines (c('0.25','0.5','0.75')).
#' @param add.quartiles logical: if \code{TRUE} (by default), lines are plotted corresponding to the quartiles.
#' @param separate if \code{TRUE} (by default), different clusters are depicted in subsequent plots.
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param size logical: if \code{TRUE} (by default), the size of each cluster is added to the title of the respective plot.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param axes logical: if \code{TRUE} (by default), a box and axes are added to the plot (if \code{FALSE}, custom specification of axes can be achieved via basic R graphics functions).
#' @param ... additional parameters to be passed to points and plot.
#' @author Achim Tresch, Bjoern Schwalb
#' @seealso \code{\link{singleclusterplot}}, \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples samples = 100
#' probes = 75
#' at = 1:probes
#' clus = matrix(rnorm(probes*samples,sd=1),ncol=probes)
#' 
#' clus = rbind(
#' 	t(t(clus)+sin(1:probes/10))+1:nrow(clus)/samples,
#' 	t(t(clus)+sin(pi/2+1:probes/10))+1:nrow(clus)/samples)
#' 
#' quartiles.col = c("transparent","black","transparent")
#' colpal = c("standardheat","crazyblue","crazyred","crazygreen")
#' 
#' labs = paste("cluster",kmeans(clus,4)$cluster)
#' clusterplot(clus,fromto=c(0,1))
#' 
#' clusterplot(clus,labs,separate=FALSE,xaxt="n",fromto=c(0.4,0.6),colpal=colpal,
#' 	outer.col="none",ylim=c(-2,3),quartiles.col = quartiles.col)
#'  
#' clusterplot(clus,labs,colpal=colpal)
#' 
#' labs = paste("cluster",kmeans(clus,2)$cluster)
#' colpal = c("greens","purples")
#' clusterplot(clus,labs,separate=FALSE,xaxt="n",fromto=c(0.3,0.7),colpal=colpal,
#' 	outer.col="none",ylim=c(-1,2),alpha=50,quartiles.col = quartiles.col)
#' @keywords cluster


clusterplot = function(input,label = NULL,at = NULL,main = NULL,xlim = NULL,ylim = NULL,xlabels = NULL,fromto = c(0.05,0.95),colpal = "standardheat",simulate = FALSE,daltonize = FALSE,cvd = "p",nrcol = 25,outer.col = "lightgrey",quartiles.col = c("grey","black","grey"),add.quartiles = TRUE,separate = TRUE,rev = FALSE,size = TRUE,alpha = NULL,axes = TRUE,...)
{
	# stops execution, if 'input' is neither a list nor a matrix and executes an error action #
	
	if (!is.matrix(input) & !is.list(input)) stop("'input' must be a matrix or a list !")
	
	# define x-positions corresponding to the columns of 'input' #
	
	if (is.null(at)) if (is.matrix(input)){at=1:ncol(input)} else if (is.list(input)){at=1:length(input)}	
	
	# preliminaries #
	
	probes = length(at)
	if (is.null(xlim)){xlim=c(min(at),max(at))}
	maxp = xlim[2]
	minp = xlim[1]
	if (is.null(ylim)) if (is.matrix(input)){ylim=c(min(input,na.rm=TRUE),max(input,na.rm=TRUE))} else if (is.list(input)){ylim=c(min(unlist(input),na.rm=TRUE),max(unlist(input),na.rm=TRUE))}
	if (is.null(xlabels)) xlabels = 1:length(at)

	# one cluster (i.e. one plot), if label = NULL #
	
	if (is.null(label)){
		plot.new()
		plot.window(xlim = xlim,ylim = ylim,...)
		if (size){
			if (is.matrix(input)){
				main = paste(main,"  ( #",nrow(input)," )")
			} else if (is.list(input)){
				input.length.range = range(as.numeric(summary(input)[,"Length"]))
				main = paste(main,"  ( #",input.length.range[1],"-",input.length.range[2]," )")
			}
		}
		title(main)
		if (axes){
			axis(1,at=at,labels=xlabels,...)
			axis(2)
			box()
		}
		singleclusterplot(input=input,at=at,fromto=fromto,colpal=colpal,simulate=simulate,daltonize=daltonize,cvd=cvd,nrcol=nrcol,outer.col=outer.col,add.quartiles=add.quartiles,quartiles.col=quartiles.col,rev=rev,alpha=alpha)
	}

	# multiple clusters, if label is specified #
	
	if (!is.null(label)) {
		clusternames = sort(unique(label))
		nrclusters = length(clusternames)
		if (!is.matrix(input)) stop("'input' must be a matrix, if 'label' is specified !")
		clustersets = split(1:nrow(input), factor(label))
		if (!is.list(colpal)) colpal = as.list(colpal)
		if (length(colpal) < nrclusters) colpal = rep(colpal, nrclusters)
		
		# multiple clusters in one plots #
		
		if (separate == FALSE){
			plot.new()
			plot.window(xlim = xlim,ylim = ylim,...)
			if (size){main = paste(main,"  ( #",nrow(input)," )")}
			title(main)
			if (axes){
				axis(1,at=at,labels=xlabels,...)
				axis(2)
				box()
			}
		}
		
		# multiple clusters in subsequent plots #
	
		if (separate == TRUE) par(mfrow = windowxy(nrclusters))
		for (j in seq(clusternames)){
			if (separate == TRUE){
				if (length(main) == length(clustersets[[j]])) clustermain = main[j]	else clustermain = paste(main,clusternames[j])
				plot.new()
				plot.window(xlim = xlim,ylim = ylim,...)
				if (size){clustermain = paste(clustermain,"  ( #",length(clustersets[[j]])," )")}
				title(clustermain)
				if (axes){
					axis(1,at=at,labels=xlabels,...)
					axis(2)
					box()
				}
			}
			singleclusterplot(input=input[clustersets[[j]],,drop = FALSE],at=at,fromto=fromto,colpal=colpal[[j]],simulate=simulate,daltonize=daltonize,cvd=cvd,nrcol=nrcol,outer.col=outer.col,add.quartiles=add.quartiles,quartiles.col=quartiles.col,rev=rev,alpha=alpha)
		}
	}
}


# alias #


LSD.clusterplot = clusterplot

### singlefusionplot ###


#' @export
#' @name singlefusionplot
#' @aliases LSD.singlefusionplot
#' @title Visualize two-dimensional data clusters (add to an existing plot)
#' @description Depict a numeric matrix or list utilizing the underlying distribution quantiles of one dimension in a color encoded fashion (add to an existing plot).
#' @param x a numeric vector.
#' @param y a numeric vector.
#' @param fromto a numeric vector containing the range of quantiles (between 0 and 1) to be plotted.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 25, if not specified).
#' @param outer.col R built-in color to be used for outlier lines (lines outside of 'fromto').
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param quartiles.col a character vector containing three R built-in colors for quartile lines (c('0.25','0.5','0.75')).
#' @param add.quartiles logical: if \code{TRUE} (by default), lines are plotted corresponding to the quartiles.
#' @author Achim Tresch, Bjoern Schwalb
#' @seealso \code{\link{fusionplot}}, \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples x = 1:1000/300
#' y = rnorm(1000)+sin(2*x)*3
#' 
#' emptyplot(xlim = range(x),ylim = range(y))
#' singlefusionplot(x,y,colpal = "ylgnbu")
#' axis(1)
#' axis(2)
#' box()
#' @keywords cluster


singlefusionplot = function(x,y,fromto = c(0.05,0.95),colpal = "standardheat",simulate = FALSE,daltonize = FALSE,cvd = "p",nrcol = 25,outer.col = "grey",rev = FALSE,alpha = NULL,quartiles.col = c("grey","black","grey"),add.quartiles = TRUE)
{
	# kernel function #
	
	kernelf = function(y0,x0,x,y,width=0.1){
		wx = 1/sqrt(2*pi)/width*exp(-(x0-x)^2/width^2/2)
		res = sum(wx[y<=y0]) / sum(wx)
		return(res)
	}
	
	# quantile function #
	
	quantf = function(x0,x,y,width=0.1,quantvector=seq(0,1,length=5)){
		y0 = seq(min(y),max(y),length=100)
		quants = sapply(y0,kernelf,x0,x,y,width)
		hilf = approxfun(quants,y0,rule=2)
		return(hilf(quantvector))
	}
	
	# calculate quantiles #
	
	xseq = seq(min(x),max(x),length=200)
	nrquants=2*nrcol
	quantvector = seq(fromto[1],fromto[2],length=nrquants)
	
	qline = sapply(xseq,quantf,x,y,width=0.1,quantvector=quantvector)
	
	# provide 'colpal' via colorpalette #
	
	colpal = colorpalette(colpal,nrcol,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev)
	colpal = c(rev(colpal),colpal)
	
	quantvec = seq(0,1,length=nrquants)
	
	for (j in 1:(nrquants - 1)){
		polygon(c(xseq,rev(xseq)),c(qline[j,],rev(qline[j+1,])),col = colpal[j],lty = 0)
	}
	points(x,y,col = outer.col,pch = 19,cex = 0.3)
	
	# wrapper for the lines function #
	
	drawline = function(y,col="black",lwd=1,lty=1){lines(xseq,y,type="l",col=col,lwd=lwd,lty=lty)}
	
	# add lines corresponding to the quartiles #
	
	if (add.quartiles){
		quantvector = seq(0.25,0.75,length=3)
		qline = sapply(xseq,quantf,x,y,width=0.1,quantvector=quantvector)
		
		drawline(qline[2,],col=quartiles.col[2],lwd=2)
		drawline(qline[1,],col=quartiles.col[1],lwd=2)
		drawline(qline[3,],col=quartiles.col[3],lwd=2)
	}
}


# alias #


LSD.singlefusionplot = singlefusionplot


### fusionplot ###


#' @export
#' @name fusionplot
#' @aliases LSD.fusionplot
#' @title Visualize two-dimensional data clusters
#' @description Depict a numeric matrix or list utilizing the underlying distribution quantiles of one dimension in a color encoded fashion.
#' @param x a numeric vector.
#' @param y a numeric vector.
#' @param label a character vector assigning rows/elements of 'input' to clusters (if specified, multiple clusters can be depicted in different colors and/or subsequent plots).
#' @param main title(s) of the plot, standard graphics parameter.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param fromto a numeric vector containing the range of quantiles (between 0 and 1) to be plotted.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 25, if not specified). 
#' @param outer.col R built-in color to be used for outlier lines (lines outside of 'fromto').
#' @param quartiles.col a character vector containing three R built-in colors for quartile lines (c('0.25','0.5','0.75')).
#' @param add.quartiles logical: if \code{TRUE} (by default), lines are plotted corresponding to the quartiles.
#' @param separate if \code{TRUE} (by default), different clusters are depicted in subsequent plots.
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param size logical: if \code{TRUE} (by default), the size of each cluster is added to the title of the respective plot.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param axes logical: if \code{TRUE} (by default), a box and axes are added to the plot (if \code{FALSE}, custom specification of axes can be achieved via basic R graphics functions).
#' @param ... additional parameters to be passed to points and plot.
#' @author Achim Tresch, Bjoern Schwalb
#' @seealso \code{\link{singlefusionplot}}, \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples nr = 750
#' x = 1:nr/300
#' y = c(rnorm(nr)+sin(2*x)*3,rnorm(nr)+sin(2*x+pi/2)*3)
#' x = c(x,x)
#' 
#' labs = paste("cluster",c(rep(c(1,2),each = nr)))
#' colpals = c("oranges","pubu")
#' qcol = c("transparent","black","transparent")
#' fusionplot(x,y,labs,separate=FALSE,colpal=colpals,alpha=75,quartiles.col = qcol)
#' @keywords cluster


fusionplot = function(x,y,label = NULL,main = NULL,xlim = NULL,ylim = NULL,fromto = c(0.05,0.95),colpal = "standardheat",simulate = FALSE,daltonize = FALSE,cvd = "p",nrcol = 25,outer.col = "lightgrey",quartiles.col = c("grey","black","grey"),add.quartiles = TRUE,separate = TRUE,rev = FALSE,size = TRUE,alpha = NULL,axes = TRUE,...)
{
	if (is.null(xlim)){xlim=c(min(x),max(x))}
	maxp = xlim[2]
	minp = xlim[1]
	if (is.null(ylim)){ylim=c(min(y),max(y))}
	
	# one cluster (i.e. one plot), if label = NULL #
	
	if (is.null(label)){
		plot.new()
		plot.window(xlim = xlim,ylim = ylim,...)
		if (size){
			main = paste(main,"  ( #",length(x)," )")
		}
		title(main)
		if (axes){
			axis(1,...)
			axis(2)
			box()
		}
		singlefusionplot(x=x,y=y,fromto=fromto,colpal=colpal,simulate=simulate,daltonize=daltonize,cvd=cvd,nrcol=nrcol,outer.col=outer.col,add.quartiles=add.quartiles,quartiles.col=quartiles.col,rev=rev,alpha=alpha)
	}
	
	# multiple clusters, if label is specified #
	
	if (!is.null(label)) {
		clusternames = sort(unique(label))
		nrclusters = length(clusternames)
		clustersets = split(1:length(x), factor(label))
		if (!is.list(colpal)) colpal = as.list(colpal)
		if (length(colpal) < nrclusters) colpal = rep(colpal, nrclusters)
		
		# multiple clusters in one plots #
		
		if (separate == FALSE){
			plot.new()
			plot.window(xlim = xlim,ylim = ylim,...)
			if (size){main = paste(main,"  ( #",length(x)," )")}
			title(main)
			if (axes){
				axis(1,...)
				axis(2)
				box()
			}
		}
		
		# multiple clusters in subsequent plots #
		
		if (separate == TRUE) par(mfrow = windowxy(nrclusters))
		for (j in seq(clusternames)){
			if (separate == TRUE){
				if (length(main) == length(clustersets[[j]])) clustermain = main[j]	else clustermain = paste(main,clusternames[j])
				plot.new()
				plot.window(xlim = xlim,ylim = ylim,...)
				if (size){clustermain = paste(clustermain,"  ( #",length(clustersets[[j]])," )")}
				title(clustermain)
				if (axes){
					axis(1,...)
					axis(2)
					box()
				}
			}
			singlefusionplot(x=x[clustersets[[j]]],y=y[clustersets[[j]]],fromto=fromto,colpal=colpal[[j]],simulate=simulate,daltonize=daltonize,cvd=cvd,nrcol=nrcol,outer.col=outer.col,add.quartiles=add.quartiles,quartiles.col=quartiles.col,rev=rev,alpha=alpha)
		}
	}
}


# alias #


LSD.fusionplot = fusionplot

### heatscatterpoints ###


#' @export
#' @name heatscatterpoints
#' @aliases LSD.heatscatterpoints
#' @title A colored scatterplot based on a two-dimensional Kernel Density Estimation (add to an existing plot)
#' @description Visualize two dimensional data in a three dimensional fashion facilitating a color encoded Kernel Density Estimation (add to an existing plot).
#' @param x a numeric vector.
#' @param y a numeric vector.
#' @param pch plotting 'character'. This can either be a single character or an integer code for one of a set of graphics symbols. (see '?pch', to be passed to plot).
#' @param cexplot a numerical value giving the amount by which the points should be magnified relative to the default.
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).
#' @param grid an integer specifying the size of the grid used for the KDE.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope). 
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param only a character string which contains 'x' if the density should only be computed for the x axis, 'y' for the y axis (defaults to 'none' for the two-dimensional case).
#' @param add.contour logical: if \code{TRUE} (\code{FALSE} by default), the contour lines are added to the plot.
#' @param nlevels an integer giving the number of levels of the contour lines.
#' @param color.contour R build-in color for the contour lines.
#' @param greyscale logical: if \code{TRUE} (\code{FALSE} by default), the used colorpalette is converted to greyscales.
#' @param log a character string which contains "x" if the x axis is to be logarithmic, "y" if the y axis is to be logarithmic and "xy" or "yx" if both axes are to be logarithmic.
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @note Two-Dimensional Kernel Density Estimation adapted and modified from Venables and Ripley's MASS package (see reference).
#' @references Venables, W. N. and Ripley, B. D. (2002) \emph{Modern Applied Statistics with S.} Fourth edition. Springer.
#' @examples points = 10^4
#' x = c(rnorm(points/2),rnorm(points/2)+4)
#' y = x + rnorm(points,sd=0.8)
#' x = sign(x)*abs(x)^1.3
#' 
#' plot.new()
#' plot.window(xlim = c(-5,15),ylim = c(-4,8))
#' heatscatterpoints(x,y,add.contour=TRUE,color.contour="green",greyscale=TRUE)
#' axis(1)
#' axis(2)
#' box()
#' @keywords scatterplot heatcolors


heatscatterpoints = function(x,y,pch = 19,cexplot = 0.5,nrcol = 30,grid = 100,colpal = "heat",simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,rev = FALSE,xlim = NULL,ylim = NULL,only = "none",add.contour = FALSE,nlevels = 10,color.contour = "black",greyscale = FALSE,log = "",...)
{
	# soundcheck #
	
	if (!is.vector(x) | !is.vector(y)) stop("First two argument must be numeric vectors!")
	if (length(x) != length(y)) stop("Data vectors must be of the same length!")
	sound = which((!(is.na(x)|is.nan(x)|(x==Inf)|(x==-Inf))) & (!(is.na(y)|is.nan(y)|(y==Inf)|(y==-Inf))))
	if (length(sound)==0) stop("There are no valid point pairs to plot!")
	x = x[sound]
	y = y[sound]
	if (!is.null(xlim)){cut = x >= xlim[1] & x <= xlim[2]
	x = x[cut]
	y = y[cut]
	}
	if (!is.null(ylim)){cut = y >= ylim[1] & y <= ylim[2]
	y = y[cut]
	x = x[cut]
	}
	
	# color handling #
	
	colpal = colorpalette(colpal,nrcol,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev)
	if (greyscale){colpal = convertgrey(colpal)}
	
	# binninmg function #
	
	todiscrete = function(t,tmin,tmax,bins){
		erg = round((t-tmin)/(tmax-tmin)*bins+0.5)
		erg = pmin(pmax(erg,1),bins)
		return(erg)
	}
	
	# kde2d.adj function: adapted and modified from Venables and Ripley's MASS package (distributed under the GPL-2 | GPL-3 license, https://cran.r-project.org/web/packages/MASS/index.html) #
	
	kde2d.adj = function(x,y,h,n = 25,lims = c(range(x),range(y)),only = "none"){
		nx = length(x)
		gx = seq.int(lims[1],lims[2],length.out = n)
		gy = seq.int(lims[3],lims[4],length.out = n)
		bandwidth.nrd.adj = function(x) 
		{
			r = quantile(x,c(0.25,0.75))
			h = (r[2] - r[1])/1.34
			return(4*1.06*min(sqrt(var(x)),h)*length(x)^(-1/5))
		}
		if (missing(h)) {
			bx = bandwidth.nrd.adj(x)
			by = bandwidth.nrd.adj(y)
			if (all(c(bx,by) == 0)){h = rep(0.01,2)} else if (any(c(bx,by) == 0)){h = rep(max(bx,by),2)} else {h = c(bx,by)}
		} else h = rep(h,length.out = 2)
		h = h/4
		ax = outer(gx,x,"-")/h[1]
		ay = outer(gy,y,"-")/h[2]
		norm.ax = dnorm(ax)
		norm.ay = dnorm(ay)
		if (only == "x"){norm.ay = rep(1,length(ay))}
		if (only == "y"){norm.ax = rep(1,length(ax))}
		z = tcrossprod(matrix(norm.ax,,nx),matrix(norm.ay,,nx))/(nx*h[1]*h[2])
		list(x = gx,y = gy,z = z)
	}
	
	# handle 'log' option #
	
	if (log == ""){
		xlog = x
		ylog = y
	} else if (log == "x"){
		xlog = log(x,10)
		ylog = y
	} else if (log == "y"){
		xlog = x
		ylog = log(y,10)
	} else if (log %in% c("xy","yx")){
		xlog = log(x,10)
		ylog = log(y,10)
	}
	
	# estimate two-dimensional KDE for color encoding #

	d = kde2d.adj(xlog,ylog,n=grid,only=only)
	
	# binning #

	xdiscrete = todiscrete(xlog,min(xlog),max(xlog),bins=grid)
	ydiscrete = todiscrete(ylog,min(ylog),max(ylog),bins=grid)
	
	# color assignment #

	getfrommat = function(a){d$z[a[1],a[2]]}
	heatvec = unlist(apply(cbind(xdiscrete,ydiscrete),1,getfrommat))
	coldiscrete = todiscrete(heatvec,min(d$z),max(d$z),bins=nrcol)
	
	# add to existing graphics device #

	points(x,y,col=colpal[coldiscrete],pch=pch,cex=cexplot,...)
	
	# handle 'add.contour' option #

	if (add.contour){contour(d,add=TRUE,nlevels=nlevels,col=color.contour)}
}


### aliases ###


LSD.heatscatterpoints = heatscatterpoints


### heatscatter ###


#' @export
#' @name heatscatter
#' @aliases LSD.heatscatter
#' @title A colored scatterplot based on a two-dimensional Kernel Density Estimation
#' @description Visualize two dimensional data in a three dimensional fashion facilitating a color encoded Kernel Density Estimation.
#' @param x a numeric vector.
#' @param y a numeric vector.
#' @param pch plotting 'character'. This can either be a single character or an integer code for one of a set of graphics symbols. (see '?pch', to be passed to plot).
#' @param cexplot a numerical value giving the amount by which the points should be magnified relative to the default.
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).
#' @param grid an integer specifying the size of the grid used for the KDE.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param xlab x labels, standard graphics parameter.
#' @param ylab y labels, standard graphics parameter.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param cor logical: if \code{TRUE} (\code{FALSE} by default), the correlation is added to the title.
#' @param method a character specifying the correlation method to use ('spearman' (default), 'pearson' or 'kendall').
#' @param only a character string which contains 'x' if the density should only be computed for the x axis, 'y' for the y axis (defaults to 'none' for the two-dimensional case).
#' @param add.contour logical: if \code{TRUE} (\code{FALSE} by default), the contour lines are added to the plot.
#' @param nlevels an integer giving the number of levels of the contour lines.
#' @param color.contour R build-in color for the contour lines.
#' @param greyscale logical: if \code{TRUE} (\code{FALSE} by default), the used colorpalette is converted to greyscales.
#' @param log a character string which contains "x" if the x axis is to be logarithmic, "y" if the y axis is to be logarithmic and "xy" or "yx" if both axes are to be logarithmic.
#' @param ... additional parameters to be passed to points and plot.
#' @author Achim Tresch, Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @note Two-Dimensional Kernel Density Estimation adapted and modified from Venables and Ripley's MASS package (see reference).
#' @references Venables, W. N. and Ripley, B. D. (2002) \emph{Modern Applied Statistics with S.} Fourth edition. Springer.
#' @examples points = 10^4
#' x = c(rnorm(points/2),rnorm(points/2)+4)
#' y = x + rnorm(points,sd=0.8)
#' x = sign(x)*abs(x)^1.3
#' 
#' heatscatter(x,y)
#' 
#' heatscatter(x,y,colpal="bl2gr2rd",main="bl2gr2rd",cor=FALSE)
#' 
#' heatscatter(x,y,cor=FALSE,add.contour=TRUE,color.contour="red",greyscale=TRUE)
#' 
#' heatscatter(x,y,colpal="spectral",cor=FALSE,add.contour=TRUE)
#' @keywords scatterplot heatcolors


heatscatter = function(x,y,pch = 19,cexplot = 0.5,nrcol = 30,grid = 100,colpal = "heat",simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,rev = FALSE,xlim = NULL,ylim = NULL,xlab = NULL,ylab = NULL,main = "heatscatter",cor = FALSE,method = "spearman",only = "none",add.contour = FALSE,nlevels = 10,color.contour = "black",greyscale = FALSE,log = "",...)
{
	# parse variable names #
	
	if (is.null(xlab)){xlab = deparse(substitute(x))}
	if (is.null(ylab)){ylab = deparse(substitute(y))}
	
	# soundcheck #
	
	if (!is.vector(x) | !is.vector(y)) stop("First two argument must be numeric vectors!")
	if (length(x) != length(y)) stop("Data vectors must be of the same length!")
	sound = which((!(is.na(x)|is.nan(x)|(x==Inf)|(x==-Inf))) & (!(is.na(y)|is.nan(y)|(y==Inf)|(y==-Inf))))
	if (length(sound)==0) stop("There are no valid point pairs to plot!")
	x = x[sound]
	y = y[sound]
	if (!is.null(xlim)){cut = x >= xlim[1] & x <= xlim[2]
	x = x[cut]
	y = y[cut]
	}
	if (!is.null(ylim)){cut = y >= ylim[1] & y <= ylim[2]
	y = y[cut]
	x = x[cut]
	}
	
	# handle 'log' option #
	
	if (log == ""){
		valid = 1:length(x)
	} else if (log == "x"){
		valid = which(x > 0)
	} else if (log == "y"){
		valid = which(y > 0)
	} else if (log %in% c("xy","yx")){
		valid = intersect(which(x > 0),which(y > 0))
	}
	x = x[valid]
	y = y[valid]
	
	# handle 'cor' option #
	
	if (cor){main = paste(main," cor = ",round(cor(x,y,method=method),digits=2))}
	
	# handle graphics device  #
	
	plot(x,y,xlim=xlim,ylim=ylim,xlab=xlab,ylab=ylab,main="",type = "n",log = log,...)
	heatscatterpoints(x,y,pch = pch,cexplot = cexplot,nrcol = nrcol,grid = grid,colpal = colpal,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev,xlim = xlim,ylim = ylim,only = only,add.contour = add.contour,nlevels = nlevels,color.contour = color.contour,greyscale = greyscale,log = log,...)
	mtext(paste(main),3,2,cex=1.25)
}


### aliases ###


LSD.heatscatter = heatscatter


### heatpairs ###


#' @export
#' @name heatpairs
#' @aliases LSD.heatpairs
#' @title Pairwise colored scatterplot based on a two-dimensional Kernel Density Estimation
#' @description Pairwise visualization of two dimensional data in a three dimensional fashion facilitating a color encoded Kernel Density Estimation.
#' @param mat a matrix with numerical entries.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param labels a character vector giving the labels to be shown on the diagonal.
#' @param add.points logical: if \code{TRUE} (\code{FALSE} by default), a certain 'group' of points can be colored in all pairwise plots.
#' @param group indices or rownames of 'mat' to be highlighted in all pairwise plots (not necessarily all).
#' @param color.group R build-in color in which the 'group' of points should be highlighted.
#' @param method a character specifying the correlation method to use ('spearman' (default), 'pearson' or 'kendall').
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope). 
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param pch plotting 'character'. This can either be a single character or an integer code for one of a set of graphics symbols. (see '?pch', to be passed to plot).
#' @param cexplot a numerical value giving the amount by which the points should be magnified relative to the default.
#' @param cor.cex a numerical value giving the amount by which the correlation characters should be magnified relative to the default.
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).
#' @param grid an integer specifying the size of the grid used for the KDE.
#' @param only a character string which contains 'x' if the density should only be computed for the x axis, 'y' for the y axis (defaults to 'none' for the two-dimensional case).
#' @param add.contour logical: if \code{TRUE} (\code{FALSE} by default), the contour lines are added to the plot.
#' @param nlevels an integer giving the number of levels of the contour lines.
#' @param color.contour R build-in color for the contour lines.
#' @param greyscale logical: if \code{TRUE} (\code{FALSE} by default), the used colorpalette is converted to greyscales.
#' @param log a character string which contains "x" if the x axis is to be logarithmic, "y" if the y axis is to be logarithmic and "xy" or "yx" if both axes are to be logarithmic.
#' @param ... additional parameters to be passed to points and plot
#' @author Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples points = 10^4
#' x = rnorm(points/2)
#' x = c(x,x+2.5)
#' y = x + rnorm(points,sd=0.75)
#' x = sign(x)*abs(x)^1.3
#' mat = cbind(x,y,x + rnorm(points,sd=0.5))
#' colnames(mat) = c("x","y","z")
#' rownames(mat) = 1:nrow(mat)
#' 
#' heatpairs(mat,labels=c(expression(Xi),expression(Lambda),expression(Delta)))
#' @keywords scatterplot heatcolors


heatpairs = function(mat,main = "heatpairs",xlim = NULL,ylim = NULL,labels = NULL,add.points = FALSE,group = NULL,color.group = "magenta",method = "spearman",colpal = "heat",simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,rev = FALSE,pch=19,cexplot=0.5,cor.cex = 2.5,nrcol=30,grid=100,only = "none",add.contour = FALSE,nlevels = 10,color.contour = "black",greyscale = FALSE,log = "",...)
{
	if (!is.matrix(mat)) stop("First argument must be a matrix !")
	if (is.null(xlim)){xlim = c(min(mat,na.rm=TRUE),max(mat,na.rm=TRUE))}
	if (is.null(ylim)){ylim = c(min(mat,na.rm=TRUE),max(mat,na.rm=TRUE))}
	if(is.null(labels)){labels = colnames(mat)}
  
  # handle 'log' option #
  
  if (log == ""){
    valid = 1:dim(mat)[1]
  } else if (log %in% c("x","y","xy","yx")){
    valid = apply(mat,1,function(x){all(x > 0)})
  }
  mat = mat[valid,]

	pairs(mat,labels=labels,xlim=xlim,ylim=ylim,lower.panel=function(x,y,...){{if (log == ""){x.pos = diff(xlim)/2 + xlim[1];y.pos = diff(ylim)/2 + ylim[1]} else if (log == "x"){x.pos = 10^(diff(log(xlim,10))/2 + log(xlim,10)[1]);y.pos = diff(ylim)/2 + ylim[1]} else if (log == "y"){x.pos = diff(xlim)/2 + xlim[1];y.pos = 10^(diff(log(ylim,10))/2 + log(ylim,10)[1])} else if (log %in% c("xy","yx")){x.pos = 10^(diff(log(xlim,10))/2 + log(xlim,10)[1]);y.pos = 10^(diff(log(ylim,10))/2 + log(ylim,10)[1])}};text(x.pos,y.pos,round(cor(x,y,method=method,use="na.or.complete"),digits=2),cex=cor.cex)},main=main,upper.panel=function(x,y,...){heatscatterpoints(x,y,colpal=colpal,pch=pch,cexplot=cexplot,nrcol=nrcol,grid=grid,simulate=simulate,daltonize=daltonize,cvd=cvd,alpha=alpha,rev=rev,only=only,add.contour=add.contour,nlevels=nlevels,color.contour=color.contour,greyscale=greyscale,log = log,...);if (log == ""){abline(a=0,b=1)} else if (log == "x"){lines(seq(xlim[1],xlim[2],length.out = 100),seq(ylim[1],ylim[2],length.out = 100))} else if (log == "y"){lines(seq(xlim[1],xlim[2],length.out = 100),seq(ylim[1],ylim[2],length.out = 100))} else if (log %in% c("xy","yx")){abline(a=0,b=1)};if (add.points){points(x[rownames(mat) %in% group],y[rownames(mat) %in% group],col=color.group,log = log,...)}},log = log,...)
}


### aliases ###


LSD.heatpairs = heatpairs

### align ###


#' @export
#' @name align
#' @aliases LSD.align
#' @title Visualize two-dimensional data in a color encoded fashion
#' @description Depict any matrix or list in a color encoded rectangular fashion.
#' @param input matrix or list with any type of entries.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param label logical: if \code{TRUE} (\code{FALSE} by default), labels are added according to the color scheme (i.e. binning).
#' @param digits integer indicating the number of decimals to be used for binning of continuous data.
#' @param border color for rectangle border(s). Use border = NA to omit borders.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param main title of the plot, standard graphics parameter.
#' @param axes logical: if \code{TRUE} (by default), a box and axes are added to the plot (if \code{FALSE}, custom specification of axes can be achieved via basic R graphics functions).
#' @param ... additional parameters to be passed to points and plot.
#' @author Phillipp Torkler, Bjoern Schwalb
#' @seealso \code{\link{clusterplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples data(seqs)
#' colpal = c("A" = "darkgreen","C" = "darkblue","G" = "yellow","T" = "darkred")
#' align(seqs,colpal = colpal,label = TRUE,main = "DNA sequences")
#' 
#' data(homer)
#' colpal = c("white","black","yellow","wheat3")
#' align(homer,colpal = colpal,main = "D'OH!",asp = 1,axes = FALSE)
#' @keywords alignment sequence


align = function(input,colpal = "heat",simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,label = FALSE,digits = 1,border = NULL,xlim = NULL,ylim = NULL,main = NULL,axes = TRUE,...) 
{
	# stops execution, if 'input' is neither a list nor a matrix and executes an error action #
	
	if (!is.matrix(input) & !is.list(input)) stop("'input' must be a matrix or a list !")
	
	# if 'input' is a list #
	
	if (is.list(input)){
		
		# stops execution, if 'input'-list entries are of unequal length and executes an error action #
		
		if (any(sapply(input,length) != length(input[[1]]))){stop("'input'-list entries are of unequal length.")}
		
		# coerce to matrix #
		
		input = t(sapply(input,c))
	}

	# bin the 'input' data via the round function #
	
	dim.input = dim(input)
	input = as.vector(input)
	options(warn = -1)
	input[!is.na(as.numeric(input))] = round(as.numeric(input[!is.na(as.numeric(input))]),digits = digits)
	options(warn = 0)
	dim(input) = dim.input
	
	# provide color encoding #
	
	colsize = length(unique(as.vector(input)))
	cat(colsize,"color encoding \n")
	if (length(colpal) > 1){if (colsize != length(colpal)){warning("'colpal' contains not enough colors to encode 'input' data!")}}
	names.colpal = NULL
	if (!is.null(names(colpal))){names.colpal = names(colpal)}
	colorset = colorpalette(colpal,colsize,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha)
	if (is.null(names.colpal)){names(colorset) = as.character(sort(unique(as.vector(input)),na.last = TRUE))} else {names(colorset) = names.colpal}
				
	# plot data in a grid like fashion #

	ysize = nrow(input)
	xsize = ncol(input)
	if (is.null(xlim)){xlim = c(0,xsize)}
	if (is.null(ylim)){ylim = c(0,ysize)}
	plot.new()
	plot.window(xlim = xlim,ylim = ylim,...)
	title(main)
	if (axes){
		axis(1)
		axis(2)
		box()
	}
	dump = sapply(1:ysize,function(i){rect(1:xsize - 1,ysize - i,1:xsize,ysize - i + 1,col = colorset[as.character(input[i,1:xsize])],border = border);if (label){text(x = 1:xsize - 0.5,y = ysize - i + 1 - 0.5,label = input[i,1:xsize],col = complementarycolor(colorset[as.character(input[i,1:xsize])]))}})
}


# alias #


LSD.align = align

### heathist ###


#' @export
#' @name heathist
#' @aliases LSD.heathist
#' @title Color a histogram
#' @description A histogram with an additional color stripe based on a kernel density estimate.
#' @param x a numeric vector.
#' @param breaks a numeric value giving the breaks of the histogram.
#' @param xlab x label, standard graphics parameter.
#' @param ylab y label, standard graphics parameter.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param colpal a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).
#' @param rev logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.
#' @param simulate logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param daltonize logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).
#' @param cvd character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param nobox logical: if \code{TRUE} (\code{FALSE} by default), the box of the plot is omitted.
#' @param add.density if \code{TRUE} (\code{FALSE} by default), a density line is added to the histogram.
#' @param col.density a R build-in color for the density line (if \code{add.density = TRUE}).
#' @param add.rug if \code{TRUE} (\code{FALSE} by default), a rug (1-d plot of the data) is added below the histogram-bars.
#' @param col.rug a R build-in color for the rug (if \code{add.rug = TRUE}).
#' @param nrcol a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples x = rnorm(1000,mean = sample(c(0,3),size = 1000,prob = c(0.4,0.6),replace = TRUE))
#' heathist(x,xlab="x",add.density=TRUE,col.rug="darkred")
#' 
#' heathist(x,xlab="x",colpal = "matlablike")
#' @keywords histogram


heathist = function(x,breaks = 20,xlab = NULL,ylab = NULL,main = "heathist",colpal = "greys",rev = FALSE,simulate = FALSE,daltonize = FALSE,cvd = "p",alpha = NULL,nobox = FALSE,add.density = FALSE,col.density = "darkred",add.rug = TRUE,col.rug = "black",nrcol = 100,...)
{
	if (!is.vector(x)) stop("x must be a vector!")
	if (is.null(xlab)){xlab = deparse(substitute(x))}
	if (!is.null(ylab)){print("ylab argument will be ignored!")}
	xhist = hist(x,plot = FALSE,breaks = breaks)
	d = density(x)
	plot(xhist,border = NA,freq = FALSE,xlab = xlab,main = "",...)
	mtext(paste(main),3,2,cex=1.25)
	usr = par("usr")
	dy = (max(xhist$density) - 0)/nrcol
	colpal  = colorpalette(colpal,nrcol,simulate = simulate,daltonize = daltonize,cvd = cvd,alpha = alpha,rev = rev)
	for(i in 1:nrcol){
		clip(usr[1],usr[2],0 + (i-1) * dy,0 + i*dy)
		plot(xhist,add = TRUE,axes = FALSE,col = colpal[i],border = NA,freq = FALSE,xlab = "",ylab = "",main = "")
	}
	do.call(clip,as.list(usr))
	plot(xhist,add = TRUE,lwd = .5 ,freq = FALSE,axes = FALSE,xlab = "",ylab = "",main = "")
	if (add.density){lines(d,lwd = 4,col = col.density)}
	rug(x,col = col.rug)
	if (!nobox){box()}
}


### aliases ###


LSD.heathist = heathist

### makemovie ###


#' @export
#' @name makemovie
#' @aliases LSD.makemovie
#' @title Interpolate rows of a matrix to extend the number of cols
#' @description Interpolate rows of a matrix to yield a smooth transitions.
#' @param input a matrix with numerical entries.
#' @param timepoints a integer vector containing the timepoints corresponding to the columns of 'input'.
#' @param timestep a non-negative integer specifying the number of timesteps between the existing timepoints (defaults to \code{1}, if not specified).
#' @param motionline a integer vector giving the timepoints of the resulting matrix (derived from timepoints and timesteps by default).
#' @author Achim Tresch, Bjoern Schwalb
#' @seealso \code{\link{clusterplot}}, \code{\link{align}}, \code{\link{demotour}}
#' @examples len = 10
#' x = sin(seq(0,2*pi,length=len*2))
#' fun = function(){n=sample(1:len,1);return(x[n:(n+len-1)])}
#' input = t(replicate(7,fun(),simplify=TRUE))
#' input = input + rnorm(length(input))/2
#' par(mfrow=c(1,2))
#' plotmatrix(input,main="original",cols=1:7,type="o")
#' mov = makemovie(input,timestep=0.2)
#' plotmatrix(mov,main="interpolated",cols=1:7,type="o")
#' @keywords matrix


makemovie = function(input,timepoints=NULL,timestep=1,motionline=NULL)
{
	if (!is.matrix(input)) stop("'input' must be a matrix !")
	if (sum(is.na(input)) != 0) stop("'input' must not contain NAs !")
	if (is.null(timepoints)) timepoints = 1:ncol(input)
	sorted = order(timepoints,decreasing=FALSE)
	input = input[,sorted]
	timepoints = timepoints[sorted]
	colnames(input) = timepoints
	if (is.null(motionline)){
		nrpics = ceiling(diff(range(timepoints))/timestep)+1
		motionline = seq(timepoints[1],timepoints[length(timepoints)],length=nrpics)		
	}
	timeline = function(x){splinefun(timepoints,x)(motionline)}
	movie = t(apply(input,1,timeline))
	colnames(movie) = round(motionline,digits=2)
	return(movie)
}


### aliases ###


LSD.makemovie = makemovie

### singlemsdplot ###


#' @export
#' @name singlemsdplot
#' @aliases LSD.singlemsdplot
#' @title Visualize two-dimensional data clusters (add to an existing plot)
#' @description Depict a numeric matrix or list utilizing the underlying mean and standard deviation estimates of one dimension in a color encoded fashion (add to an existing plot).
#' @param input data as matrix or list.
#' @param col a character vector of R build-in colors.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param bars logical: if \code{TRUE} (by default), error bars are added at each position.
#' @param length a numeric value scaling the width of the bars.
#' @param at a integer vector containing the x-positions corresponding to the columns of 'input'.
#' @author Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples samples = 100
#' probes = 200
#' clus = matrix(rnorm(probes*samples,sd=1),ncol=probes)
#' 
#' clus = rbind(
#' 	t(t(clus)+sin(1:probes/10))+1:nrow(clus)/samples,
#' 	t(t(clus)+sin(pi/2+1:probes/10))+1:nrow(clus)/samples)
#' 
#' emptyplot(xlim = c(1,ncol(clus)),ylim = range(clus))
#' singlemsdplot(clus)
#' axis(1)
#' axis(2)
#' box()
#' @keywords mean sd


singlemsdplot = function(input,col = "darkgreen",alpha = 50,bars = TRUE,length = 0.25,at = NULL)
{
	if (!is.matrix(input) & !is.list(input)) stop("First argument must be a matrix or a list!")
	if (is.null(at)) if (is.matrix(input)){at=1:ncol(input)} else if (is.list(input)){at=1:length(input)}
	probes = length(at)
	if (is.matrix(input)){
		means = apply(input,2,mean,na.rm=TRUE)
		sds = apply(input,2,sd,na.rm=TRUE)
	} else if (is.list(input)){
		means = lapply(input,mean,na.rm=TRUE)
		means = sapply(means,c)
		sds = lapply(input,sd,na.rm=TRUE)
		sds = sapply(sds,c)
	}
	sds[is.na(sds)] = 0
	qline = rbind(means+sds,means,means-sds)
	for (j in 1:2){polygon(at[c(1:probes,probes:1)],c(qline[j,],qline[j+1,probes:1]),col = convertcolor(col,alpha),lty=0)}
	lines(at,qline[2,],col=col,lwd=2)
	if (bars){options(warn = -1);arrows(at,means-sds,at,means+sds,angle=90,code=3,length=length,col=col);options(warn = 0)}                               
}


### aliases ###


LSD.singlemsdplot = singlemsdplot


### msdplot ###


#' @export
#' @name msdplot
#' @aliases LSD.msdplot
#' @title Visualize two-dimensional data clusters
#' @description Depict a numeric matrix or list utilizing the underlying mean and standard deviation estimates of one dimension in a color encoded fashion.
#' @param input matrix or list with numerical entries, quantiles of cols will define lines.
#' @param label a character vector assigning rows/elements of 'input' to clusters (if specified, multiple clusters can be depicted in different colors and/or subsequent plots).
#' @param at a integer vector containing the x-positions corresponding to the columns of 'input'.
#' @param xlim x limits, standard graphics parameter.
#' @param ylim y limits, standard graphics parameter.
#' @param xlab x labels, standard graphics parameter.
#' @param ylab y labels, standard graphics parameter.
#' @param main title(s) of the plot, standard graphics parameter.
#' @param xaxt a character which specifies the x axis type ("n" suppresses plotting of the axis).
#' @param xlabels a character vector containing labels for the x-axis.
#' @param las las=1: horizontal text, las=2: vertical text (x-axis labels).
#' @param separate if \code{TRUE} (by default), different clusters are depicted in subsequent plots.
#' @param size logical: if \code{TRUE} (by default), the size of each cluster is added to the title of the respective plot.
#' @param col a character vector giving R build-in colors for different clusters.
#' @param bars logical: if \code{TRUE} (by default), error bars are added at each position.
#' @param alpha alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).
#' @param ... additional parameters to be passed to points and plot.
#' @author Bjoern Schwalb
#' @seealso \code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
#' @examples at = c(2,4,8,16,32)
#' clus = matrix(rnorm(500,sd=0.5),ncol=5)
#' batch = sample(c(-8,-6,-4,-2),100,replace=TRUE)
#' clus = clus + cbind(0,0.25*batch,0.5*batch,0.75*batch,batch)
#' clus = clus - clus[,1]
#' clus = t(t(clus)*c(0,0.1,0.25,0.5,1))
#' labs = paste("cluster",kmeans(clus,4)$cluster)
#' 
#' colpal = c("darkgreen","darkblue","darkred","black")
#' msdplot(clus,labs,at,separate=FALSE,col=colpal,alpha=25,xlabels=at)
#' 
#' msdplot(clus,labs,at,col=colpal,alpha=50,xlabels=at)
#' @keywords mean sd


msdplot = function(input,label = NULL,at = NULL,xlim = NULL,ylim = NULL,xlab = "",ylab = "",main = "msdplot",xaxt = "s",xlabels = NULL,las = 1,separate = TRUE,size = TRUE,col = "darkgreen",bars = TRUE,alpha = 50,...)
{
	if (!is.matrix(input) & !is.list(input)) stop("First argument must be a matrix or a list!")
	if (is.null(at)) if (is.matrix(input)){at=1:ncol(input)} else if (is.list(input)){at=1:length(input)}
	probes = length(at)
	if (is.null(xlim)) xlim=range(at)
	maxp = xlim[2]
	minp = xlim[1]
	if (is.null(ylim)) ylim=range(input,na.rm=TRUE)
	if (is.null(xlabels)) xlabels = 1:length(at)
	# one cluster in one plot
	if (is.null(label)){
		plot(xlim,ylim,type="n",xaxt="n",xlab=xlab,ylab=ylab,main="",...)
		mtext(paste(main),3,2,cex=1.25)
		if (size){mtext(paste("( #",nrow(input)," )"),3,1,col="darkgrey",cex=0.75)}
		if (xaxt!="n") axis(side=1,las=las,at=at,labels=xlabels)
		singlemsdplot(input=input,at=at,alpha=alpha,col=col,bars=bars,length=0.02*range(at))
	}
	# several clusters in one plot or several plots
	if (!is.null(label)){clusternames = unique(label)
		nrclusters = length(clusternames)
		if (!is.matrix(input)) stop("First argument must be a matrix for multiple clusters!")
		clustersets = split(1:nrow(input),factor(label))	
		if (separate==FALSE){
			plot(xlim,ylim,type="n",xaxt="n",xlab=xlab,ylab=ylab,main="",...)
			mtext(paste(main),3,2,cex=1.25)
			if (size){mtext(paste("( #",nrow(input)," )"),3,1,col="darkgrey",cex=0.75)}
			if (xaxt!="n") axis(side=1,las=las,at=at,labels=xlabels)}
		if (separate==TRUE) par(mfrow=windowxy(nrclusters))
		for (j in seq(clusternames)){
			if (separate==TRUE){
				if (length(main) == length(clustersets[[j]])) clustermain = main[j]	else clustermain = paste(main,clusternames[j])
				plot(xlim,ylim,type="n",xaxt="n",xlab=xlab,ylab=ylab,main="",...)
				mtext(paste(clustermain),3,2,cex=1.25)
				if (size){mtext(paste("( #",length(clustersets[[j]])," )"),3,1,col="darkgrey",cex=0.75)}
				if (xaxt!="n") axis(side=1,las=las,at=at,labels=xlabels)
			}
			singlemsdplot(input=input[clustersets[[j]],,drop=FALSE],at=at,alpha=alpha,col=col[j],bars=bars,length=0.02*range(at))
		}
	}
}


### aliases ###


LSD.msdplot = msdplot

complete -c lsd -l color -d 'When to use terminal colours [default: auto]' -r -f -a "{always	'',auto	'',never	''}"
complete -c lsd -l icon -d 'When to print the icons [default: auto]' -r -f -a "{always	'',auto	'',never	''}"
complete -c lsd -l icon-theme -d 'Whether to use fancy or unicode icons [default: fancy]' -r -f -a "{fancy	'',unicode	''}"
complete -c lsd -l config-file -d 'Provide a custom lsd configuration file' -r -F
complete -c lsd -l depth -d 'Stop recursing into directories after reaching specified depth' -r
complete -c lsd -l permission -d 'How to display permissions [default: rwx for linux, attributes for windows]' -r -f -a "{rwx	'',octal	'',attributes	'',disable	''}"
complete -c lsd -l size -d 'How to display size [default: default]' -r -f -a "{default	'',short	'',bytes	''}"
complete -c lsd -l date -d 'How to display date [default: date] [possible values: date, locale, relative, +date-time-format]' -r
complete -c lsd -l sort -d 'Sort by TYPE instead of name' -r -f -a "{size	'',time	'',version	'',extension	'',git	'',none	''}"
complete -c lsd -l group-dirs -d 'Sort the directories then the files' -r -f -a "{none	'',first	'',last	''}"
complete -c lsd -l blocks -d 'Specify the blocks that will be displayed and in what order' -r -f -a "{permission	'',user	'',group	'',context	'',size	'',date	'',name	'',inode	'',links	'',git	''}"
complete -c lsd -s I -l ignore-glob -d 'Do not display files/directories with names matching the glob pattern(s). More than one can be specified by repeating the argument' -r
complete -c lsd -l hyperlink -d 'Attach hyperlink to filenames [default: never]' -r -f -a "{always	'',auto	'',never	''}"
complete -c lsd -l truncate-owner-after -d 'Truncate the user and group names if they exceed a certain number of characters' -r
complete -c lsd -l truncate-owner-marker -d 'Truncation marker appended to a truncated user or group name' -r
complete -c lsd -s a -l all -d 'Do not ignore entries starting with . '
complete -c lsd -s A -l almost-all -d 'Do not list implied . and ..'
complete -c lsd -s F -l classify -d 'Append indicator (one of */=>@|) at the end of the file names'
complete -c lsd -s l -l long -d 'Display extended file metadata as a table'
complete -c lsd -l ignore-config -d 'Ignore the configuration file'
complete -c lsd -s 1 -l oneline -d 'Display one entry per line'
complete -c lsd -s R -l recursive -d 'Recurse into directories'
complete -c lsd -s h -l human-readable -d 'For ls compatibility purposes ONLY, currently set by default'
complete -c lsd -l tree -d 'Recurse into directories and present the result as a tree'
complete -c lsd -s d -l directory-only -d 'Display directories themselves, and not their contents (recursively when used with --tree)'
complete -c lsd -l total-size -d 'Display the total size of directories'
complete -c lsd -s t -l timesort -d 'Sort by time modified'
complete -c lsd -s S -l sizesort -d 'Sort by size'
complete -c lsd -s X -l extensionsort -d 'Sort by file extension'
complete -c lsd -s G -l gitsort -d 'Sort by git status'
complete -c lsd -s v -l versionsort -d 'Natural sort of (version) numbers within text'
complete -c lsd -s U -l no-sort -d 'Do not sort. List entries in directory order'
complete -c lsd -s r -l reverse -d 'Reverse the order of the sort'
complete -c lsd -l group-directories-first -d 'Groups the directories at the top before the files. Same as --group-dirs=first'
complete -c lsd -l classic -d 'Enable classic mode (display output similar to ls)'
complete -c lsd -l no-symlink -d 'Do not display symlink target'
complete -c lsd -s i -l inode -d 'Display the index number of each file'
complete -c lsd -s g -l git -d 'Show git status on file and directory" Only when used with --long option'
complete -c lsd -s L -l dereference -d 'When showing file information for a symbolic link, show information for the file the link references rather than for the link itself'
complete -c lsd -s Z -l context -d 'Print security context (label) of each file'
complete -c lsd -l header -d 'Display block headers'
complete -c lsd -l system-protected -d 'Includes files with the windows system protection flag set. This is the same as --all on other platforms'
complete -c lsd -s N -l literal -d 'Print entry names without quoting'
complete -c lsd -l help -d 'Print help information'
complete -c lsd -s V -l version -d 'Print version'

complete -c lsd -n "__fish_use_subcommand" -l color -d 'When to use terminal colours' -r -f -a "always auto never"
complete -c lsd -n "__fish_use_subcommand" -l icon -d 'When to print the icons' -r -f -a "always auto never"
complete -c lsd -n "__fish_use_subcommand" -l icon-theme -d 'Whether to use fancy or unicode icons' -r -f -a "fancy unicode"
complete -c lsd -n "__fish_use_subcommand" -l depth -d 'Stop recursing into directories after reaching specified depth'
complete -c lsd -n "__fish_use_subcommand" -l size -d 'How to display size' -r -f -a "default short bytes"
complete -c lsd -n "__fish_use_subcommand" -l date -d 'How to display date [possible values: date, relative, +date-time-format]'
complete -c lsd -n "__fish_use_subcommand" -l sort -d 'sort by WORD instead of name' -r -f -a "size time version extension"
complete -c lsd -n "__fish_use_subcommand" -l group-dirs -d 'Sort the directories then the files' -r -f -a "none first last"
complete -c lsd -n "__fish_use_subcommand" -l blocks -d 'Specify the blocks that will be displayed and in what order' -r -f -a "permission user group size date name inode"
complete -c lsd -n "__fish_use_subcommand" -s I -l ignore-glob -d 'Do not display files/directories with names matching the glob pattern(s). More than one can be specified by repeating the argument'
complete -c lsd -n "__fish_use_subcommand" -s a -l all -d 'Do not ignore entries starting with .'
complete -c lsd -n "__fish_use_subcommand" -s A -l almost-all -d 'Do not list implied . and ..'
complete -c lsd -n "__fish_use_subcommand" -s F -l classify -d 'Append indicator (one of */=>@|) at the end of the file names'
complete -c lsd -n "__fish_use_subcommand" -s l -l long -d 'Display extended file metadata as a table'
complete -c lsd -n "__fish_use_subcommand" -l ignore-config -d 'Ignore the configuration file'
complete -c lsd -n "__fish_use_subcommand" -s 1 -l oneline -d 'Display one entry per line'
complete -c lsd -n "__fish_use_subcommand" -s R -l recursive -d 'Recurse into directories'
complete -c lsd -n "__fish_use_subcommand" -s h -l human-readable -d 'For ls compatibility purposes ONLY, currently set by default'
complete -c lsd -n "__fish_use_subcommand" -l tree -d 'Recurse into directories and present the result as a tree'
complete -c lsd -n "__fish_use_subcommand" -s d -l directory-only -d 'Display directories themselves, and not their contents (recursively when used with --tree)'
complete -c lsd -n "__fish_use_subcommand" -l total-size -d 'Display the total size of directories'
complete -c lsd -n "__fish_use_subcommand" -s t -l timesort -d 'Sort by time modified'
complete -c lsd -n "__fish_use_subcommand" -s S -l sizesort -d 'Sort by size'
complete -c lsd -n "__fish_use_subcommand" -s X -l extensionsort -d 'Sort by file extension'
complete -c lsd -n "__fish_use_subcommand" -s v -l versionsort -d 'Natural sort of (version) numbers within text'
complete -c lsd -n "__fish_use_subcommand" -s r -l reverse -d 'Reverse the order of the sort'
complete -c lsd -n "__fish_use_subcommand" -l classic -d 'Enable classic mode (no colors or icons)'
complete -c lsd -n "__fish_use_subcommand" -l no-symlink -d 'Do not display symlink target'
complete -c lsd -n "__fish_use_subcommand" -s i -l inode -d 'Display the index number of each file'
complete -c lsd -n "__fish_use_subcommand" -s L -l dereference -d 'When showing file information for a symbolic link, show information for the file the link references rather than for the link itself'
complete -c lsd -n "__fish_use_subcommand" -l help -d 'Prints help information'
complete -c lsd -n "__fish_use_subcommand" -s V -l version -d 'Prints version information'

#!/usr/bin/env bash

set -ex

# Incorporate TARGET env var to the build and test process
cargo build --target "$TARGET" --verbose

# We cannot run arm executables on linux
if [[ $TARGET != arm-unknown-linux-* ]]; then
    cargo test --target "$TARGET" --verbose
fi

#!/usr/bin/env bash

set -ex

if [ "$TRAVIS_OS_NAME" != linux ]; then
    exit 0
fi

sudo apt-get update

# needed to build deb packages
sudo apt-get install -y fakeroot

# needed for i686 linux gnu target
if [[ $TARGET == i686-unknown-linux-gnu ]]; then
    sudo apt-get install -y gcc-multilib
fi

# needed for cross-compiling for arm
if [[ $TARGET == arm-unknown-linux-* ]]; then
    sudo apt-get install -y \
        gcc-4.8-arm-linux-gnueabihf \
        binutils-arm-linux-gnueabihf \
        libc6-armhf-cross \
        libc6-dev-armhf-cross
fi

#!/usr/bin/env bash
# Building and packaging for release

set -ex

build() {
    cargo build --target "$TARGET" --features="$FEATURES" --release --verbose
}

pack() {
    local tempdir
    local out_dir
    local package_name
    local gcc_prefix

    tempdir=$(mktemp -d 2>/dev/null || mktemp -d -t tmp)
    out_dir=$(pwd)
    package_name="$PROJECT_NAME-$TRAVIS_TAG-$TARGET"

    if [[ $TARGET == arm-unknown-linux-* ]]; then
        gcc_prefix="arm-linux-gnueabihf-"
    else
        gcc_prefix=""
    fi

    # create a "staging" directory
    mkdir "$tempdir/$package_name"
    mkdir "$tempdir/$package_name/autocomplete"

    # copying the main binary
    cp "target/$TARGET/release/$PROJECT_NAME" "$tempdir/$package_name/"
    "${gcc_prefix}"strip "$tempdir/$package_name/$PROJECT_NAME"

    # manpage, readme and license
    cp README.md "$tempdir/$package_name"
    cp LICENSE "$tempdir/$package_name"

    # various autocomplete
    cp target/"$TARGET"/release/build/"$PROJECT_NAME"-*/out/"$PROJECT_NAME".bash "$tempdir/$package_name/autocomplete/${PROJECT_NAME}.bash-completion"
    cp target/"$TARGET"/release/build/"$PROJECT_NAME"-*/out/"$PROJECT_NAME".fish "$tempdir/$package_name/autocomplete"
    cp target/"$TARGET"/release/build/"$PROJECT_NAME"-*/out/_"$PROJECT_NAME" "$tempdir/$package_name/autocomplete"

    # archiving
    pushd "$tempdir"
    tar czf "$out_dir/$package_name.tar.gz" "$package_name"/*
    popd
    rm -r "$tempdir"
}

make_deb() {
    local tempdir
    local architecture
    local version
    local dpkgname
    local conflictname

    case $TARGET in
        x86_64*)
            architecture=amd64
            ;;
        i686*)
            architecture=i386
            ;;
        *)
            echo "make_deb: skipping target '${TARGET}'" >&2
            return 0
            ;;
    esac
    version=${TRAVIS_TAG#v}
    if [[ $TARGET = *musl* ]]; then
      dpkgname=$PROJECT_NAME-musl
      conflictname=$PROJECT_NAME
    else
      dpkgname=$PROJECT_NAME
      conflictname=$PROJECT_NAME-musl
    fi

    tempdir=$(mktemp -d 2>/dev/null || mktemp -d -t tmp)

    # copy the main binary
    install -Dm755 "target/$TARGET/release/$PROJECT_NAME" "$tempdir/usr/bin/$PROJECT_NAME"
    strip "$tempdir/usr/bin/$PROJECT_NAME"

    # readme and license
    install -Dm644 README.md "$tempdir/usr/share/doc/$PROJECT_NAME/README.md"
    install -Dm644 LICENSE "$tempdir/usr/share/doc/$PROJECT_NAME/LICENSE"

    # completions
    install -Dm644 target/$TARGET/release/build/$PROJECT_NAME-*/out/$PROJECT_NAME.bash "$tempdir/usr/share/bash-completion/completions/${PROJECT_NAME}"
    install -Dm644 target/$TARGET/release/build/$PROJECT_NAME-*/out/$PROJECT_NAME.fish "$tempdir/usr/share/fish/completions/$PROJECT_NAME.fish"
    install -Dm644 target/$TARGET/release/build/$PROJECT_NAME-*/out/_$PROJECT_NAME "$tempdir/usr/share/zsh/vendor-completions/_$PROJECT_NAME"

    # Control file
    mkdir "$tempdir/DEBIAN"
    cat > "$tempdir/DEBIAN/control" <<EOF
Package: $dpkgname
Version: $version
Section: utils
Priority: optional
Maintainer: Peltoche <peltoche@halium.fr>
Architecture: $architecture
Provides: $PROJECT_NAME
Conflicts: $conflictname
Description: A ls command with a lot of pretty colors.
EOF

    fakeroot dpkg-deb --build "$tempdir" "${dpkgname}_${version}_${architecture}.deb"
}


main() {
    build
    pack
    if [[ $TARGET = *linux* ]]; then
      make_deb
    fi
}

main

---
title: lsd
section: 1
header: User Manual
footer: lsd <version>
date: <date>
---

# NAME

lsd - LSDeluxe

# SYNOPSIS

`lsd [FLAGS] [OPTIONS] [--] [FILE]...`

# DESCRIPTION

lsd is a ls command with a lot of pretty colours and some other stuff to enrich and enhance the directory listing experience.

# OPTIONS

`-a`, `--all`
: Do not ignore entries starting with **.**

`-A`, `--almost-all`
: Do not list implied **.** and **..**

`--classic`
: Enable classic mode (no colours or icons)

`-L`, `--dereference`
: When showing file information for a symbolic link, show information for the file the link references rather than for the link itself

`-d`, `--directory-only`
: Display directories themselves, and not their contents (recursively when used with --tree)

`-X`, `--extensionsort`
: Sort by file extension

`--git`
: Display git status. Directory git status is a reduction of included file statuses (recursively).

`--help`
: Prints help information

`-h`, `--human-readable`
: For ls compatibility purposes ONLY, currently set by default

`--ignore-config`
: Ignore the configuration file

`--config-file <path>`
: Provide the config file from a custom location

`-F`, `--classify`
: Append indicator (one of \*/=>@|) at the end of the file names

`-i`, `--inode`
: Display the index number of each file

`-l`, `--long`
: Display extended file metadata as a table

`--no-symlink`
: Do not display symlink target

`-1`, `--oneline`
: Display one entry per line

`-R`, `--recursive`
: Recurse into directories

`-r`, `--reverse`
: Reverse the order of the sort

`-S`, `--sizesort`
: Sort by size

`-t`, `--timesort`
: Sort by time modified

`--total-size`
: Display the total size of directories

`--tree`
: Recurse into directories and present the result as a tree

`-V`, `--version`
: Prints version information

`-v`, `--versionsort`
: Natural sort of (version) numbers within text

`--blocks <blocks>...`
: Specify the blocks that will be displayed and in what order [possible values: permission, user, group, size, date, name, inode, git]

`--color <color>...`
: When to use terminal colours [default: auto]  [possible values: always, auto, never]

`--date <date>...`
: How to display date [possible values: date, locale, relative, +date-time-format] [default: date]

`--depth <num>...`
: Stop recursing into directories after reaching specified depth

`--group-dirs <group-dirs>...`
: Sort the directories then the files [default: none]  [possible values: none, first, last]

`--group-directories-first`
: Groups the directories at the top before the files. Same as `--group-dirs=first`

`--hyperlink <hyperlink>...`
: Attach hyperlink to filenames [default: never]  [possible values: always, auto, never]

`--icon <icon>...`
: When to print the icons [default: auto]  [possible values: always, auto, never]

`--icon-theme <icon-theme>...`
: Whether to use fancy or unicode icons [default: fancy]  [possible values: fancy, unicode]

`-I, --ignore-glob <pattern>...`
: Do not display files/directories with names matching the glob pattern(s). More than one can be specified by repeating the argument [default: ]

`--permission <permission>...`
: How to display permissions [default: rwx for linux, attributes for windows]  [possible values: rwx, octal, attributes, disable]

`--size <size>...`
: How to display size [default: default]  [possible values: default, short, bytes]

`--sort <WORD>...`
: Sort by WORD instead of name [possible values: size, time, version, extension, git]

`-U`, `--no-sort`
: Do not sort. List entries in directory order

`-Z` `--context`
: Display SELinux or SMACK security context

`--header`
: Display block headers

`-N --literal`
: Print entry names without quoting

`--truncate-owner-after`
: Truncate the user and group names if they exceed a certain number of characters

`--truncate-owner-marker`
: Truncation marker appended to a truncated user or group name

# ARGS

`<FILE>...`
: A file or directory to list [default: .]

# EXAMPLES

`lsd`
: Display listing for current directory

`lsd /etc`
: Display listing of /etc

`lsd -la`
: Display listing of current directory, including files starting with `.` and the current directory's entry.

# ENVIRONMENT

`LS_COLORS`
: Used to determine color for displaying filenames. See **dir_colors**.

`XDG_CONFIG_HOME`
: Used to locate optional config file. If `XDG_CONFIG_HOME` is set, use `$XDG_CONFIG_HOME/lsd/config.yaml` else `$HOME/.config/lsd/config.yaml`.

`SHELL_COMPLETIONS_DIR` or `OUT_DIR`
: Used to specify the directory for generating a shell completions file. If neither are set, no completions file will be generated. The directory will be created if it does not exist.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.color.r
\name{disco}
\alias{disco}
\alias{LSD.disco}
\alias{display.colorpalette}
\alias{LSD.display.colorpalette}
\title{Disco (DISplays COlorpalettes)}
\usage{
disco(colpal = NULL, nrcol = NULL, alpha = NULL)
}
\arguments{
\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (displays all colorpalettes, if not specified).}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to length of \code{colpal}, if not specified).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}
}
\description{
Displays pre-designed colorpalettes as well as custom-made ones (see \code{colorpalette}).
}
\examples{
disco()
disco("rdbu",10)
}
\seealso{
\code{\link{colorpalette}}, \code{\link{demotour}}
}
\author{
Bjoern Schwalb
}
\keyword{alpha}
\keyword{color}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.plotmatrix.r
\name{plotmatrix}
\alias{plotmatrix}
\alias{LSD.plotmatrix}
\title{Visualize two-dimensional data}
\usage{
plotmatrix(
  input,
  xlim = NULL,
  ylim = NULL,
  xlab = "",
  ylab = "",
  main = "plotmatrix",
  type = "l",
  lwd = 2,
  at = NULL,
  xlabels = NULL,
  ltys = NULL,
  add = FALSE,
  cols = NULL,
  ...
)
}
\arguments{
\item{input}{a matrix with numerical entries.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{xlab}{x lab, standard graphics parameter.}

\item{ylab}{y lab, standard graphics parameter.}

\item{main}{title of the plot, standard graphics parameter.}

\item{type}{what 'type' of plot should be drawn (to be passed to points).}

\item{lwd}{a positive number giving the line width.}

\item{at}{a integer vector containing the x-positions corresponding to the columns of 'input'.}

\item{xlabels}{a character vector containing labels for the x-axis.}

\item{ltys}{a numeric vector giving the line types for each row of 'input'.}

\item{add}{logical: if \code{TRUE} (\code{FALSE} by default), lines are added to existing plot.}

\item{cols}{a character vector of R build-in colors.}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Plot the rows of a matrix as lines along the cols.
}
\examples{
len = 20
x = sin(seq(0,2*pi,length=len*2))
fun = function(){n=sample(1:len,1); return(x[n:(n+len-1)])}
input = t(replicate(7,fun(),simplify=TRUE))
input = input + rnorm(length(input))/2

plotmatrix(input,cols=1:7)
}
\seealso{
\code{\link{clusterplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Achim Tresch, Bjoern Schwalb
}
\keyword{matrix}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.utilities.R
\name{windowxy}
\alias{windowxy}
\alias{LSD.windowxy}
\title{Factorization of the number of windows for plots with device partitions}
\usage{
windowxy(nrwin = 1)
}
\arguments{
\item{nrwin}{a non-negative integer specifying the number of windows.}
}
\description{
Create a factorization of the number of windows for plots with device partitions to be used in par(mfrow = ...).
}
\examples{
windowxy(20)
}
\seealso{
\code{\link{demotour}}
}
\author{
Bjoern Schwalb
}
\keyword{factorization}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.msdplot.r
\name{singlemsdplot}
\alias{singlemsdplot}
\alias{LSD.singlemsdplot}
\title{Visualize two-dimensional data clusters (add to an existing plot)}
\usage{
singlemsdplot(
  input,
  col = "darkgreen",
  alpha = 50,
  bars = TRUE,
  length = 0.25,
  at = NULL
)
}
\arguments{
\item{input}{data as matrix or list.}

\item{col}{a character vector of R build-in colors.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{bars}{logical: if \code{TRUE} (by default), error bars are added at each position.}

\item{length}{a numeric value scaling the width of the bars.}

\item{at}{a integer vector containing the x-positions corresponding to the columns of 'input'.}
}
\description{
Depict a numeric matrix or list utilizing the underlying mean and standard deviation estimates of one dimension in a color encoded fashion (add to an existing plot).
}
\examples{
samples = 100
probes = 200
clus = matrix(rnorm(probes*samples,sd=1),ncol=probes)

clus = rbind(
	t(t(clus)+sin(1:probes/10))+1:nrow(clus)/samples,
	t(t(clus)+sin(pi/2+1:probes/10))+1:nrow(clus)/samples)

emptyplot(xlim = c(1,ncol(clus)),ylim = range(clus))
singlemsdplot(clus)
axis(1)
axis(2)
box()
}
\seealso{
\code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{mean}
\keyword{sd}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.align.R
\name{align}
\alias{align}
\alias{LSD.align}
\title{Visualize two-dimensional data in a color encoded fashion}
\usage{
align(
  input,
  colpal = "heat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  label = FALSE,
  digits = 1,
  border = NULL,
  xlim = NULL,
  ylim = NULL,
  main = NULL,
  axes = TRUE,
  ...
)
}
\arguments{
\item{input}{matrix or list with any type of entries.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{label}{logical: if \code{TRUE} (\code{FALSE} by default), labels are added according to the color scheme (i.e. binning).}

\item{digits}{integer indicating the number of decimals to be used for binning of continuous data.}

\item{border}{color for rectangle border(s). Use border = NA to omit borders.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{main}{title of the plot, standard graphics parameter.}

\item{axes}{logical: if \code{TRUE} (by default), a box and axes are added to the plot (if \code{FALSE}, custom specification of axes can be achieved via basic R graphics functions).}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Depict any matrix or list in a color encoded rectangular fashion.
}
\examples{
data(seqs)
colpal = c("A" = "darkgreen","C" = "darkblue","G" = "yellow","T" = "darkred")
align(seqs,colpal = colpal,label = TRUE,main = "DNA sequences")

data(homer)
colpal = c("white","black","yellow","wheat3")
align(homer,colpal = colpal,main = "D'OH!",asp = 1,axes = FALSE)
}
\seealso{
\code{\link{clusterplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Phillipp Torkler, Bjoern Schwalb
}
\keyword{alignment}
\keyword{sequence}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.pie.R
\name{LSD.pie}
\alias{LSD.pie}
\title{Custom-built piechart version}
\usage{
LSD.pie(
  props,
  x = 0,
  y = 0,
  radius = 1,
  colpal = "prgn",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  edges = 1000,
  add = FALSE,
  xlim = c(-1, 1),
  ylim = c(-1, 1),
  main = "LSD.pie: piecharts",
  alpha = NULL,
  addPercent = FALSE,
  textcol = "black",
  clockwise = FALSE,
  init.angle = 0,
  labels = c(),
  cex = 1,
  cex.percentage = cex,
  border = NA,
  ...
)
}
\arguments{
\item{props}{a numeric vector giving the relations of the pie pieces (need not to be normalized).}

\item{x}{x-position of the piechart.}

\item{y}{y-position of the piechart.}

\item{radius}{a numeric value giving the radius of the piechart.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{edges}{an integer giving the number of edges the "circle" will have.}

\item{add}{logical: if \code{TRUE} (\code{FALSE} by default), the pie is added to an existing plot.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{addPercent}{logical: if \code{TRUE} (\code{FALSE} by default), the percentage of each slice is written inside of the pie.}

\item{textcol}{a R build-in color for the percentages of \code{addPercent}.}

\item{clockwise}{if \code{TRUE} (\code{FALSE} by default), slices drawn clockwise (counter clockwise, if \code{FALSE}).}

\item{init.angle}{a numerical value representing an angle as a starting angle for the drawn slices.}

\item{labels}{a character vector giving the names for the pie slices.}

\item{cex}{scaling a numeric value giving the expansion factor for the slice names (if labels are given).}

\item{cex.percentage}{a numeric value giving the expansion factor for the percentage values (if \code{addPercent = TRUE}).}

\item{border}{a R build-in color giving the border color (NA by default).}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Piecharts at arbitrary position and radii.
}
\examples{
emptyplot(xlim=c(1,9),ylim=c(1,9))
mtext(paste("LSD.pie: piecharts"),3,2,cex=1.25)
polygon(c(4,2,4,7,8),c(4,8,4,2,8))
LSD.pie(sample(1:50,5),4,4,add=TRUE,radius=2,colpal="prgn",alpha=75)
LSD.pie(sample(1:50,5),2,8,add=TRUE,colpal="prgn",alpha=75)
LSD.pie(sample(1:50,5),8,8,add=TRUE,colpal="prgn",alpha=75)
LSD.pie(sample(1:50,5),7,2,add=TRUE,colpal="prgn",alpha=75)
}
\seealso{
\code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb, Carina Demel
}
\keyword{pie}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.ellipsescatter.R
\name{ellipsescatter}
\alias{ellipsescatter}
\alias{LSD.ellipsescatter}
\title{Visualize subgroups of two-dimensional data assuming normal distributions}
\usage{
ellipsescatter(
  x,
  y,
  groups,
  colors = NULL,
  pch = 20,
  bgcol = "darkgrey",
  main = "ellipsescatter",
  xlab = NULL,
  ylab = NULL,
  scalesd = 1,
  level = 0.75,
  legend.cex = 1,
  location = "topright",
  ...
)
}
\arguments{
\item{x}{a numeric vector.}

\item{y}{a numeric vector.}

\item{groups}{a list of indices or vector names to be plotted as groups (not necessarily all of x and y).}

\item{colors}{a character vector of R build-in colors corresponding to the chosen groups.}

\item{pch}{the plotting character (to be passed to plot).}

\item{bgcol}{a R build-in color for non-grouped points.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{xlab}{x label, standard graphics parameter.}

\item{ylab}{y label, standard graphics parameter.}

\item{scalesd}{a numeric value giving the scaling factor for standard deviations in each dimension (defaults to 1).}

\item{level}{a numeric value (between 0 and 1) giving the confidence level of a pairwise confidence region.}

\item{legend.cex}{a numerical value giving the amount by which the added legend should be magnified relative to the default.}

\item{location}{the x and y co-ordinates to be used to position the legend (see 'xy.coords').}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
A scatterplot with additional colored ellipses based on a gaussianity assumption.
}
\examples{
x = c(rnorm(50),rnorm(100,2),rnorm(50,4))
y = (x + rnorm(200,0,0.8))*rep(c(1,4,1),c(50,100,50))
x = sign(x)*abs(x)^1.3

groups = list("Green" = 1:50,"Red" = 51:150,"Blue" = 151:200)
colors = c("darkgreen","darkred","darkblue")
ellipsescatter(x,y,groups,colors,location = "topleft")
}
\seealso{
\code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{scatterplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.plotit.r
\name{plotit}
\alias{plotit}
\alias{LSD.plotit}
\title{Plotting wrapper function to plot plots in printable quality and all kinds of formats}
\usage{
plotit(
  filename,
  sw = 1,
  sh = 1,
  sres = 1,
  plotsfkt,
  ww = 7,
  wh = 7,
  pointsize = 12,
  dev.pointsize = 8,
  paper = "special",
  quality = 100,
  units = "px",
  bg = "white",
  fileformat = "jpeg",
  saveit = FALSE,
  notinR = FALSE,
  addformat = NULL
)
}
\arguments{
\item{filename}{name of the plot to be saved with the format type suffix.}

\item{sw}{scaling factor of weight.}

\item{sh}{scaling factor of height.}

\item{sres}{scaling factor of the resolution.}

\item{plotsfkt}{list of plots to be plotted.}

\item{ww}{width of window.}

\item{wh}{height of window.}

\item{pointsize}{the default pointsize of plotted text, interpreted as big points (1/72 inch) for plots to be saved.}

\item{dev.pointsize}{pointsize of plotted text, interpreted as big points (1/72 inch) for display in R.}

\item{paper}{needed only if filformat = "pdf" or "ps".}

\item{quality}{needed only if filformat = "jpeg".}

\item{units}{needed only if filformat = "jpeg", "png", "bmp" or "tiff".}

\item{bg}{backgroundcolor.}

\item{fileformat}{save the plot as "pdf", "ps", "jpeg", "png", "bmp" or "tiff".}

\item{saveit}{should plot be saved.}

\item{notinR}{should plot be not plotted in R.}

\item{addformat}{should plot be saved additionally in another format ("pdf", "ps", "jpeg", "png", "bmp" or "tiff").}
}
\description{
Plotting wrapper function to save plots in R as "pdf", "ps", "jpeg", "png", "bmp" or "tiff".
}
\examples{
data(homer)

plotsfkt = function(){
		colpal = c("white","black","yellow","wheat3")
		align(homer,colpal = colpal,main = "D'OH!",asp = 1,axes = FALSE)
}

# choose 'saveit = TRUE' for saving the plot in the specified fileformat #

# choose 'notinR = TRUE' to suppress plotting in R #

plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "jpeg")

plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "png")

plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "bmp")

plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "tiff")

plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "ps")

plotit("homer",sw = 2,sh = 2,sres = 2,plotsfkt,saveit = FALSE,notinR = FALSE,fileformat = "pdf")
}
\seealso{
\code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{bmp}
\keyword{jpeg}
\keyword{pdf}
\keyword{plot}
\keyword{png}
\keyword{ps}
\keyword{tiff}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.heathist.r
\name{heathist}
\alias{heathist}
\alias{LSD.heathist}
\title{Color a histogram}
\usage{
heathist(
  x,
  breaks = 20,
  xlab = NULL,
  ylab = NULL,
  main = "heathist",
  colpal = "greys",
  rev = FALSE,
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  nobox = FALSE,
  add.density = FALSE,
  col.density = "darkred",
  add.rug = TRUE,
  col.rug = "black",
  nrcol = 100,
  ...
)
}
\arguments{
\item{x}{a numeric vector.}

\item{breaks}{a numeric value giving the breaks of the histogram.}

\item{xlab}{x label, standard graphics parameter.}

\item{ylab}{y label, standard graphics parameter.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{nobox}{logical: if \code{TRUE} (\code{FALSE} by default), the box of the plot is omitted.}

\item{add.density}{if \code{TRUE} (\code{FALSE} by default), a density line is added to the histogram.}

\item{col.density}{a R build-in color for the density line (if \code{add.density = TRUE}).}

\item{add.rug}{if \code{TRUE} (\code{FALSE} by default), a rug (1-d plot of the data) is added below the histogram-bars.}

\item{col.rug}{a R build-in color for the rug (if \code{add.rug = TRUE}).}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
A histogram with an additional color stripe based on a kernel density estimate.
}
\examples{
x = rnorm(1000,mean = sample(c(0,3),size = 1000,prob = c(0.4,0.6),replace = TRUE))
heathist(x,xlab="x",add.density=TRUE,col.rug="darkred")

heathist(x,xlab="x",colpal = "matlablike")
}
\seealso{
\code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{histogram}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.heatscatter.R
\name{heatscatterpoints}
\alias{heatscatterpoints}
\alias{LSD.heatscatterpoints}
\title{A colored scatterplot based on a two-dimensional Kernel Density Estimation (add to an existing plot)}
\usage{
heatscatterpoints(
  x,
  y,
  pch = 19,
  cexplot = 0.5,
  nrcol = 30,
  grid = 100,
  colpal = "heat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  rev = FALSE,
  xlim = NULL,
  ylim = NULL,
  only = "none",
  add.contour = FALSE,
  nlevels = 10,
  color.contour = "black",
  greyscale = FALSE,
  log = "",
  ...
)
}
\arguments{
\item{x}{a numeric vector.}

\item{y}{a numeric vector.}

\item{pch}{plotting 'character'. This can either be a single character or an integer code for one of a set of graphics symbols. (see '?pch', to be passed to plot).}

\item{cexplot}{a numerical value giving the amount by which the points should be magnified relative to the default.}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).}

\item{grid}{an integer specifying the size of the grid used for the KDE.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{only}{a character string which contains 'x' if the density should only be computed for the x axis, 'y' for the y axis (defaults to 'none' for the two-dimensional case).}

\item{add.contour}{logical: if \code{TRUE} (\code{FALSE} by default), the contour lines are added to the plot.}

\item{nlevels}{an integer giving the number of levels of the contour lines.}

\item{color.contour}{R build-in color for the contour lines.}

\item{greyscale}{logical: if \code{TRUE} (\code{FALSE} by default), the used colorpalette is converted to greyscales.}

\item{log}{a character string which contains "x" if the x axis is to be logarithmic, "y" if the y axis is to be logarithmic and "xy" or "yx" if both axes are to be logarithmic.}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Visualize two dimensional data in a three dimensional fashion facilitating a color encoded Kernel Density Estimation (add to an existing plot).
}
\note{
Two-Dimensional Kernel Density Estimation adapted and modified from Venables and Ripley's MASS package (see reference).
}
\examples{
points = 10^4
x = c(rnorm(points/2),rnorm(points/2)+4)
y = x + rnorm(points,sd=0.8)
x = sign(x)*abs(x)^1.3

plot.new()
plot.window(xlim = c(-5,15),ylim = c(-4,8))
heatscatterpoints(x,y,add.contour=TRUE,color.contour="green",greyscale=TRUE)
axis(1)
axis(2)
box()
}
\references{
Venables, W. N. and Ripley, B. D. (2002) \emph{Modern Applied Statistics with S.} Fourth edition. Springer.
}
\seealso{
\code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{heatcolors}
\keyword{scatterplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.heatscatter.R
\name{heatpairs}
\alias{heatpairs}
\alias{LSD.heatpairs}
\title{Pairwise colored scatterplot based on a two-dimensional Kernel Density Estimation}
\usage{
heatpairs(
  mat,
  main = "heatpairs",
  xlim = NULL,
  ylim = NULL,
  labels = NULL,
  add.points = FALSE,
  group = NULL,
  color.group = "magenta",
  method = "spearman",
  colpal = "heat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  rev = FALSE,
  pch = 19,
  cexplot = 0.5,
  cor.cex = 2.5,
  nrcol = 30,
  grid = 100,
  only = "none",
  add.contour = FALSE,
  nlevels = 10,
  color.contour = "black",
  greyscale = FALSE,
  log = "",
  ...
)
}
\arguments{
\item{mat}{a matrix with numerical entries.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{labels}{a character vector giving the labels to be shown on the diagonal.}

\item{add.points}{logical: if \code{TRUE} (\code{FALSE} by default), a certain 'group' of points can be colored in all pairwise plots.}

\item{group}{indices or rownames of 'mat' to be highlighted in all pairwise plots (not necessarily all).}

\item{color.group}{R build-in color in which the 'group' of points should be highlighted.}

\item{method}{a character specifying the correlation method to use ('spearman' (default), 'pearson' or 'kendall').}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{pch}{plotting 'character'. This can either be a single character or an integer code for one of a set of graphics symbols. (see '?pch', to be passed to plot).}

\item{cexplot}{a numerical value giving the amount by which the points should be magnified relative to the default.}

\item{cor.cex}{a numerical value giving the amount by which the correlation characters should be magnified relative to the default.}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).}

\item{grid}{an integer specifying the size of the grid used for the KDE.}

\item{only}{a character string which contains 'x' if the density should only be computed for the x axis, 'y' for the y axis (defaults to 'none' for the two-dimensional case).}

\item{add.contour}{logical: if \code{TRUE} (\code{FALSE} by default), the contour lines are added to the plot.}

\item{nlevels}{an integer giving the number of levels of the contour lines.}

\item{color.contour}{R build-in color for the contour lines.}

\item{greyscale}{logical: if \code{TRUE} (\code{FALSE} by default), the used colorpalette is converted to greyscales.}

\item{log}{a character string which contains "x" if the x axis is to be logarithmic, "y" if the y axis is to be logarithmic and "xy" or "yx" if both axes are to be logarithmic.}

\item{...}{additional parameters to be passed to points and plot}
}
\description{
Pairwise visualization of two dimensional data in a three dimensional fashion facilitating a color encoded Kernel Density Estimation.
}
\examples{
points = 10^4
x = rnorm(points/2)
x = c(x,x+2.5)
y = x + rnorm(points,sd=0.75)
x = sign(x)*abs(x)^1.3
mat = cbind(x,y,x + rnorm(points,sd=0.5))
colnames(mat) = c("x","y","z")
rownames(mat) = 1:nrow(mat)

heatpairs(mat,labels=c(expression(Xi),expression(Lambda),expression(Delta)))
}
\seealso{
\code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{heatcolors}
\keyword{scatterplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.intersphere.R
\name{intersphere}
\alias{intersphere}
\alias{LSD.intersphere}
\title{Intersphere: a fancy Venn diagram}
\usage{
intersphere(
  data,
  colors = NULL,
  alpha = 25,
  cex = 1,
  expand.circles = 1,
  expand.lims = 1.5,
  main = "intersphere: overlap diagram",
  onlySets = seq(length(data), 2, by = -1)
)
}
\arguments{
\item{data}{a list with n entries having elements that can be represented as sets (have union and intersect methods).}

\item{colors}{a character vector of  R build-in colors for circles representing different sets.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{cex}{a numeric value giving the character expansion factor for intersect size text inside each circle.}

\item{expand.circles}{a numeric value giving the expansion factor of circles (multiplicative).}

\item{expand.lims}{a numeric value giving the expansion of x and y limits (additive).}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{onlySets}{vectors, which n-overlaps should be shown, default to all 1 < n < length(data).}
}
\description{
Create circles for visualizing overlaps between up to 4 datasets.
}
\examples{
data = list(
	"A" = sample(1:200,100),
	"B" = sample(1:200,150),
	"C" = sample(1:200,50))

intersphere(data,colors = c("orange","skyblue","green"))

data = list(
	"A" = sample(1:200,100),
	"B" = sample(1:200,150),
	"C" = sample(1:200,50),
	"D" = sample(1:200,75))

colors = c("orange","skyblue","green","purple")
intersphere(data,colors,expand.circles = 0.5,expand.lims = 0.5)
}
\seealso{
\code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Sebastian Duemcke, Bjoern Schwalb
}
\keyword{Venn}
\keyword{intersphere}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.color.r
\name{convertgrey}
\alias{convertgrey}
\alias{LSD.convertgrey}
\title{Convert R colors to greyscale}
\usage{
convertgrey(cols, alpha = NULL)
}
\arguments{
\item{cols}{a character vector containing R built-in colors.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}
}
\value{
\code{convertgrey} returns a vector containing R built-in colors in hexadecimal representation.
}
\description{
Greyscale R built-in colors.
}
\examples{
convertgrey(c("red","green","blue"))
}
\seealso{
\code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
}
\author{
Bjoern Schwalb
}
\keyword{color}
\keyword{greyscale}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.color.r
\name{colorpalette}
\alias{colorpalette}
\alias{LSD.colorpalette}
\title{Provides colorpalettes containing R built-in colors}
\usage{
colorpalette(
  colpal,
  nrcol = NULL,
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  rev = FALSE
)
}
\arguments{
\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to length of \code{colpal}, if not specified).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is returned to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is returned to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is returned.}
}
\value{
\code{colorpalette} returns a vector containing R built-in colors in hexadecimal representation.
}
\description{
Provides pre-designed colorpalettes (character vectors containing R built-in colors) of this and several other R packages (grDevices, RColorBrewer, colorRamps) as well as custom-made ones.
}
\examples{
colorpalette("heat")
colorpalette(c("darkred","grey","darkblue"),10)
}
\seealso{
\code{\link{disco}}, \code{\link{demotour}}
}
\author{
Achim Tresch, Bjoern Schwalb
}
\keyword{alpha}
\keyword{color}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.linesplot.r
\name{linesplot}
\alias{linesplot}
\alias{LSD.linesplot}
\title{One-dimensional scatterplot}
\usage{
linesplot(
  x,
  labels = NULL,
  col = "black",
  cols = NULL,
  alpha = 25,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = "",
  las = 1,
  outline = TRUE,
  cexbox = 0.6,
  addboxes = FALSE,
  border = "black",
  range = 1.5,
  lwd = 1.5,
  main = "LSD.linesplot",
  ...
)
}
\arguments{
\item{x}{numeric data as vector, matrix, list or data.frame.}

\item{labels}{a character vector of labels.}

\item{col}{a R build-in color.}

\item{cols}{a character vector of R build-in colors.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{xlab}{x label, standard graphics parameter.}

\item{ylab}{y label, standard graphics parameter.}

\item{las}{las=1: horizontal text, las=2: vertical text (x-axis labels).}

\item{outline}{logical: if \code{TRUE} (by default), outliers are plotted.}

\item{cexbox}{a numerical value giving the amount by which the boxes should be magnified relative to the default.}

\item{addboxes}{logical: if \code{TRUE} (\code{FALSE} by default), boxplots be added to the plot.}

\item{border}{a R build-in color for the box and the whiskers (if \code{addboxes = TRUE}).}

\item{range}{this determines how far the plot whiskers extend out from the box.}

\item{lwd}{linewidth of the box and whiskers.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Visualize one-dimensional data in its every detail.
}
\examples{
l = list()
for (i in 1:10){l[[i]] = rnorm(100,sqrt(i^2.5),1+i/2)}

linesplot(l,alpha=25,border="darkred",addboxes = TRUE,outline=FALSE)
}
\seealso{
\code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{boxplotlike}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.fusionplot.R
\name{singlefusionplot}
\alias{singlefusionplot}
\alias{LSD.singlefusionplot}
\title{Visualize two-dimensional data clusters (add to an existing plot)}
\usage{
singlefusionplot(
  x,
  y,
  fromto = c(0.05, 0.95),
  colpal = "standardheat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  nrcol = 25,
  outer.col = "grey",
  rev = FALSE,
  alpha = NULL,
  quartiles.col = c("grey", "black", "grey"),
  add.quartiles = TRUE
)
}
\arguments{
\item{x}{a numeric vector.}

\item{y}{a numeric vector.}

\item{fromto}{a numeric vector containing the range of quantiles (between 0 and 1) to be plotted.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 25, if not specified).}

\item{outer.col}{R built-in color to be used for outlier lines (lines outside of 'fromto').}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{quartiles.col}{a character vector containing three R built-in colors for quartile lines (c('0.25','0.5','0.75')).}

\item{add.quartiles}{logical: if \code{TRUE} (by default), lines are plotted corresponding to the quartiles.}
}
\description{
Depict a numeric matrix or list utilizing the underlying distribution quantiles of one dimension in a color encoded fashion (add to an existing plot).
}
\examples{
x = 1:1000/300
y = rnorm(1000)+sin(2*x)*3

emptyplot(xlim = range(x),ylim = range(y))
singlefusionplot(x,y,colpal = "ylgnbu")
axis(1)
axis(2)
box()
}
\seealso{
\code{\link{fusionplot}}, \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Achim Tresch, Bjoern Schwalb
}
\keyword{cluster}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.clusterplot.R
\name{singleclusterplot}
\alias{singleclusterplot}
\alias{LSD.singleclusterplot}
\title{Visualize two-dimensional data clusters (add to an existing plot)}
\usage{
singleclusterplot(
  input,
  at = NULL,
  fromto = c(0.05, 0.95),
  colpal = "standardheat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  nrcol = 25,
  outer.col = "lightgrey",
  rev = FALSE,
  alpha = NULL,
  quartiles.col = c("grey", "black", "grey"),
  add.quartiles = TRUE
)
}
\arguments{
\item{input}{matrix or list with numerical entries.}

\item{at}{a integer vector containing the x-positions corresponding to the columns of 'input'.}

\item{fromto}{a numeric vector containing the range of quantiles (between 0 and 1) to be plotted.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 25, if not specified).}

\item{outer.col}{R built-in color to be used for outlier lines (lines outside of 'fromto').}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{quartiles.col}{a character vector containing three R built-in colors for quartile lines (c('0.25','0.5','0.75')).}

\item{add.quartiles}{logical: if \code{TRUE} (by default), lines are plotted corresponding to the quartiles.}
}
\description{
Depict a numeric matrix or list utilizing the underlying distribution quantiles of one dimension in a color encoded fashion (add to an existing plot).
}
\examples{
samples = 100
probes = 200
clus = matrix(rnorm(probes*samples,sd=1),ncol=probes)

clus = rbind(
	t(t(clus)+sin(1:probes/10))+1:nrow(clus)/samples,
	t(t(clus)+sin(pi/2+1:probes/10))+1:nrow(clus)/samples)

emptyplot(xlim = c(1,ncol(clus)),ylim = range(clus))
singleclusterplot(clus)
axis(1)
axis(2)
box()
}
\seealso{
\code{\link{clusterplot}}, \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Achim Tresch, Bjoern Schwalb
}
\keyword{cluster}

\name{homer}
\docType{data}
\alias{homer}
\title{homer}
\description{Homer Simpson as a list!}
\usage{homer}
\format{This list contains 31 character vectors of length 22 encoding Homer Simpson.}
\keyword{dataset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.color.r
\name{daltonize}
\alias{daltonize}
\alias{LSD.daltonize}
\title{Dichromat vision simulation for colorpalettes}
\usage{
daltonize(colpal, cvd = "p", show = TRUE)
}
\arguments{
\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{show}{logical: if \code{TRUE} (by default), the resulting colorpalettes are depicted in an R plot.}
}
\value{
\code{daltonize} returns a list, where each entry is a vector containing R built-in colors in hexadecimal representation: \item{simulated}{vector of simulated colors} \item{enhanced}{vector of enhanced colors}
}
\description{
Dichromat vision simulation and enhancement according to \url{http://www.daltonize.org}.
}
\examples{
daltonize("heat",cvd = "d")
daltonize("colorblind",cvd = "p")
}
\references{
\url{http://www.daltonize.org}
}
\seealso{
\code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
}
\author{
Bjoern Schwalb
}
\keyword{colorblind}
\keyword{daltonize}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.clusterplot.R
\name{clusterplot}
\alias{clusterplot}
\alias{LSD.clusterplot}
\title{Visualize two-dimensional data clusters}
\usage{
clusterplot(
  input,
  label = NULL,
  at = NULL,
  main = NULL,
  xlim = NULL,
  ylim = NULL,
  xlabels = NULL,
  fromto = c(0.05, 0.95),
  colpal = "standardheat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  nrcol = 25,
  outer.col = "lightgrey",
  quartiles.col = c("grey", "black", "grey"),
  add.quartiles = TRUE,
  separate = TRUE,
  rev = FALSE,
  size = TRUE,
  alpha = NULL,
  axes = TRUE,
  ...
)
}
\arguments{
\item{input}{matrix or list with numerical entries.}

\item{label}{a character vector assigning rows/elements of 'input' to clusters (if specified, multiple clusters can be depicted in different colors and/or subsequent plots).}

\item{at}{a integer vector containing the x-positions corresponding to the columns of 'input'.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{xlabels}{a character vector containing labels for the x-axis.}

\item{fromto}{a numeric vector containing the range of quantiles (between 0 and 1) to be plotted.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 25, if not specified).}

\item{outer.col}{R built-in color to be used for outlier lines (lines outside of 'fromto').}

\item{quartiles.col}{a character vector containing three R built-in colors for quartile lines (c('0.25','0.5','0.75')).}

\item{add.quartiles}{logical: if \code{TRUE} (by default), lines are plotted corresponding to the quartiles.}

\item{separate}{if \code{TRUE} (by default), different clusters are depicted in subsequent plots.}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{size}{logical: if \code{TRUE} (by default), the size of each cluster is added to the title of the respective plot.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{axes}{logical: if \code{TRUE} (by default), a box and axes are added to the plot (if \code{FALSE}, custom specification of axes can be achieved via basic R graphics functions).}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Depict a numeric matrix or list utilizing the underlying distribution quantiles of one dimension in a color encoded fashion.
}
\examples{
samples = 100
probes = 75
at = 1:probes
clus = matrix(rnorm(probes*samples,sd=1),ncol=probes)

clus = rbind(
	t(t(clus)+sin(1:probes/10))+1:nrow(clus)/samples,
	t(t(clus)+sin(pi/2+1:probes/10))+1:nrow(clus)/samples)

quartiles.col = c("transparent","black","transparent")
colpal = c("standardheat","crazyblue","crazyred","crazygreen")

labs = paste("cluster",kmeans(clus,4)$cluster)
clusterplot(clus,fromto=c(0,1))

clusterplot(clus,labs,separate=FALSE,xaxt="n",fromto=c(0.4,0.6),colpal=colpal,
	outer.col="none",ylim=c(-2,3),quartiles.col = quartiles.col)
 
clusterplot(clus,labs,colpal=colpal)

labs = paste("cluster",kmeans(clus,2)$cluster)
colpal = c("greens","purples")
clusterplot(clus,labs,separate=FALSE,xaxt="n",fromto=c(0.3,0.7),colpal=colpal,
	outer.col="none",ylim=c(-1,2),alpha=50,quartiles.col = quartiles.col)
}
\seealso{
\code{\link{singleclusterplot}}, \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Achim Tresch, Bjoern Schwalb
}
\keyword{cluster}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.utilities.R
\name{emptyplot}
\alias{emptyplot}
\alias{LSD.emptyplot}
\title{Wrapper function for an empty graphics device}
\usage{
emptyplot(xlim = c(-1, 1), ylim = c(-1, 1), ...)
}
\arguments{
\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Calls an empty graphics device with a coordinate system of choice.
}
\examples{
emptyplot()
}
\seealso{
\code{\link{demotour}}
}
\author{
Bjoern Schwalb
}
\keyword{empty}
\keyword{plotting}
\keyword{region}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.makemovie.R
\name{makemovie}
\alias{makemovie}
\alias{LSD.makemovie}
\title{Interpolate rows of a matrix to extend the number of cols}
\usage{
makemovie(input, timepoints = NULL, timestep = 1, motionline = NULL)
}
\arguments{
\item{input}{a matrix with numerical entries.}

\item{timepoints}{a integer vector containing the timepoints corresponding to the columns of 'input'.}

\item{timestep}{a non-negative integer specifying the number of timesteps between the existing timepoints (defaults to \code{1}, if not specified).}

\item{motionline}{a integer vector giving the timepoints of the resulting matrix (derived from timepoints and timesteps by default).}
}
\description{
Interpolate rows of a matrix to yield a smooth transitions.
}
\examples{
len = 10
x = sin(seq(0,2*pi,length=len*2))
fun = function(){n=sample(1:len,1);return(x[n:(n+len-1)])}
input = t(replicate(7,fun(),simplify=TRUE))
input = input + rnorm(length(input))/2
par(mfrow=c(1,2))
plotmatrix(input,main="original",cols=1:7,type="o")
mov = makemovie(input,timestep=0.2)
plotmatrix(mov,main="interpolated",cols=1:7,type="o")
}
\seealso{
\code{\link{clusterplot}}, \code{\link{align}}, \code{\link{demotour}}
}
\author{
Achim Tresch, Bjoern Schwalb
}
\keyword{matrix}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.heatboxplot.R
\name{heatboxplot}
\alias{heatboxplot}
\alias{LSD.heatboxplot}
\title{Heatboxplot: a colored boxplot}
\usage{
heatboxplot(
  x,
  horizontal = FALSE,
  add = FALSE,
  colpal = "standard",
  rev = FALSE,
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  colpals = NULL,
  nrcol = 75,
  lwd = 1.75,
  axes = TRUE,
  labels = NULL,
  xlim = NULL,
  ylim = NULL,
  xlab = NULL,
  ylab = "",
  main = "heatboxplot",
  nolab = FALSE,
  outline = TRUE,
  boxonly = FALSE,
  adjust = 1,
  quant.from = 0.25,
  quant.to = 0.75,
  range = 1.5,
  border = "black",
  plot.boxplot = TRUE,
  add.quartiles = TRUE,
  add.box = FALSE,
  n.density = 1024,
  cexbox = 0.6,
  ...
)
}
\arguments{
\item{x}{data as vector, matrix, list or data.frame.}

\item{horizontal}{logical: if \code{TRUE} (\code{FALSE} by default), rotation of 90 degrees is applied.}

\item{add}{logical: if \code{TRUE} (\code{FALSE} by default), the boxplot is added to an existing plot.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{colpals}{a character vector containing names of \code{LSD} colorpalettes (see disco() or \code{\link{disco}}).}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).}

\item{lwd}{linewidth of the box and whiskers.}

\item{axes}{logical: if \code{TRUE} (by default), the axes are plotted.}

\item{labels}{a character vector of labels.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{xlab}{x label, standard graphics parameter.}

\item{ylab}{y label, standard graphics parameter.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{nolab}{logical: if \code{TRUE} (\code{FALSE} by default), the title and ylab are suppressed.}

\item{outline}{logical: if \code{TRUE} (by default), outliers are plotted.}

\item{boxonly}{logical: if \code{TRUE} (\code{FALSE} by default), the density is only be plotted in the box.}

\item{adjust}{a numeric value giving the scaling factor for the used bandwidth (defaults to 1).}

\item{quant.from}{a numeric value (between 0 and 1) giving the quantile from which the density lane should be plotted.}

\item{quant.to}{a numeric value (between 0 and 1) giving the quantile to which the density lane should be plotted.}

\item{range}{a numeric value to determine how far the plot whiskers extend out from the box.}

\item{border}{an R build-in color for the box and whiskers.}

\item{plot.boxplot}{logical: if \code{TRUE} (by default), the boxplot is added to the density.}

\item{add.quartiles}{if \code{TRUE} (\code{FALSE} by default), only the box of the boxplot is added (if \code{plot.boxplot = FALSE}).}

\item{add.box}{logical: if \code{TRUE} (by default), the box is added to the plot.}

\item{n.density}{an integer specifying the number of equally spaced points at which the density is to be estimated.}

\item{cexbox}{a numerical value giving the amount by which the boxes should be magnified relative to the default.}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
A boxplot with an additional color stripe based on a kernel density estimate.
}
\examples{
f = c(rnorm(200),rnorm(200)+4)
h = rf(500,15,15)*10
g = rnorm(300)+1

heatboxplot(h)

heatboxplot(list(f=f,g=g),colpals=c("rdpu","greens"),labels=c("bimodal","unimodal"))
}
\seealso{
\code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{boxplot}

\name{seqs}
\docType{data}
\alias{seqs}
\title{seqs}
\description{TATAbox containing DNA-sequences!}
\usage{seqs}
\format{This list contains 20 character vectors of TATAbox containing DNA-sequences of length 30.}
\keyword{dataset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.fusionplot.R
\name{fusionplot}
\alias{fusionplot}
\alias{LSD.fusionplot}
\title{Visualize two-dimensional data clusters}
\usage{
fusionplot(
  x,
  y,
  label = NULL,
  main = NULL,
  xlim = NULL,
  ylim = NULL,
  fromto = c(0.05, 0.95),
  colpal = "standardheat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  nrcol = 25,
  outer.col = "lightgrey",
  quartiles.col = c("grey", "black", "grey"),
  add.quartiles = TRUE,
  separate = TRUE,
  rev = FALSE,
  size = TRUE,
  alpha = NULL,
  axes = TRUE,
  ...
)
}
\arguments{
\item{x}{a numeric vector.}

\item{y}{a numeric vector.}

\item{label}{a character vector assigning rows/elements of 'input' to clusters (if specified, multiple clusters can be depicted in different colors and/or subsequent plots).}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{fromto}{a numeric vector containing the range of quantiles (between 0 and 1) to be plotted.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 25, if not specified).}

\item{outer.col}{R built-in color to be used for outlier lines (lines outside of 'fromto').}

\item{quartiles.col}{a character vector containing three R built-in colors for quartile lines (c('0.25','0.5','0.75')).}

\item{add.quartiles}{logical: if \code{TRUE} (by default), lines are plotted corresponding to the quartiles.}

\item{separate}{if \code{TRUE} (by default), different clusters are depicted in subsequent plots.}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{size}{logical: if \code{TRUE} (by default), the size of each cluster is added to the title of the respective plot.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{axes}{logical: if \code{TRUE} (by default), a box and axes are added to the plot (if \code{FALSE}, custom specification of axes can be achieved via basic R graphics functions).}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Depict a numeric matrix or list utilizing the underlying distribution quantiles of one dimension in a color encoded fashion.
}
\examples{
nr = 750
x = 1:nr/300
y = c(rnorm(nr)+sin(2*x)*3,rnorm(nr)+sin(2*x+pi/2)*3)
x = c(x,x)

labs = paste("cluster",c(rep(c(1,2),each = nr)))
colpals = c("oranges","pubu")
qcol = c("transparent","black","transparent")
fusionplot(x,y,labs,separate=FALSE,colpal=colpals,alpha=75,quartiles.col = qcol)
}
\seealso{
\code{\link{singlefusionplot}}, \code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Achim Tresch, Bjoern Schwalb
}
\keyword{cluster}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.color.r
\name{distinctcolors}
\alias{distinctcolors}
\alias{LSD.distinctcolors}
\title{Find preferably distinct R built-in colors}
\usage{
distinctcolors(
  nrcol = 10,
  method = "RGB",
  bw = FALSE,
  show = TRUE,
  simulate = TRUE
)
}
\arguments{
\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to the length of \code{10}, if not specified).}

\item{method}{character string implying the method for color selection to be used ("RGB" uses a grid in the RGB space (default), "Lab" uses a grid in the Lab space, "goldenratio" uses the golden ratio as spacing between colors in the HSV color space).}

\item{bw}{logical: if \code{TRUE} (\code{FALSE} by default), the colors "black" and "white" are removed from the resulting colorpalette.}

\item{show}{logical: if \code{TRUE} (by default), the resulting colorpalettes are depicted in an R plot.}

\item{simulate}{logical: if \code{TRUE} (by default), a converted colorpalettes are additionally depicted to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}
}
\value{
\code{distinctcolors} returns a vector containing R built-in colors in hexadecimal representation.
}
\description{
Find a vector of distinct R built-in colors for a pre-defined length ('nrcol').
}
\examples{
distinctcolors()
}
\seealso{
\code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
}
\author{
Bjoern Schwalb
}
\keyword{color}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.demotour.R
\name{demotour}
\alias{demotour}
\alias{LSD.demotour}
\title{LSD teaser}
\usage{
demotour()
}
\description{
A compilation of selected plot examples.
}
\examples{
demotour()
}
\seealso{
\code{\link{heatscatter}}, \code{\link{clusterplot}}, \code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{daltonize}}
}
\author{
Bjoern Schwalb
}
\keyword{clusterplot}
\keyword{colorpalette}
\keyword{daltonize}
\keyword{disco}
\keyword{heatscatter}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.color.r
\name{complementarycolor}
\alias{complementarycolor}
\alias{LSD.complementarycolor}
\title{Complement R colors}
\usage{
complementarycolor(cols, alpha = NULL)
}
\arguments{
\item{cols}{a character vector containing R built-in colors.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}
}
\value{
\code{complementarycolor} returns a vector containing R built-in colors in hexadecimal representation.
}
\description{
Convert R built-in colors to their color complement
}
\examples{
complementarycolor(c("red","green","blue"))
}
\seealso{
\code{\link{disco}}, \code{\link{colorpalette}}, \code{\link{demotour}}
}
\author{
Bjoern Schwalb
}
\keyword{color}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.utilities.R
\name{webdesign}
\alias{webdesign}
\alias{LSD.webdesign}
\title{Colored rectangular grid}
\usage{
webdesign(xlim, ylim, colpal = "rdbu", xlabels = NULL, ylabels = NULL, ...)
}
\arguments{
\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{xlabels}{a character vector containing labels depicted parallel to the x-axis.}

\item{ylabels}{a character vector containing labels depicted parallel to the y-axis.}

\item{...}{additional parameters to be passed to abline().}
}
\description{
Adds a colored rectangular grid to an existing plot.
}
\examples{
emptyplot(c(-5,5),c(-5,5))
labels = c("2 fold","4 fold","8 fold")
webdesign(c(-5,5),c(-5,5),lty = 2,xlabels = labels,ylabels = labels)
}
\seealso{
\code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{grid}
\keyword{web}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.comparisonplot.r
\name{heatbarplot}
\alias{heatbarplot}
\alias{LSD.heatbarplot}
\title{Color a barplot.}
\usage{
heatbarplot(
  x,
  colpal = "heat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  rev = FALSE,
  horizontal = FALSE,
  nrcol = 100,
  ...
)
}
\arguments{
\item{x}{a histogram object.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{horizontal}{logical: if \code{TRUE} (\code{FALSE} by default), rotation of 90 degrees is applied.}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Depict a histogram object as a barplot in a color encoded fashion based on a kernel density estimate.
}
\examples{
points = 10^4
x = c(rnorm(points/2),rnorm(points/2)+4)
x = sign(x)*abs(x)^1.3
xhist = hist(x,plot = FALSE)

heatbarplot(xhist)
}
\seealso{
\code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{barplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.heatboxplot.R
\name{densitylane}
\alias{densitylane}
\alias{LSD.densitylane}
\title{Visualize a density in a rectangular fashion}
\usage{
densitylane(
  x,
  y,
  pos = 1,
  width = 0.4,
  colpal = "standard",
  rev = FALSE,
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  horizontal = horizontal,
  nrcol = 75
)
}
\arguments{
\item{x}{density$x values of a density object.}

\item{y}{density$y values of a density object.}

\item{pos}{the x co-ordinate of the lane (mid point).}

\item{width}{a numeric value giving the width of the lane.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}) (defaults to "heat", if not specified).}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{horizontal}{logical: if \code{TRUE} (\code{FALSE} by default), rotation of 90 degrees is applied.}

\item{nrcol}{a non-negative integer specifying the number of colors to be used (defaults to 100, if not specified).}
}
\description{
Add a color stripe to an existing plot based on a kernel density estimate.
}
\seealso{
\code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{density}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.msdplot.r
\name{msdplot}
\alias{msdplot}
\alias{LSD.msdplot}
\title{Visualize two-dimensional data clusters}
\usage{
msdplot(
  input,
  label = NULL,
  at = NULL,
  xlim = NULL,
  ylim = NULL,
  xlab = "",
  ylab = "",
  main = "msdplot",
  xaxt = "s",
  xlabels = NULL,
  las = 1,
  separate = TRUE,
  size = TRUE,
  col = "darkgreen",
  bars = TRUE,
  alpha = 50,
  ...
)
}
\arguments{
\item{input}{matrix or list with numerical entries, quantiles of cols will define lines.}

\item{label}{a character vector assigning rows/elements of 'input' to clusters (if specified, multiple clusters can be depicted in different colors and/or subsequent plots).}

\item{at}{a integer vector containing the x-positions corresponding to the columns of 'input'.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{xlab}{x labels, standard graphics parameter.}

\item{ylab}{y labels, standard graphics parameter.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{xaxt}{a character which specifies the x axis type ("n" suppresses plotting of the axis).}

\item{xlabels}{a character vector containing labels for the x-axis.}

\item{las}{las=1: horizontal text, las=2: vertical text (x-axis labels).}

\item{separate}{if \code{TRUE} (by default), different clusters are depicted in subsequent plots.}

\item{size}{logical: if \code{TRUE} (by default), the size of each cluster is added to the title of the respective plot.}

\item{col}{a character vector giving R build-in colors for different clusters.}

\item{bars}{logical: if \code{TRUE} (by default), error bars are added at each position.}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
Depict a numeric matrix or list utilizing the underlying mean and standard deviation estimates of one dimension in a color encoded fashion.
}
\examples{
at = c(2,4,8,16,32)
clus = matrix(rnorm(500,sd=0.5),ncol=5)
batch = sample(c(-8,-6,-4,-2),100,replace=TRUE)
clus = clus + cbind(0,0.25*batch,0.5*batch,0.75*batch,batch)
clus = clus - clus[,1]
clus = t(t(clus)*c(0,0.1,0.25,0.5,1))
labs = paste("cluster",kmeans(clus,4)$cluster)

colpal = c("darkgreen","darkblue","darkred","black")
msdplot(clus,labs,at,separate=FALSE,col=colpal,alpha=25,xlabels=at)

msdplot(clus,labs,at,col=colpal,alpha=50,xlabels=at)
}
\seealso{
\code{\link{comparisonplot}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{mean}
\keyword{sd}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LSD.comparisonplot.r
\name{comparisonplot}
\alias{comparisonplot}
\alias{cplot}
\title{Comparisonplot: a fancy scatterplot}
\usage{
comparisonplot(
  x,
  y,
  histbreaks = 30,
  adjust = 1,
  colpal = "heat",
  simulate = FALSE,
  daltonize = FALSE,
  cvd = "p",
  alpha = NULL,
  rev = FALSE,
  main = "comparisonplot",
  cor = FALSE,
  xlab = NULL,
  ylab = NULL,
  xlim = NULL,
  ylim = NULL,
  ab = FALSE,
  add.density = FALSE,
  col.density = "darkred",
  pimp = FALSE,
  ...
)
}
\arguments{
\item{x}{a numeric vector.}

\item{y}{a numeric vector.}

\item{histbreaks}{a non-negative integer specifying the number of breaks of the histograms.}

\item{adjust}{scale the used bandwidth of the density estimate, if \code{add.density = TRUE}.}

\item{colpal}{a character vector containing R built-in color names or a name of a \code{LSD} colorpalette as a character string (see disco() or \code{\link{disco}}).}

\item{simulate}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to simulate dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{daltonize}{logical: if \code{TRUE} (\code{FALSE} by default), a converted colorpalette is used to enhance dichromat vision according to \url{http://www.daltonize.org} (see \code{\link{daltonize}}).}

\item{cvd}{character string implying the type of color vision deficiency ("p" for protanope, "d" for deuteranope or "t" for tritanope).}

\item{alpha}{alpha value: a two-digit integer between 01 and 99 for color opacity, i.e. appearance of partial or full transparency (usage omitted by default).}

\item{rev}{logical: if \code{TRUE} (\code{FALSE} by default), a reversed colorpalette is used.}

\item{main}{title(s) of the plot, standard graphics parameter.}

\item{cor}{if \code{TRUE} (\code{FALSE} by default), the correlation is added to the title.}

\item{xlab}{x label, standard graphics parameter.}

\item{ylab}{y label, standard graphics parameter.}

\item{xlim}{x limits, standard graphics parameter.}

\item{ylim}{y limits, standard graphics parameter.}

\item{ab}{if \code{TRUE} (\code{FALSE} by default), \code{abline(0,1)} is added to the heatscatter.}

\item{add.density}{if \code{TRUE} (\code{FALSE} by default), density lines are added to the barplots.}

\item{col.density}{R built-in color to specify the color of the density line.}

\item{pimp}{if \code{TRUE} (\code{FALSE} by default), the plot is pimped.}

\item{...}{additional parameters to be passed to points and plot.}
}
\description{
A function to compare two vectors extensively.
}
\examples{
points = 10^4
x = c(rnorm(points/2),rnorm(points/2)+4)
y = x + rnorm(points,sd=0.8)
x = sign(x)*abs(x)^1.3

comparisonplot(x,y,histbreaks=30,pch=20)
}
\seealso{
\code{\link{align}}, \code{\link{demotour}}, \code{\link{disco}}, \code{\link{colorpalette}}
}
\author{
Bjoern Schwalb
}
\keyword{barplot}
\keyword{scatterplot}
